"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var mol_plugin_1 = require("../../mol-plugin");
require("./index.html");
var command_1 = require("../../mol-plugin/command");
var transforms_1 = require("../../mol-plugin/state/transforms");
var representation_1 = require("../../mol-plugin/state/transforms/representation");
var color_1 = require("../../mol-util/color");
var built_in_1 = require("../../mol-plugin/state/animation/built-in");
var mol_state_1 = require("../../mol-state");
var coloring_1 = require("./coloring");
// import { BasicWrapperControls } from './controls';
var superposition_1 = require("./superposition");
require('mol-plugin/skin/light.scss');
var BasicWrapper = /** @class */ (function () {
    function BasicWrapper() {
        var _this = this;
        this.loadedParams = { url: '', format: 'cif', assemblyId: '' };
        this.animate = {
            modelIndex: {
                maxFPS: 8,
                onceForward: function () { _this.plugin.state.animation.play(built_in_1.AnimateModelIndex, { maxFPS: Math.max(0.5, _this.animate.modelIndex.maxFPS | 0), mode: { name: 'once', params: { direction: 'forward' } } }); },
                onceBackward: function () { _this.plugin.state.animation.play(built_in_1.AnimateModelIndex, { maxFPS: Math.max(0.5, _this.animate.modelIndex.maxFPS | 0), mode: { name: 'once', params: { direction: 'backward' } } }); },
                palindrome: function () { _this.plugin.state.animation.play(built_in_1.AnimateModelIndex, { maxFPS: Math.max(0.5, _this.animate.modelIndex.maxFPS | 0), mode: { name: 'palindrome', params: {} } }); },
                loop: function () { _this.plugin.state.animation.play(built_in_1.AnimateModelIndex, { maxFPS: Math.max(0.5, _this.animate.modelIndex.maxFPS | 0), mode: { name: 'loop', params: {} } }); },
                stop: function () { return _this.plugin.state.animation.stop(); }
            }
        };
        this.coloring = {
            applyStripes: function () { return __awaiter(_this, void 0, void 0, function () {
                var state, visuals, tree, colorTheme, _i, visuals_1, v;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            state = this.plugin.state.dataState;
                            visuals = state.selectQ(function (q) { return q.ofTransformer(transforms_1.StateTransforms.Representation.StructureRepresentation3D); });
                            tree = state.build();
                            colorTheme = { name: coloring_1.StripedResidues.Descriptor.name, params: this.plugin.structureRepresentation.themeCtx.colorThemeRegistry.get(coloring_1.StripedResidues.Descriptor.name).defaultValues };
                            for (_i = 0, visuals_1 = visuals; _i < visuals_1.length; _i++) {
                                v = visuals_1[_i];
                                tree.to(v).update(function (old) { return (__assign({}, old, { colorTheme: colorTheme })); });
                            }
                            return [4 /*yield*/, command_1.PluginCommands.State.Update.dispatch(this.plugin, { state: state, tree: tree })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); }
        };
        this.tests = {
            staticSuperposition: function () { return __awaiter(_this, void 0, void 0, function () {
                var state, tree;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            state = this.plugin.state.dataState;
                            tree = superposition_1.buildStaticSuperposition(this.plugin, superposition_1.StaticSuperpositionTestData);
                            return [4 /*yield*/, command_1.PluginCommands.State.RemoveObject.dispatch(this.plugin, { state: state, ref: mol_state_1.StateTransform.RootRef })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, command_1.PluginCommands.State.Update.dispatch(this.plugin, { state: state, tree: tree })];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); },
            dynamicSuperposition: function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, command_1.PluginCommands.State.RemoveObject.dispatch(this.plugin, { state: this.plugin.state.dataState, ref: mol_state_1.StateTransform.RootRef })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, superposition_1.dynamicSuperpositionTest(this.plugin, ['1tqn', '2hhb', '4hhb'], 'HEM')];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); }
        };
    }
    BasicWrapper.prototype.init = function (target) {
        this.plugin = mol_plugin_1.createPlugin(typeof target === 'string' ? document.getElementById(target) : target, __assign({}, mol_plugin_1.DefaultPluginSpec, { layout: {
                initial: {
                    isExpanded: false,
                    showControls: false
                },
                controls: {
                // left: 'none',
                // right: BasicWrapperControls
                }
            } }));
        this.plugin.structureRepresentation.themeCtx.colorThemeRegistry.add(coloring_1.StripedResidues.Descriptor.name, coloring_1.StripedResidues.colorTheme);
        this.plugin.lociLabels.addProvider(coloring_1.StripedResidues.labelProvider);
        this.plugin.customModelProperties.register(coloring_1.StripedResidues.propertyProvider);
    };
    BasicWrapper.prototype.download = function (b, url) {
        return b.apply(transforms_1.StateTransforms.Data.Download, { url: url, isBinary: false });
    };
    BasicWrapper.prototype.parse = function (b, format, assemblyId) {
        var parsed = format === 'cif'
            ? b.apply(transforms_1.StateTransforms.Data.ParseCif).apply(transforms_1.StateTransforms.Model.TrajectoryFromMmCif)
            : b.apply(transforms_1.StateTransforms.Model.TrajectoryFromPDB);
        return parsed
            .apply(transforms_1.StateTransforms.Model.ModelFromTrajectory, { modelIndex: 0 })
            .apply(transforms_1.StateTransforms.Model.CustomModelProperties, { properties: [coloring_1.StripedResidues.Descriptor.name] }, { ref: 'props', state: { isGhost: false } })
            .apply(transforms_1.StateTransforms.Model.StructureAssemblyFromModel, { id: assemblyId || 'deposited' }, { ref: 'asm' });
    };
    BasicWrapper.prototype.visual = function (visualRoot) {
        visualRoot.apply(transforms_1.StateTransforms.Model.StructureComplexElement, { type: 'atomic-sequence' })
            .apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsStatic(this.plugin, 'cartoon'), { ref: 'seq-visual' });
        visualRoot.apply(transforms_1.StateTransforms.Model.StructureComplexElement, { type: 'atomic-het' })
            .apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsStatic(this.plugin, 'ball-and-stick'), { ref: 'het-visual' });
        visualRoot.apply(transforms_1.StateTransforms.Model.StructureComplexElement, { type: 'water' })
            .apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsStatic(this.plugin, 'ball-and-stick', { alpha: 0.51 }), { ref: 'water-visual' });
        visualRoot.apply(transforms_1.StateTransforms.Model.StructureComplexElement, { type: 'spheres' })
            .apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsStatic(this.plugin, 'spacefill'), { ref: 'ihm-visual' });
        return visualRoot;
    };
    BasicWrapper.prototype.load = function (_a) {
        var url = _a.url, _b = _a.format, format = _b === void 0 ? 'cif' : _b, _c = _a.assemblyId, assemblyId = _c === void 0 ? '' : _c;
        return __awaiter(this, void 0, void 0, function () {
            var loadType, state, tree;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        loadType = 'full';
                        state = this.plugin.state.dataState;
                        if (this.loadedParams.url !== url || this.loadedParams.format !== format) {
                            loadType = 'full';
                        }
                        else if (this.loadedParams.url === url) {
                            if (state.select('asm').length > 0)
                                loadType = 'update';
                        }
                        if (!(loadType === 'full')) return [3 /*break*/, 2];
                        return [4 /*yield*/, command_1.PluginCommands.State.RemoveObject.dispatch(this.plugin, { state: state, ref: state.tree.root.ref })];
                    case 1:
                        _d.sent();
                        tree = state.build();
                        this.visual(this.parse(this.download(tree.toRoot(), url), format, assemblyId));
                        return [3 /*break*/, 3];
                    case 2:
                        tree = state.build();
                        tree.to('asm').update(transforms_1.StateTransforms.Model.StructureAssemblyFromModel, function (p) { return (__assign({}, p, { id: assemblyId || 'deposited' })); });
                        _d.label = 3;
                    case 3: return [4 /*yield*/, command_1.PluginCommands.State.Update.dispatch(this.plugin, { state: this.plugin.state.dataState, tree: tree })];
                    case 4:
                        _d.sent();
                        this.loadedParams = { url: url, format: format, assemblyId: assemblyId };
                        command_1.PluginCommands.Camera.Reset.dispatch(this.plugin, {});
                        return [2 /*return*/];
                }
            });
        });
    };
    BasicWrapper.prototype.setBackground = function (color) {
        var renderer = this.plugin.canvas3d.props.renderer;
        command_1.PluginCommands.Canvas3D.SetSettings.dispatch(this.plugin, { settings: { renderer: __assign({}, renderer, { backgroundColor: color_1.Color(color) }) } });
    };
    BasicWrapper.prototype.toggleSpin = function () {
        var trackball = this.plugin.canvas3d.props.trackball;
        var spinning = trackball.spin;
        command_1.PluginCommands.Canvas3D.SetSettings.dispatch(this.plugin, { settings: { trackball: __assign({}, trackball, { spin: !trackball.spin }) } });
        if (!spinning)
            command_1.PluginCommands.Camera.Reset.dispatch(this.plugin, {});
    };
    return BasicWrapper;
}());
window.BasicMolStarWrapper = new BasicWrapper();
