"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var linear_algebra_1 = require("../../mol-math/linear-algebra");
var helpers_1 = require("./helpers");
var command_1 = require("../../mol-plugin/command");
var mol_state_1 = require("../../mol-state");
var objects_1 = require("../../mol-plugin/state/objects");
var builder_1 = require("../../mol-script/language/builder");
var compiler_1 = require("../../mol-script/runtime/query/compiler");
var structure_1 = require("../../mol-model/structure");
var superposition_1 = require("../../mol-model/structure/structure/util/superposition");
// function getAxisAngleTranslation(m: Mat4) {
//     const translation = Mat4.getTranslation(Vec3.zero(), m);
//     const axis = Vec3.zero();
//     const angle = 180 / Math.PI * Quat.getAxisAngle(axis, Mat4.getRotation(Quat.zero(), m));
//     return { translation, axis, angle };
// }
function buildStaticSuperposition(ctx, src) {
    var b = ctx.state.dataState.build().toRoot();
    for (var _i = 0, src_1 = src; _i < src_1.length; _i++) {
        var s = src_1[_i];
        helpers_1.StateHelper.visual(ctx, helpers_1.StateHelper.transform(helpers_1.StateHelper.selectChain(helpers_1.StateHelper.structure(helpers_1.StateHelper.getModel(helpers_1.StateHelper.download(b, "https://www.ebi.ac.uk/pdbe/static/entry/" + s.pdbId + "_updated.cif"), 'cif')), s.auth_asym_id), s.matrix));
    }
    return b;
}
exports.buildStaticSuperposition = buildStaticSuperposition;
exports.StaticSuperpositionTestData = [
    { pdbId: '1aj5', auth_asym_id: 'A', matrix: linear_algebra_1.Mat4.identity() },
    { pdbId: '1df0', auth_asym_id: 'B', matrix: linear_algebra_1.Mat4.ofRows([[0.406, 0.879, 0.248, -200.633],
            [0.693, -0.473, 0.544, 73.403],
            [0.596, -0.049, -0.802, -14.209],
            [0, 0, 0, 1]]) },
    { pdbId: '1dvi', auth_asym_id: 'A', matrix: linear_algebra_1.Mat4.ofRows([[-0.053, -0.077, 0.996, -45.633],
            [-0.312, 0.949, 0.057, -12.255],
            [-0.949, -0.307, -0.074, 53.562],
            [0, 0, 0, 1]]) }
];
function dynamicSuperpositionTest(ctx, src, comp_id) {
    return __awaiter(this, void 0, void 0, function () {
        var state, structures, _i, src_2, s, pivot, rest, query, xs, selections, transforms, visuals, i, root;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    state = ctx.state.dataState;
                    structures = state.build().toRoot();
                    for (_i = 0, src_2 = src; _i < src_2.length; _i++) {
                        s = src_2[_i];
                        helpers_1.StateHelper.structure(helpers_1.StateHelper.getModel(helpers_1.StateHelper.download(structures, "https://www.ebi.ac.uk/pdbe/static/entry/" + s + "_updated.cif"), 'cif'));
                    }
                    return [4 /*yield*/, command_1.PluginCommands.State.Update.dispatch(ctx, { state: state, tree: structures })];
                case 1:
                    _a.sent();
                    pivot = builder_1.MolScriptBuilder.struct.filter.first([
                        builder_1.MolScriptBuilder.struct.generator.atomGroups({
                            'residue-test': builder_1.MolScriptBuilder.core.rel.eq([builder_1.MolScriptBuilder.struct.atomProperty.macromolecular.label_comp_id(), comp_id]),
                            'group-by': builder_1.MolScriptBuilder.struct.atomProperty.macromolecular.residueKey()
                        })
                    ]);
                    rest = builder_1.MolScriptBuilder.struct.modifier.exceptBy({
                        0: builder_1.MolScriptBuilder.struct.generator.all(),
                        by: pivot
                    });
                    query = compiler_1.compile(pivot);
                    xs = state.select(mol_state_1.StateSelection.Generators.rootsOfType(objects_1.PluginStateObject.Molecule.Structure));
                    selections = xs.map(function (s) { return structure_1.StructureSelection.toLoci(query(new structure_1.QueryContext(s.obj.data))); });
                    transforms = superposition_1.superposeStructures(selections);
                    visuals = state.build();
                    siteVisual(ctx, helpers_1.StateHelper.selectSurroundingsOfFirstResidue(visuals.to(xs[0].transform.ref), 'HEM', 7), pivot, rest);
                    for (i = 1; i < selections.length; i++) {
                        root = visuals.to(xs[i].transform.ref);
                        siteVisual(ctx, helpers_1.StateHelper.transform(helpers_1.StateHelper.selectSurroundingsOfFirstResidue(root, 'HEM', 7), transforms[i - 1].bTransform), pivot, rest);
                    }
                    return [4 /*yield*/, command_1.PluginCommands.State.Update.dispatch(ctx, { state: state, tree: visuals })];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.dynamicSuperpositionTest = dynamicSuperpositionTest;
function siteVisual(ctx, b, pivot, rest) {
    helpers_1.StateHelper.ballsAndSticks(ctx, b, pivot, 'residue-name');
    helpers_1.StateHelper.ballsAndSticks(ctx, b, rest, 'uniform');
}
