"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var Rx = require("rxjs");
var api_1 = require("../../servers/model/server/api");
require("./index.html");
var Root = /** @class */ (function (_super) {
    __extends(Root, _super);
    function Root() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Root.prototype.render = function () {
        var _this = this;
        return React.createElement("div", null,
            React.createElement("div", null,
                "Query: ",
                React.createElement(QuerySelect, { state: this.props.state })),
            React.createElement("div", null,
                "ID: ",
                React.createElement("input", { type: 'text', onChange: function (t) { return _this.props.state.id.next(t.currentTarget.value); } })),
            React.createElement("div", null,
                "Params:",
                React.createElement("br", null),
                React.createElement(QueryParams, { state: this.props.state })),
            React.createElement("div", null,
                "Model numbers (empty for all): ",
                React.createElement(ModelNums, { state: this.props.state })),
            React.createElement("div", null,
                React.createElement("input", { type: 'checkbox', onChange: function (t) { return _this.props.state.isBinary.next(!!t.currentTarget.checked); } }),
                " Binary"),
            React.createElement("div", null,
                "Query string:",
                React.createElement(QueryUrl, { state: this.props.state })));
    };
    return Root;
}(React.Component));
var QuerySelect = /** @class */ (function (_super) {
    __extends(QuerySelect, _super);
    function QuerySelect() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    QuerySelect.prototype.render = function () {
        var _this = this;
        return React.createElement("select", { onChange: function (s) { return _this.props.state.query.next(api_1.QueryList[+s.currentTarget.value].definition); } }, api_1.QueryList.map(function (q, i) { return React.createElement("option", { value: i, key: i, selected: i === 1 }, q.definition.niceName); }));
    };
    return QuerySelect;
}(React.Component));
var QueryParams = /** @class */ (function (_super) {
    __extends(QueryParams, _super);
    function QueryParams() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { prms: '' };
        return _this;
    }
    QueryParams.prototype.parseParams = function (str) {
        this.setState({ prms: str });
        try {
            var params = JSON.parse(str);
            this.props.state.params.next(params);
        }
        catch (_a) {
            this.props.state.params.next({});
        }
    };
    QueryParams.prototype.componentDidMount = function () {
        var _this = this;
        this.props.state.query.subscribe(function (q) { return _this.setState({ prms: formatParams(q) }); });
    };
    QueryParams.prototype.render = function () {
        var _this = this;
        return React.createElement("textarea", { style: { height: '300px' }, value: this.state.prms, cols: 80, onChange: function (t) { return _this.parseParams(t.currentTarget.value); } });
    };
    return QueryParams;
}(React.Component));
var QueryUrl = /** @class */ (function (_super) {
    __extends(QueryUrl, _super);
    function QueryUrl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { queryString: '' };
        return _this;
    }
    QueryUrl.prototype.componentDidMount = function () {
        var _this = this;
        this.props.state.url.subscribe(function (url) { return _this.setState({ queryString: url }); });
    };
    QueryUrl.prototype.render = function () {
        return React.createElement("input", { type: 'text', value: this.state.queryString, style: { width: '800px' } });
    };
    return QueryUrl;
}(React.Component));
var ModelNums = /** @class */ (function (_super) {
    __extends(ModelNums, _super);
    function ModelNums() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModelNums.prototype.render = function () {
        var _this = this;
        return React.createElement("input", { type: 'text', defaultValue: '1', style: { width: '300px' }, onChange: function (t) {
                return _this.props.state.models.next(t.currentTarget.value.split(',')
                    .map(function (v) { return v.trim(); })
                    .filter(function (v) { return !!v; })
                    .map(function (v) { return +v; }));
            } });
    };
    return ModelNums;
}(React.Component));
var state = {
    query: new Rx.BehaviorSubject(api_1.QueryList[1].definition),
    id: new Rx.BehaviorSubject('1cbs'),
    params: new Rx.BehaviorSubject({}),
    isBinary: new Rx.BehaviorSubject(false),
    models: new Rx.BehaviorSubject([]),
    url: new Rx.Subject()
};
function formatParams(def) {
    var prms = Object.create(null);
    for (var _i = 0, _a = def.params; _i < _a.length; _i++) {
        var p = _a[_i];
        prms[p.name] = p.exampleValues ? p.exampleValues[0] : void 0;
    }
    return JSON.stringify(prms, void 0, 2);
}
function formatUrl() {
    var json = JSON.stringify({
        name: state.query.value.name,
        id: state.id.value,
        modelNums: state.models.value.length ? state.models.value : void 0,
        binary: state.isBinary.value,
        params: state.params.value
    });
    state.url.next(encodeURIComponent(json));
}
Rx.merge(state.query, state.id, state.params, state.isBinary, state.models).subscribe(function (s) { return formatUrl(); });
ReactDOM.render(React.createElement(Root, { state: state }), document.getElementById('app'));
