"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var mol_state_1 = require("../../../mol-state");
var transforms_1 = require("../../../mol-plugin/state/transforms");
var structure_1 = require("../../../mol-plugin/state/actions/structure");
var objects_1 = require("../../../mol-plugin/state/objects");
var param_definition_1 = require("../../../mol-util/param-definition");
var command_1 = require("../../../mol-plugin/command");
var linear_algebra_1 = require("../../../mol-math/linear-algebra");
var snapshots_1 = require("../../../mol-plugin/state/snapshots");
var builder_1 = require("../../../mol-script/language/builder");
var text_1 = require("../../../mol-geo/geometry/text/text");
var mol_util_1 = require("../../../mol-util");
var tables_1 = require("../../../mol-util/color/tables");
var representation_1 = require("../../../mol-plugin/state/transforms/representation");
exports.CreateJoleculeState = mol_state_1.StateAction.build({
    display: { name: 'Jolecule State Import' },
    params: { id: param_definition_1.ParamDefinition.Text('1mbo') },
    from: objects_1.PluginStateObject.Root
})(function (_a, plugin) {
    var ref = _a.ref, state = _a.state, params = _a.params;
    return __awaiter(_this, void 0, void 0, function () {
        var id, data_1, template_1, snapshots, _i, snapshots_2, s, e_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 3, , 4]);
                    id = params.id.trim().toLowerCase();
                    return [4 /*yield*/, plugin.runTask(plugin.fetch({ url: "https://jolecule.appspot.com/pdb/" + id + ".views.json", type: 'json' }))];
                case 1:
                    data_1 = _b.sent();
                    data_1.sort(function (a, b) { return a.order - b.order; });
                    return [4 /*yield*/, command_1.PluginCommands.State.RemoveObject.dispatch(plugin, { state: state, ref: ref })];
                case 2:
                    _b.sent();
                    plugin.state.snapshots.clear();
                    template_1 = createTemplate(plugin, state, id);
                    snapshots = data_1.map(function (e, idx) { return buildSnapshot(plugin, template_1, { e: e, idx: idx, len: data_1.length }); });
                    for (_i = 0, snapshots_2 = snapshots; _i < snapshots_2.length; _i++) {
                        s = snapshots_2[_i];
                        plugin.state.snapshots.add(s);
                    }
                    command_1.PluginCommands.State.Snapshots.Apply.dispatch(plugin, { id: snapshots[0].snapshot.id });
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _b.sent();
                    plugin.log.error("Jolecule Failed: " + e_1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
});
function createTemplate(plugin, state, id) {
    var b = new mol_state_1.StateBuilder.Root(state.tree);
    var data = b.toRoot().apply(transforms_1.StateTransforms.Data.Download, { url: "https://www.ebi.ac.uk/pdbe/static/entry/" + id + "_updated.cif" }, { state: { isGhost: true } });
    var model = structure_1.createModelTree(data, 'cif');
    var structure = model.apply(transforms_1.StateTransforms.Model.StructureFromModel, {});
    structure_1.complexRepresentation(plugin, structure, { hideWater: true });
    return { tree: b.getTree(), structure: structure.ref };
}
var labelOptions = __assign({}, param_definition_1.ParamDefinition.getDefaultValues(text_1.Text.Params), { tether: true, sizeFactor: 1.3, attachment: 'bottom-right', offsetZ: 10, background: true, backgroundMargin: 0.2, backgroundColor: tables_1.ColorNames.skyblue, backgroundOpacity: 0.9 });
// const distanceLabelOptions = {
//     ...ParamDefinition.getDefaultValues(Text.Params),
//     sizeFactor: 1,
//     offsetX: 0,
//     offsetY: 0,
//     offsetZ: 10,
//     background: true,
//     backgroundMargin: 0.2,
//     backgroundColor: ColorNames.snow,
//     backgroundOpacity: 0.9
// }
function buildSnapshot(plugin, template, params) {
    var b = new mol_state_1.StateBuilder.Root(template.tree);
    var i = 0;
    for (var _i = 0, _a = params.e.labels; _i < _a.length; _i++) {
        var l = _a[_i];
        var query = createQuery([l.i_atom]);
        var group = b.to(template.structure)
            .group(transforms_1.StateTransforms.Misc.CreateGroup, { label: "Label " + ++i });
        group
            .apply(transforms_1.StateTransforms.Model.StructureSelection, { query: query, label: 'Atom' })
            .apply(transforms_1.StateTransforms.Representation.StructureLabels3D, {
            target: { name: 'static-text', params: { value: l.text || '' } },
            options: labelOptions
        });
        group
            .apply(transforms_1.StateTransforms.Model.StructureSelection, { query: builder_1.MolScriptBuilder.struct.modifier.wholeResidues([query]), label: 'Residue' })
            .apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsStatic(plugin, 'ball-and-stick', {}));
    }
    if (params.e.selected && params.e.selected.length > 0) {
        b.to(template.structure)
            .apply(transforms_1.StateTransforms.Model.StructureSelection, { query: createQuery(params.e.selected), label: "Selected" })
            .apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsStatic(plugin, 'ball-and-stick'));
    }
    // TODO
    // for (const l of params.e.distances) {
    //     b.to('structure')
    //         .apply(StateTransforms.Model.StructureSelection, { query: createQuery([l.i_atom1, l.i_atom2]), label: `Distance ${++i}` })
    //         .apply(StateTransforms.Representation.StructureLabels3D, {
    //             target: { name: 'static-text', params: { value: l. || '' } },
    //             options: labelOptions
    //         });
    // }
    return snapshots_1.PluginStateSnapshotManager.Entry({
        id: mol_util_1.UUID.create22(),
        data: { tree: mol_state_1.StateTree.toJSON(b.getTree()) },
        camera: {
            current: getCameraSnapshot(params.e.camera),
            transitionStyle: 'animate',
            transitionDurationInMs: 350
        }
    }, {
        name: params.e.text
    });
}
function getCameraSnapshot(e) {
    var direction = linear_algebra_1.Vec3.sub(linear_algebra_1.Vec3.zero(), e.pos, e.in);
    linear_algebra_1.Vec3.normalize(direction, direction);
    var up = linear_algebra_1.Vec3.sub(linear_algebra_1.Vec3.zero(), e.pos, e.up);
    linear_algebra_1.Vec3.normalize(up, up);
    var s = {
        mode: 'perspective',
        position: linear_algebra_1.Vec3.scaleAndAdd(linear_algebra_1.Vec3.zero(), e.pos, direction, e.slab.zoom),
        target: e.pos,
        direction: direction,
        up: up,
        near: e.slab.zoom + e.slab.z_front,
        far: e.slab.zoom + e.slab.z_back,
        fogNear: e.slab.zoom + e.slab.z_front,
        fogFar: e.slab.zoom + e.slab.z_back,
        fov: Math.PI / 4,
        zoom: 1
    };
    return s;
}
function createQuery(atomIndices) {
    if (atomIndices.length === 0)
        return builder_1.MolScriptBuilder.struct.generator.empty();
    return builder_1.MolScriptBuilder.struct.generator.atomGroups({
        'atom-test': atomIndices.length === 1
            ? builder_1.MolScriptBuilder.core.rel.eq([builder_1.MolScriptBuilder.struct.atomProperty.core.sourceIndex(), atomIndices[0]])
            : builder_1.MolScriptBuilder.core.set.has([builder_1.MolScriptBuilder.set.apply(null, atomIndices), builder_1.MolScriptBuilder.struct.atomProperty.core.sourceIndex()]),
        'group-by': 0
    });
}
