"use strict";
/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var mol_plugin_1 = require("../../mol-plugin");
require("./index.html");
var command_1 = require("../../mol-plugin/command");
var spec_1 = require("../../mol-plugin/spec");
var jolecule_1 = require("./extensions/jolecule");
require('mol-plugin/skin/light.scss');
function getParam(name, regex) {
    var r = new RegExp(name + "=(" + regex + ")[&]?", 'i');
    return decodeURIComponent(((window.location.search || '').match(r) || [])[1] || '');
}
var hideControls = getParam('hide-controls', "[^&]+") === '1';
function init() {
    var spec = {
        actions: mol_plugin_1.DefaultPluginSpec.actions.concat([spec_1.PluginSpec.Action(jolecule_1.CreateJoleculeState)]),
        behaviors: mol_plugin_1.DefaultPluginSpec.behaviors.slice(),
        animations: (mol_plugin_1.DefaultPluginSpec.animations || []).slice(),
        customParamEditors: mol_plugin_1.DefaultPluginSpec.customParamEditors,
        layout: {
            initial: {
                isExpanded: true,
                showControls: !hideControls
            },
            controls: __assign({}, mol_plugin_1.DefaultPluginSpec.layout && mol_plugin_1.DefaultPluginSpec.layout.controls)
        }
    };
    var plugin = mol_plugin_1.createPlugin(document.getElementById('app'), spec);
    trySetSnapshot(plugin);
}
function trySetSnapshot(ctx) {
    return __awaiter(this, void 0, void 0, function () {
        var snapshotUrl, snapshotId, url, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    snapshotUrl = getParam('snapshot-url', "[^&]+");
                    snapshotId = getParam('snapshot-id', "[^&]+");
                    if (!snapshotUrl && !snapshotId)
                        return [2 /*return*/];
                    url = snapshotId
                        ? "https://webchem.ncbr.muni.cz/molstar-state/get/" + snapshotId
                        : snapshotUrl;
                    return [4 /*yield*/, command_1.PluginCommands.State.Snapshots.Fetch.dispatch(ctx, { url: url })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_1 = _a.sent();
                    ctx.log.error('Failed to load snapshot.');
                    console.warn('Failed to load snapshot', e_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
init();
