"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ReactDOM = require("react-dom");
var mol_plugin_1 = require("../../mol-plugin");
require("./index.html");
var command_1 = require("../../mol-plugin/command");
var transforms_1 = require("../../mol-plugin/state/transforms");
var representation_1 = require("../../mol-plugin/state/transforms/representation");
var color_1 = require("../../mol-util/color");
var built_in_1 = require("../../mol-plugin/state/animation/built-in");
var mol_state_1 = require("../../mol-state");
var annotation_1 = require("./annotation");
var helpers_1 = require("./helpers");
var rx_event_helper_1 = require("../../mol-util/rx-event-helper");
var controls_1 = require("./ui/controls");
var mol_task_1 = require("../../mol-task");
var coloring_1 = require("./coloring");
var builder_1 = require("../../mol-script/language/builder");
var registry_1 = require("../../mol-repr/structure/registry");
var color_2 = require("../../mol-theme/color");
var size_1 = require("../../mol-theme/size");
var tables_1 = require("../../mol-util/color/tables");
var transformers_1 = require("../../mol-plugin/behavior/dynamic/volume-streaming/transformers");
var param_definition_1 = require("../../mol-util/param-definition");
// import { Vec3 } from 'mol-math/linear-algebra';
// import { ParamDefinition } from 'mol-util/param-definition';
// import { Text } from 'mol-geo/geometry/text/text';
require('../../mol-plugin/skin/light.scss');
var MolStarProteopediaWrapper = /** @class */ (function () {
    function MolStarProteopediaWrapper() {
        var _this = this;
        this._ev = rx_event_helper_1.RxEventHelper.create();
        this.events = {
            modelInfo: this._ev()
        };
        this.loadedParams = { url: '', format: 'cif', assemblyId: '' };
        this.animate = {
            modelIndex: {
                maxFPS: 8,
                onceForward: function () { _this.plugin.state.animation.play(built_in_1.AnimateModelIndex, { maxFPS: Math.max(0.5, _this.animate.modelIndex.maxFPS | 0), mode: { name: 'once', params: { direction: 'forward' } } }); },
                onceBackward: function () { _this.plugin.state.animation.play(built_in_1.AnimateModelIndex, { maxFPS: Math.max(0.5, _this.animate.modelIndex.maxFPS | 0), mode: { name: 'once', params: { direction: 'backward' } } }); },
                palindrome: function () { _this.plugin.state.animation.play(built_in_1.AnimateModelIndex, { maxFPS: Math.max(0.5, _this.animate.modelIndex.maxFPS | 0), mode: { name: 'palindrome', params: {} } }); },
                loop: function () { _this.plugin.state.animation.play(built_in_1.AnimateModelIndex, { maxFPS: Math.max(0.5, _this.animate.modelIndex.maxFPS | 0), mode: { name: 'loop', params: {} } }); },
                stop: function () { return _this.plugin.state.animation.stop(); }
            }
        };
        this.coloring = {
            evolutionaryConservation: function (params) { return __awaiter(_this, void 0, void 0, function () {
                var state, tree, colorTheme;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(!params || !params.keepStyle)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.updateStyle({ sequence: { kind: 'spacefill' } }, true)];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            state = this.state;
                            tree = state.build();
                            colorTheme = { name: annotation_1.EvolutionaryConservation.Descriptor.name, params: this.plugin.structureRepresentation.themeCtx.colorThemeRegistry.get(annotation_1.EvolutionaryConservation.Descriptor.name).defaultValues };
                            if (!params || !!params.sequence) {
                                tree.to(helpers_1.StateElements.SequenceVisual).update(transforms_1.StateTransforms.Representation.StructureRepresentation3D, function (old) { return (__assign({}, old, { colorTheme: colorTheme })); });
                            }
                            if (params && !!params.het) {
                                tree.to(helpers_1.StateElements.HetVisual).update(transforms_1.StateTransforms.Representation.StructureRepresentation3D, function (old) { return (__assign({}, old, { colorTheme: colorTheme })); });
                            }
                            return [4 /*yield*/, command_1.PluginCommands.State.Update.dispatch(this.plugin, { state: state, tree: tree })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); }
        };
        this.experimentalDataElement = void 0;
        this.experimentalData = {
            init: function (parent) { return __awaiter(_this, void 0, void 0, function () {
                var asm, params;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            asm = this.state.select(helpers_1.StateElements.Assembly)[0].obj;
                            params = param_definition_1.ParamDefinition.getDefaultValues(transformers_1.InitVolumeStreaming.definition.params(asm, this.plugin));
                            params.behaviorRef = helpers_1.StateElements.VolumeStreaming;
                            params.defaultView = 'box';
                            return [4 /*yield*/, this.plugin.runTask(this.state.applyAction(transformers_1.InitVolumeStreaming, params, helpers_1.StateElements.Assembly))];
                        case 1:
                            _a.sent();
                            this.experimentalDataElement = parent;
                            controls_1.volumeStreamingControls(this.plugin, parent);
                            return [2 /*return*/];
                    }
                });
            }); },
            remove: function () {
                var r = _this.state.select(mol_state_1.StateSelection.Generators.ofTransformer(transformers_1.CreateVolumeStreamingInfo))[0];
                if (!r)
                    return;
                command_1.PluginCommands.State.RemoveObject.dispatch(_this.plugin, { state: _this.state, ref: r.transform.ref });
                if (_this.experimentalDataElement) {
                    ReactDOM.unmountComponentAtNode(_this.experimentalDataElement);
                    _this.experimentalDataElement = void 0;
                }
            }
        };
        this.hetGroups = {
            reset: function () {
                var update = _this.state.build().delete(helpers_1.StateElements.HetGroupFocus);
                command_1.PluginCommands.State.Update.dispatch(_this.plugin, { state: _this.state, tree: update });
                command_1.PluginCommands.Camera.Reset.dispatch(_this.plugin, {});
            },
            focusFirst: function (compId) { return __awaiter(_this, void 0, void 0, function () {
                var update, core, surroundings, group, focus, sphere, snapshot;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.state.transforms.has(helpers_1.StateElements.Assembly))
                                return [2 /*return*/];
                            return [4 /*yield*/, command_1.PluginCommands.Camera.Reset.dispatch(this.plugin, {})];
                        case 1:
                            _a.sent();
                            update = this.state.build();
                            update.delete(helpers_1.StateElements.HetGroupFocusGroup);
                            core = builder_1.MolScriptBuilder.struct.filter.first([
                                builder_1.MolScriptBuilder.struct.generator.atomGroups({
                                    'residue-test': builder_1.MolScriptBuilder.core.rel.eq([builder_1.MolScriptBuilder.struct.atomProperty.macromolecular.label_comp_id(), compId]),
                                    'group-by': builder_1.MolScriptBuilder.core.str.concat([builder_1.MolScriptBuilder.struct.atomProperty.core.operatorName(), builder_1.MolScriptBuilder.struct.atomProperty.macromolecular.residueKey()])
                                })
                            ]);
                            surroundings = builder_1.MolScriptBuilder.struct.modifier.includeSurroundings({ 0: core, radius: 5, 'as-whole-residues': true });
                            group = update.to(helpers_1.StateElements.Assembly).group(transforms_1.StateTransforms.Misc.CreateGroup, { label: compId }, { ref: helpers_1.StateElements.HetGroupFocusGroup });
                            group.apply(transforms_1.StateTransforms.Model.StructureSelection, { label: 'Core', query: core }, { ref: helpers_1.StateElements.HetGroupFocus })
                                .apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, this.createCoreVisualParams());
                            group.apply(transforms_1.StateTransforms.Model.StructureSelection, { label: 'Surroundings', query: surroundings })
                                .apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, this.createSurVisualParams());
                            // sel.apply(StateTransforms.Representation.StructureLabels3D, {
                            //     target: { name: 'residues', params: { } },
                            //     options: {
                            //         ...ParamDefinition.getDefaultValues(Text.Params),
                            //         background: true,
                            //         backgroundMargin: 0.2,
                            //         backgroundColor: ColorNames.snow,
                            //         backgroundOpacity: 0.9,
                            //     }
                            // });
                            return [4 /*yield*/, command_1.PluginCommands.State.Update.dispatch(this.plugin, { state: this.state, tree: update })];
                        case 2:
                            // sel.apply(StateTransforms.Representation.StructureLabels3D, {
                            //     target: { name: 'residues', params: { } },
                            //     options: {
                            //         ...ParamDefinition.getDefaultValues(Text.Params),
                            //         background: true,
                            //         backgroundMargin: 0.2,
                            //         backgroundColor: ColorNames.snow,
                            //         backgroundOpacity: 0.9,
                            //     }
                            // });
                            _a.sent();
                            focus = this.state.select(helpers_1.StateElements.HetGroupFocus)[0].obj.data;
                            sphere = focus.boundary.sphere;
                            snapshot = this.plugin.canvas3d.camera.getFocus(sphere.center, Math.max(sphere.radius, 5));
                            command_1.PluginCommands.Camera.SetSnapshot.dispatch(this.plugin, { snapshot: snapshot, durationMs: 250 });
                            return [2 /*return*/];
                    }
                });
            }); }
        };
        this.snapshot = {
            get: function () {
                return _this.plugin.state.getSnapshot();
            },
            set: function (snapshot) {
                return _this.plugin.state.setSnapshot(snapshot);
            },
            download: function (url) { return __awaiter(_this, void 0, void 0, function () {
                var data, snapshot, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 3, , 4]);
                            return [4 /*yield*/, this.plugin.runTask(this.plugin.fetch({ url: url }))];
                        case 1:
                            data = _a.sent();
                            snapshot = JSON.parse(data);
                            return [4 /*yield*/, this.plugin.state.setSnapshot(snapshot)];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            console.log(e_1);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); }
        };
    }
    MolStarProteopediaWrapper.prototype.init = function (target, options) {
        this.plugin = mol_plugin_1.createPlugin(typeof target === 'string' ? document.getElementById(target) : target, __assign({}, mol_plugin_1.DefaultPluginSpec, { animations: [
                built_in_1.AnimateModelIndex
            ], layout: {
                initial: {
                    isExpanded: false,
                    showControls: false
                },
                controls: {
                    right: controls_1.ControlsWrapper
                }
            } }));
        var customColoring = coloring_1.createProteopediaCustomTheme((options && options.customColorList) || []);
        this.plugin.structureRepresentation.themeCtx.colorThemeRegistry.add('proteopedia-custom', customColoring);
        this.plugin.structureRepresentation.themeCtx.colorThemeRegistry.add(annotation_1.EvolutionaryConservation.Descriptor.name, annotation_1.EvolutionaryConservation.colorTheme);
        this.plugin.lociLabels.addProvider(annotation_1.EvolutionaryConservation.labelProvider);
        this.plugin.customModelProperties.register(annotation_1.EvolutionaryConservation.propertyProvider);
    };
    Object.defineProperty(MolStarProteopediaWrapper.prototype, "state", {
        get: function () {
            return this.plugin.state.dataState;
        },
        enumerable: true,
        configurable: true
    });
    MolStarProteopediaWrapper.prototype.download = function (b, url) {
        return b.apply(transforms_1.StateTransforms.Data.Download, { url: url, isBinary: false });
    };
    MolStarProteopediaWrapper.prototype.model = function (b, format) {
        var parsed = format === 'cif'
            ? b.apply(transforms_1.StateTransforms.Data.ParseCif).apply(transforms_1.StateTransforms.Model.TrajectoryFromMmCif)
            : b.apply(transforms_1.StateTransforms.Model.TrajectoryFromPDB);
        return parsed
            .apply(transforms_1.StateTransforms.Model.ModelFromTrajectory, { modelIndex: 0 }, { ref: helpers_1.StateElements.Model });
    };
    MolStarProteopediaWrapper.prototype.structure = function (assemblyId) {
        var model = this.state.build().to(helpers_1.StateElements.Model);
        var s = model
            .apply(transforms_1.StateTransforms.Model.CustomModelProperties, { properties: [annotation_1.EvolutionaryConservation.Descriptor.name] }, { ref: helpers_1.StateElements.ModelProps, state: { isGhost: false } })
            .apply(transforms_1.StateTransforms.Model.StructureAssemblyFromModel, { id: assemblyId || 'deposited' }, { ref: helpers_1.StateElements.Assembly });
        s.apply(transforms_1.StateTransforms.Model.StructureComplexElement, { type: 'atomic-sequence' }, { ref: helpers_1.StateElements.Sequence });
        s.apply(transforms_1.StateTransforms.Model.StructureComplexElement, { type: 'atomic-het' }, { ref: helpers_1.StateElements.Het });
        s.apply(transforms_1.StateTransforms.Model.StructureComplexElement, { type: 'water' }, { ref: helpers_1.StateElements.Water });
        return s;
    };
    MolStarProteopediaWrapper.prototype.visual = function (_style, partial) {
        var structure = this.getObj(helpers_1.StateElements.Assembly);
        if (!structure)
            return;
        var style = _style || {};
        var update = this.state.build();
        if (!partial || (partial && style.sequence)) {
            var root = update.to(helpers_1.StateElements.Sequence);
            if (style.sequence && style.sequence.hide) {
                root.delete(helpers_1.StateElements.SequenceVisual);
            }
            else {
                root.applyOrUpdate(helpers_1.StateElements.SequenceVisual, transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsWithTheme(this.plugin, (style.sequence && style.sequence.kind) || 'cartoon', (style.sequence && style.sequence.coloring) || 'unit-index', structure));
            }
        }
        if (!partial || (partial && style.hetGroups)) {
            var root = update.to(helpers_1.StateElements.Het);
            if (style.hetGroups && style.hetGroups.hide) {
                root.delete(helpers_1.StateElements.HetVisual);
            }
            else {
                if (style.hetGroups && style.hetGroups.hide) {
                    root.delete(helpers_1.StateElements.HetVisual);
                }
                else {
                    root.applyOrUpdate(helpers_1.StateElements.HetVisual, transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsWithTheme(this.plugin, (style.hetGroups && style.hetGroups.kind) || 'ball-and-stick', (style.hetGroups && style.hetGroups.coloring), structure));
                }
            }
        }
        if (!partial || (partial && style.snfg3d)) {
            var root = update.to(helpers_1.StateElements.Het);
            if (style.hetGroups && style.hetGroups.hide) {
                root.delete(helpers_1.StateElements.HetVisual);
            }
            else {
                if (style.snfg3d && style.snfg3d.hide) {
                    root.delete(helpers_1.StateElements.Het3DSNFG);
                }
                else {
                    root.applyOrUpdate(helpers_1.StateElements.Het3DSNFG, transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsWithTheme(this.plugin, 'carbohydrate', void 0, structure));
                }
            }
        }
        if (!partial || (partial && style.water)) {
            var root = update.to(helpers_1.StateElements.Water);
            if (style.water && style.water.hide) {
                root.delete(helpers_1.StateElements.WaterVisual);
            }
            else {
                root.applyOrUpdate(helpers_1.StateElements.WaterVisual, transforms_1.StateTransforms.Representation.StructureRepresentation3D, representation_1.StructureRepresentation3DHelpers.getDefaultParamsWithTheme(this.plugin, (style.water && style.water.kind) || 'ball-and-stick', (style.water && style.water.coloring), structure, { alpha: 0.51 }));
            }
        }
        return update;
    };
    MolStarProteopediaWrapper.prototype.getObj = function (ref) {
        var state = this.state;
        var cell = state.select(ref)[0];
        if (!cell || !cell.obj)
            return void 0;
        return cell.obj.data;
    };
    MolStarProteopediaWrapper.prototype.doInfo = function (checkPreferredAssembly) {
        return __awaiter(this, void 0, void 0, function () {
            var model, info;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        model = this.getObj('model');
                        if (!model)
                            return [2 /*return*/];
                        return [4 /*yield*/, helpers_1.ModelInfo.get(this.plugin, model, checkPreferredAssembly)];
                    case 1:
                        info = _a.sent();
                        this.events.modelInfo.next(info);
                        return [2 /*return*/, info];
                }
            });
        });
    };
    MolStarProteopediaWrapper.prototype.applyState = function (tree) {
        return command_1.PluginCommands.State.Update.dispatch(this.plugin, { state: this.plugin.state.dataState, tree: tree });
    };
    MolStarProteopediaWrapper.prototype.load = function (_a) {
        var url = _a.url, _b = _a.format, format = _b === void 0 ? 'cif' : _b, _c = _a.assemblyId, assemblyId = _c === void 0 ? 'deposited' : _c, representationStyle = _a.representationStyle;
        return __awaiter(this, void 0, void 0, function () {
            var loadType, state, modelTree, info, asmId, structureTree, tree, info, asmId_1;
            var _this = this;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        loadType = 'full';
                        state = this.plugin.state.dataState;
                        if (this.loadedParams.url !== url || this.loadedParams.format !== format) {
                            loadType = 'full';
                        }
                        else if (this.loadedParams.url === url) {
                            if (state.select(helpers_1.StateElements.Assembly).length > 0)
                                loadType = 'update';
                        }
                        if (!(loadType === 'full')) return [3 /*break*/, 5];
                        return [4 /*yield*/, command_1.PluginCommands.State.RemoveObject.dispatch(this.plugin, { state: state, ref: state.tree.root.ref })];
                    case 1:
                        _d.sent();
                        modelTree = this.model(this.download(state.build().toRoot(), url), format);
                        return [4 /*yield*/, this.applyState(modelTree)];
                    case 2:
                        _d.sent();
                        return [4 /*yield*/, this.doInfo(true)];
                    case 3:
                        info = _d.sent();
                        asmId = (assemblyId === 'preferred' && info && info.preferredAssemblyId) || assemblyId;
                        structureTree = this.structure(asmId);
                        return [4 /*yield*/, this.applyState(structureTree)];
                    case 4:
                        _d.sent();
                        return [3 /*break*/, 8];
                    case 5:
                        tree = state.build();
                        return [4 /*yield*/, this.doInfo(true)];
                    case 6:
                        info = _d.sent();
                        asmId_1 = (assemblyId === 'preferred' && info && info.preferredAssemblyId) || assemblyId;
                        tree.to(helpers_1.StateElements.Assembly).update(transforms_1.StateTransforms.Model.StructureAssemblyFromModel, function (p) { return (__assign({}, p, { id: asmId_1 })); });
                        return [4 /*yield*/, this.applyState(tree)];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8: return [4 /*yield*/, this.updateStyle(representationStyle)];
                    case 9:
                        _d.sent();
                        this.loadedParams = { url: url, format: format, assemblyId: assemblyId };
                        mol_task_1.Scheduler.setImmediate(function () { return command_1.PluginCommands.Camera.Reset.dispatch(_this.plugin, {}); });
                        return [2 /*return*/];
                }
            });
        });
    };
    MolStarProteopediaWrapper.prototype.updateStyle = function (style, partial) {
        return __awaiter(this, void 0, void 0, function () {
            var tree;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        tree = this.visual(style, partial);
                        if (!tree)
                            return [2 /*return*/];
                        return [4 /*yield*/, command_1.PluginCommands.State.Update.dispatch(this.plugin, { state: this.plugin.state.dataState, tree: tree })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    MolStarProteopediaWrapper.prototype.setBackground = function (color) {
        var renderer = this.plugin.canvas3d.props.renderer;
        command_1.PluginCommands.Canvas3D.SetSettings.dispatch(this.plugin, { settings: { renderer: __assign({}, renderer, { backgroundColor: color_1.Color(color) }) } });
    };
    MolStarProteopediaWrapper.prototype.toggleSpin = function () {
        var trackball = this.plugin.canvas3d.props.trackball;
        var spinning = trackball.spin;
        command_1.PluginCommands.Canvas3D.SetSettings.dispatch(this.plugin, { settings: { trackball: __assign({}, trackball, { spin: !trackball.spin }) } });
        if (!spinning)
            command_1.PluginCommands.Camera.Reset.dispatch(this.plugin, {});
    };
    MolStarProteopediaWrapper.prototype.createSurVisualParams = function () {
        var asm = this.state.select(helpers_1.StateElements.Assembly)[0].obj;
        return representation_1.StructureRepresentation3DHelpers.createParams(this.plugin, asm.data, {
            repr: registry_1.BuiltInStructureRepresentations['ball-and-stick'],
            color: [color_2.BuiltInColorThemes.uniform, function () { return ({ value: tables_1.ColorNames.gray }); }],
            size: [size_1.BuiltInSizeThemes.uniform, function () { return ({ value: 0.33 }); }]
        });
    };
    MolStarProteopediaWrapper.prototype.createCoreVisualParams = function () {
        var asm = this.state.select(helpers_1.StateElements.Assembly)[0].obj;
        return representation_1.StructureRepresentation3DHelpers.createParams(this.plugin, asm.data, {
            repr: registry_1.BuiltInStructureRepresentations['ball-and-stick'],
        });
    };
    MolStarProteopediaWrapper.VERSION_MAJOR = 3;
    MolStarProteopediaWrapper.VERSION_MINOR = 2;
    return MolStarProteopediaWrapper;
}());
window.MolStarProteopediaWrapper = MolStarProteopediaWrapper;
