"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var base_1 = require("../../../mol-plugin/ui/base");
var plugin_1 = require("../../../mol-plugin/ui/plugin");
var animation_1 = require("../../../mol-plugin/ui/state/animation");
var camera_1 = require("../../../mol-plugin/ui/camera");
var update_transform_1 = require("../../../mol-plugin/ui/state/update-transform");
var helpers_1 = require("../helpers");
var ControlsWrapper = /** @class */ (function (_super) {
    __extends(ControlsWrapper, _super);
    function ControlsWrapper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ControlsWrapper.prototype.render = function () {
        return React.createElement("div", { className: 'msp-scrollable-container msp-right-controls' },
            React.createElement(plugin_1.CurrentObject, null),
            React.createElement(animation_1.AnimationControls, null),
            React.createElement(camera_1.CameraSnapshots, null));
    };
    return ControlsWrapper;
}(base_1.PluginUIComponent));
exports.ControlsWrapper = ControlsWrapper;
function volumeStreamingControls(plugin, parent) {
    ReactDOM.render(React.createElement(plugin_1.PluginContextContainer, { plugin: plugin },
        React.createElement(update_transform_1.TransformUpdaterControl, { nodeRef: helpers_1.StateElements.VolumeStreaming })), parent);
}
exports.volumeStreamingControls = volumeStreamingControls;
