"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var color_1 = require("../../mol-util/color");
var ColorThemeComponent = /** @class */ (function (_super) {
    __extends(ColorThemeComponent, _super);
    function ColorThemeComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {};
        return _this;
    }
    ColorThemeComponent.prototype.render = function () {
        var ct = this.props.colorTheme;
        return React.createElement("div", null,
            React.createElement("span", null, "Color Theme Info "),
            ct.description ? React.createElement("div", null,
                React.createElement("i", null, ct.description)) : '',
            ct.legend && ct.legend.kind === 'scale-legend'
                ? React.createElement("div", { style: {
                        width: '100%',
                        height: '30px',
                        background: "linear-gradient(to right, " + ct.legend.colors.map(function (c) { return color_1.Color.toStyle(c); }).join(', ') + ")"
                    } },
                    React.createElement("span", { style: { float: 'left', padding: '6px', color: 'white', fontWeight: 'bold', backgroundColor: 'rgba(0, 0, 0, 0.2)' } }, ct.legend.minLabel),
                    React.createElement("span", { style: { float: 'right', padding: '6px', color: 'white', fontWeight: 'bold', backgroundColor: 'rgba(0, 0, 0, 0.2)' } }, ct.legend.maxLabel))
                : ct.legend && ct.legend.kind === 'table-legend'
                    ? React.createElement("div", null, ct.legend.table.map(function (value, i) {
                        var name = value[0], color = value[1];
                        return React.createElement("div", { key: i, style: { minWidth: '60px', marginRight: '5px', display: 'inline-block' } },
                            React.createElement("div", { style: { width: '30px', height: '20px', backgroundColor: color_1.Color.toStyle(color), display: 'inline-block' } }),
                            name);
                    }))
                    : '');
    };
    return ColorThemeComponent;
}(React.Component));
exports.ColorThemeComponent = ColorThemeComponent;
