"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var tables_1 = require("../../../mol-util/color/tables");
var color_1 = require("../../../mol-util/color");
var ColorParamComponent = /** @class */ (function (_super) {
    __extends(ColorParamComponent, _super);
    function ColorParamComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.value
        };
        return _this;
    }
    ColorParamComponent.prototype.onChange = function (value) {
        this.setState({ value: value });
        this.props.onChange(value);
    };
    ColorParamComponent.prototype.render = function () {
        var _this = this;
        return React.createElement("div", null,
            React.createElement("span", null,
                this.props.label,
                " "),
            React.createElement("select", { value: this.state.value, onChange: function (e) { return _this.onChange(color_1.Color(parseInt(e.target.value))); } }, Object.keys(tables_1.ColorNames).map(function (name) {
                return React.createElement("option", { key: name, value: tables_1.ColorNames[name] }, name);
            })));
    };
    return ColorParamComponent;
}(React.Component));
exports.ColorParamComponent = ColorParamComponent;
