/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import * as React from 'react';
import { ParamDefinition as PD } from '../../../mol-util/param-definition';
export interface MultiSelectParamComponentProps<T extends string> {
    label: string;
    param: PD.MultiSelect<T>;
    value: T[];
    onChange(v: T[]): void;
}
export interface MultiSelectParamComponentState<T extends string> {
    value: T[];
}
export declare class MultiSelectParamComponent<T extends string> extends React.Component<MultiSelectParamComponentProps<T>, MultiSelectParamComponentState<T>> {
    state: {
        value: T[];
    };
    onChange(value: T[]): void;
    render(): JSX.Element;
}
