"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var MultiSelectParamComponent = /** @class */ (function (_super) {
    __extends(MultiSelectParamComponent, _super);
    function MultiSelectParamComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.value
        };
        return _this;
    }
    MultiSelectParamComponent.prototype.onChange = function (value) {
        this.setState({ value: value });
        this.props.onChange(value);
    };
    MultiSelectParamComponent.prototype.render = function () {
        var _this = this;
        return React.createElement("div", null,
            React.createElement("span", null,
                this.props.label,
                " "),
            React.createElement("select", { multiple: true, value: this.state.value, onChange: function (e) {
                    var value = Array.from(e.target.options).filter(function (option) { return option.selected; }).map(function (option) { return option.value; });
                    _this.onChange(value);
                } }, this.props.param.options.map(function (v) {
                var value = v[0], label = v[1];
                return React.createElement("option", { key: label, value: value }, label);
            })));
    };
    return MultiSelectParamComponent;
}(React.Component));
exports.MultiSelectParamComponent = MultiSelectParamComponent;
