/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import * as React from 'react';
import { ParamDefinition as PD } from '../../mol-util/param-definition';
interface ParametersProps<P extends PD.Params> {
    params: P;
    values: {
        [k in keyof P]: P[k]['defaultValue'];
    };
    onChange<K extends keyof P>(k: K, v: P[K]['defaultValue']): void;
}
declare type ParametersState = {};
export declare class ParametersComponent<P extends PD.Params> extends React.Component<ParametersProps<P>, ParametersState> {
    onChange(k: string, value: any): void;
    render(): JSX.Element;
}
export {};
