"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var boolean_1 = require("./parameter/boolean");
var number_1 = require("./parameter/number");
var select_1 = require("./parameter/select");
var multi_select_1 = require("./parameter/multi-select");
var text_1 = require("./parameter/text");
var color_1 = require("./parameter/color");
var string_1 = require("../../mol-util/string");
function getParamComponent(label, param, value, onChange) {
    switch (param.type) {
        case 'boolean':
            return React.createElement(boolean_1.BooleanParamComponent, { label: label, param: param, value: value, onChange: onChange });
        case 'number':
            return React.createElement(number_1.NumberParamComponent, { label: label, param: param, value: value, onChange: onChange });
        case 'select':
            return React.createElement(select_1.SelectParamComponent, { label: label, param: param, value: value, onChange: onChange });
        case 'multi-select':
            return React.createElement(multi_select_1.MultiSelectParamComponent, { label: label, param: param, value: value, onChange: onChange });
        case 'text':
            return React.createElement(text_1.TextParamComponent, { label: label, param: param, value: value, onChange: onChange });
        case 'color':
            return React.createElement(color_1.ColorParamComponent, { label: label, param: param, value: value, onChange: onChange });
    }
    return '';
}
function getLabel(name, param) {
    return param.label === undefined ? string_1.camelCaseToWords(name) : param.label;
}
var ParametersComponent = /** @class */ (function (_super) {
    __extends(ParametersComponent, _super);
    function ParametersComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ParametersComponent.prototype.onChange = function (k, value) {
        this.props.onChange(k, value);
    };
    ParametersComponent.prototype.render = function () {
        var _this = this;
        return React.createElement("div", { style: { width: '100%' } }, Object.keys(this.props.params).map(function (k) {
            var param = _this.props.params[k];
            var value = _this.props.values[k];
            var label = getLabel(k, param);
            return React.createElement("div", { key: k }, getParamComponent(label, param, value, function (v) { return _this.onChange(k, v); }));
        }));
    };
    return ParametersComponent;
}(React.Component));
exports.ParametersComponent = ParametersComponent;
