/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import InputObserver, { ModifiersKeys, ButtonsType } from '../../mol-util/input/input-observer';
declare type Canvas3D = import('../canvas3d').Canvas3D;
export declare class Canvas3dInteractionHelper {
    private canvasIdentify;
    private getLoci;
    private maxFps;
    private ev;
    readonly events: {
        highlight: import("rxjs").Subject<import("../canvas3d").Canvas3D.HighlightEvent>;
        click: import("rxjs").Subject<import("../canvas3d").Canvas3D.ClickEvent>;
    };
    private cX;
    private cY;
    private lastX;
    private lastY;
    private id;
    private currentIdentifyT;
    private prevLoci;
    private prevT;
    private inside;
    private buttons;
    private modifiers;
    private identify;
    tick(t: number): void;
    leave(): void;
    move(x: number, y: number, modifiers: ModifiersKeys): void;
    select(x: number, y: number, buttons: ButtonsType, modifiers: ModifiersKeys): void;
    modify(modifiers: ModifiersKeys): void;
    dispose(): void;
    constructor(canvasIdentify: Canvas3D['identify'], getLoci: Canvas3D['getLoci'], input: InputObserver, maxFps?: number);
}
export {};
