/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { WebGLContext } from '../../mol-gl/webgl/context';
import { RenderTarget } from '../../mol-gl/webgl/render-target';
import Renderer from '../../mol-gl/renderer';
import Scene from '../../mol-gl/scene';
import { BoundingSphereHelper } from '../helper/bounding-sphere-helper';
import { Texture } from '../../mol-gl/webgl/texture';
export declare class DrawPass {
    private webgl;
    private renderer;
    private scene;
    private debugHelper;
    colorTarget: RenderTarget;
    depthTexture: Texture;
    packedDepth: boolean;
    private depthTarget;
    constructor(webgl: WebGLContext, renderer: Renderer, scene: Scene, debugHelper: BoundingSphereHelper);
    setSize(width: number, height: number): void;
    render(toDrawingBuffer: boolean): void;
}
