/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { WebGLContext } from '../../mol-gl/webgl/context';
import { ParamDefinition as PD } from '../../mol-util/param-definition';
import { Camera } from '../../mol-canvas3d/camera';
import { PostprocessingPass } from './postprocessing';
import { DrawPass } from './draw';
export declare const MultiSampleParams: {
    mode: PD.Select<"on" | "off" | "temporal">;
    sampleLevel: PD.Numeric;
};
export declare type MultiSampleProps = PD.Values<typeof MultiSampleParams>;
export declare class MultiSamplePass {
    private webgl;
    private camera;
    private drawPass;
    private postprocessing;
    props: MultiSampleProps;
    private composeTarget;
    private holdTarget;
    private compose;
    private sampleIndex;
    private currentTime;
    private lastRenderTime;
    constructor(webgl: WebGLContext, camera: Camera, drawPass: DrawPass, postprocessing: PostprocessingPass, props: Partial<MultiSampleProps>);
    readonly enabled: boolean;
    update(changed: boolean, currentTime: number): void;
    setSize(width: number, height: number): void;
    setProps(props: Partial<MultiSampleProps>): void;
    render(): void;
    private renderMultiSample;
    private renderTemporalMultiSample;
}
