/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { WebGLContext } from '../../mol-gl/webgl/context';
import { RenderTarget } from '../../mol-gl/webgl/render-target';
import Renderer from '../../mol-gl/renderer';
import Scene from '../../mol-gl/scene';
import { PickingId } from '../../mol-geo/geometry/picking';
export declare class PickPass {
    private webgl;
    private renderer;
    private scene;
    private pickBaseScale;
    pickDirty: boolean;
    objectPickTarget: RenderTarget;
    instancePickTarget: RenderTarget;
    groupPickTarget: RenderTarget;
    private pickScale;
    private pickWidth;
    private pickHeight;
    constructor(webgl: WebGLContext, renderer: Renderer, scene: Scene, pickBaseScale: number);
    setSize(width: number, height: number): void;
    render(): void;
    identify(x: number, y: number): PickingId | undefined;
}
