"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
/** resize canvas to container element */
function resizeCanvas(canvas, container) {
    var w = window.innerWidth;
    var h = window.innerHeight;
    if (container !== document.body) {
        var bounds = container.getBoundingClientRect();
        w = bounds.right - bounds.left;
        h = bounds.bottom - bounds.top;
    }
    canvas.width = window.devicePixelRatio * w;
    canvas.height = window.devicePixelRatio * h;
    Object.assign(canvas.style, { width: w + "px", height: h + "px" });
}
exports.resizeCanvas = resizeCanvas;
