/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Segmentation, OrderedSet, SortedArray } from '../int';
import _Iterator from '../iterator';
/** Pairs of min and max indices of sorted, non-overlapping ranges */
declare type SortedRanges<T extends number = number> = SortedArray<T>;
declare namespace SortedRanges {
    function ofSortedRanges<T extends number = number>(array: ArrayLike<T>): SortedArray<T>;
    function start<T extends number = number>(ranges: SortedRanges<T>): T;
    function end<T extends number = number>(ranges: SortedRanges<T>): number;
    function min<T extends number = number>(ranges: SortedRanges<T>): T;
    function max<T extends number = number>(ranges: SortedRanges<T>): T;
    function size<T extends number = number>(ranges: SortedRanges<T>): number;
    function transientSegments<T extends number = number, I extends number = number>(ranges: SortedRanges<T>, set: OrderedSet<T>): Iterator<T, I>;
    class Iterator<T extends number = number, I extends number = number> implements _Iterator<Segmentation.Segment<I>> {
        private ranges;
        private set;
        private value;
        private curIndex;
        private maxIndex;
        private interval;
        private curMin;
        hasNext: boolean;
        updateInterval(): void;
        updateValue(): void;
        move(): Segmentation.Segment<I>;
        getRangeIndex(value: number): number;
        constructor(ranges: SortedRanges<T>, set: OrderedSet<T>);
    }
}
export default SortedRanges;
