"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MarkerAction;
(function (MarkerAction) {
    MarkerAction[MarkerAction["Highlight"] = 0] = "Highlight";
    MarkerAction[MarkerAction["RemoveHighlight"] = 1] = "RemoveHighlight";
    MarkerAction[MarkerAction["Select"] = 2] = "Select";
    MarkerAction[MarkerAction["Deselect"] = 3] = "Deselect";
    MarkerAction[MarkerAction["Toggle"] = 4] = "Toggle";
    MarkerAction[MarkerAction["Clear"] = 5] = "Clear";
})(MarkerAction = exports.MarkerAction || (exports.MarkerAction = {}));
function applyMarkerAction(array, start, end, action) {
    var changed = false;
    for (var i = start; i < end; ++i) {
        var v = array[i];
        switch (action) {
            case MarkerAction.Highlight:
                if (v % 2 === 0) {
                    v += 1;
                }
                break;
            case MarkerAction.RemoveHighlight:
                if (v % 2 !== 0) {
                    v -= 1;
                }
                break;
            case MarkerAction.Select:
                if (v < 2)
                    v += 2;
                // v += 2
                break;
            case MarkerAction.Deselect:
                // if (v >= 2) {
                //     v -= 2
                // }
                v = v % 2;
                break;
            case MarkerAction.Toggle:
                if (v >= 2) {
                    v -= 2;
                }
                else {
                    v += 2;
                }
                break;
            case MarkerAction.Clear:
                v = 0;
                break;
        }
        changed = array[i] !== v || changed;
        array[i] = v;
    }
    return changed;
}
exports.applyMarkerAction = applyMarkerAction;
