"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var linear_algebra_1 = require("../../../../mol-math/linear-algebra");
var cylinder_1 = require("./cylinder");
var sphere_1 = require("./sphere");
var tmpStart = linear_algebra_1.Vec3.zero();
var tmpEnd = linear_algebra_1.Vec3.zero();
var cylinderProps = {};
function addBoundingBox(state, box, radius, detail, radialSegments) {
    var min = box.min, max = box.max;
    cylinderProps.radiusTop = radius;
    cylinderProps.radiusBottom = radius;
    cylinderProps.radialSegments = radialSegments;
    linear_algebra_1.Vec3.set(tmpStart, max[0], max[1], max[2]);
    sphere_1.addSphere(state, tmpStart, radius, detail);
    linear_algebra_1.Vec3.set(tmpEnd, max[0], max[1], min[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpEnd, max[0], min[1], max[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpEnd, min[0], max[1], max[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpStart, min[0], min[1], min[2]);
    sphere_1.addSphere(state, tmpStart, radius, detail);
    linear_algebra_1.Vec3.set(tmpEnd, min[0], min[1], max[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpEnd, min[0], max[1], min[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpEnd, max[0], min[1], min[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpStart, max[0], min[1], min[2]);
    sphere_1.addSphere(state, tmpStart, radius, detail);
    linear_algebra_1.Vec3.set(tmpEnd, max[0], min[1], max[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpEnd, max[0], max[1], min[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpStart, min[0], min[1], max[2]);
    sphere_1.addSphere(state, tmpStart, radius, detail);
    linear_algebra_1.Vec3.set(tmpEnd, min[0], max[1], max[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpEnd, max[0], min[1], max[2]);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpStart, min[0], max[1], min[2]);
    sphere_1.addSphere(state, tmpStart, radius, detail);
    linear_algebra_1.Vec3.set(tmpEnd, max[0], max[1], min[2]);
    sphere_1.addSphere(state, tmpEnd, radius, detail);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
    linear_algebra_1.Vec3.set(tmpEnd, min[0], max[1], max[2]);
    sphere_1.addSphere(state, tmpEnd, radius, detail);
    cylinder_1.addCylinder(state, tmpStart, tmpEnd, 1, cylinderProps);
}
exports.addBoundingBox = addBoundingBox;
