/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { ValueCell } from '../../mol-util/value-cell';
import { Vec2 } from '../../mol-math/linear-algebra';
import { TextureImage } from '../../mol-gl/renderable/util';
import { Transparency } from '../../mol-theme/transparency';
export declare type TransparencyData = {
    tTransparency: ValueCell<TextureImage<Uint8Array>>;
    uTransparencyTexDim: ValueCell<Vec2>;
    dTransparency: ValueCell<boolean>;
    dTransparencyVariant: ValueCell<string>;
};
export declare function applyTransparencyValue(array: Uint8Array, start: number, end: number, value: number): boolean;
export declare function clearTransparency(array: Uint8Array, start: number, end: number): void;
export declare function createTransparency(count: number, variant: Transparency.Variant, transparencyData?: TransparencyData): TransparencyData;
export declare function createEmptyTransparency(transparencyData?: TransparencyData): TransparencyData;
