"use strict";
/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Create 3d points for a polygon:
 * 3 for a triangle, 4 for a rectangle, 5 for a pentagon, 6 for a hexagon...
 */
function polygon(sideCount, shift) {
    var points = new Float32Array(sideCount * 3);
    var radius = sideCount <= 4 ? Math.sqrt(2) / 2 : 0.6;
    var offset = shift ? 1 : 0;
    for (var i = 0, il = sideCount; i < il; ++i) {
        var c = (i * 2 + offset) / sideCount * Math.PI;
        points[i * 3] = Math.cos(c) * radius;
        points[i * 3 + 1] = Math.sin(c) * radius;
        points[i * 3 + 2] = 0;
    }
    return points;
}
exports.polygon = polygon;
