"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var primitive_1 = require("./primitive");
var cage_1 = require("./cage");
exports.tetrahedronVertices = [
    0.7071, 0, 0, -0.3535, 0.6123, 0, -0.3535, -0.6123, 0,
    0, 0, 0.7071, 0, 0, -0.7071
];
exports.tetrahedronIndices = [
    4, 1, 0, 4, 2, 1, 4, 0, 2,
    0, 1, 3, 1, 2, 3, 2, 0, 3,
];
var tetrahedronEdges = [
    0, 1, 1, 2, 2, 0,
    0, 3, 1, 3, 2, 3,
    0, 4, 1, 4, 2, 4,
];
var tetrahedron;
function Tetrahedron() {
    if (!tetrahedron)
        tetrahedron = primitive_1.createPrimitive(exports.tetrahedronVertices, exports.tetrahedronIndices);
    return tetrahedron;
}
exports.Tetrahedron = Tetrahedron;
var tetrahedronCage = cage_1.createCage(exports.tetrahedronVertices, tetrahedronEdges);
function TetrahedronCage() {
    return tetrahedronCage;
}
exports.TetrahedronCage = TetrahedronCage;
