/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Mat4, Mat3 } from '../mol-math/linear-algebra';
import { NumberArray } from '../mol-util/type-helpers';
export declare function normalizeVec3Array<T extends NumberArray>(a: T): void;
export declare function getNormalMatrix(out: Mat3, t: Mat4): Mat3;
export declare function transformPositionArray(t: Mat4, array: NumberArray, offset: number, count: number): void;
export declare function transformDirectionArray(n: Mat3, array: NumberArray, offset: number, count: number): void;
export declare function setArrayZero(array: NumberArray): void;
/** iterate over the entire buffer and apply the radius to each vertex */
export declare function appplyRadius(vertices: NumberArray, radius: number): void;
/**
 * indexed vertex normals weighted by triangle areas http://www.iquilezles.org/www/articles/normals/normals.htm
 * normal array must contain only zeros
 */
export declare function computeIndexedVertexNormals<T extends NumberArray>(vertices: NumberArray, indices: NumberArray, normals: T): T;
/** vertex normals for unindexed triangle soup, normal array must contain only zeros */
export declare function computeVertexNormals<T extends NumberArray>(vertices: NumberArray, normals: T): T;
