/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Iterator } from '../../mol-data';
import { Location } from '../../mol-model/location';
export interface LocationValue {
    location: Location;
    index: number;
    groupIndex: number;
    instanceIndex: number;
    isSecondary: boolean;
}
export declare const NullLocationValue: LocationValue;
export interface LocationIterator extends Iterator<LocationValue> {
    readonly hasNext: boolean;
    readonly isNextNewInstance: boolean;
    readonly groupCount: number;
    readonly instanceCount: number;
    readonly count: number;
    /** If true, may have multiple units per instance; if false one unit per instance */
    readonly isComplex: boolean;
    move(): LocationValue;
    reset(): void;
    skipInstance(): void;
}
declare type LocationGetter = (groupIndex: number, instanceIndex: number) => Location;
declare type IsSecondaryGetter = (groupIndex: number, instanceIndex: number) => boolean;
export declare function LocationIterator(groupCount: number, instanceCount: number, getLocation: LocationGetter, isComplex?: boolean, isSecondary?: IsSecondaryGetter): LocationIterator;
export {};
