"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../renderable/util");
describe('renderable', function () {
    it('calculateBoundingSphere', function () {
        var position = new Float32Array([
            0, 0, 0,
            1, 0, 0
        ]);
        var transform = new Float32Array([
            1, 0, 0, 0,
            0, 1, 0, 0,
            0, 0, 1, 0,
            0, 0, 0, 0,
            1, 0, 0, 0,
            0, 1, 0, 0,
            0, 0, 1, 0,
            1, 0, 0, 0,
            1, 0, 0, 0,
            0, 1, 0, 0,
            0, 0, 1, 0,
            2, 0, 0, 0
        ]);
        var boundingSphere = util_1.calculateBoundingSphere(position, position.length / 3, transform, transform.length / 16).boundingSphere;
        expect(boundingSphere.radius).toBe(1.5);
        expect(boundingSphere.center).toEqual([1.5, 0.0, 0.0]);
    });
});
