"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var renderable_1 = require("../renderable");
var render_item_1 = require("../webgl/render-item");
var schema_1 = require("./schema");
var shader_code_1 = require("../shader-code");
var mol_util_1 = require("../../mol-util");
exports.SpheresSchema = __assign({}, schema_1.BaseSchema, schema_1.SizeSchema, { aPosition: schema_1.AttributeSpec('float32', 3, 0), aMapping: schema_1.AttributeSpec('float32', 2, 0), elements: schema_1.ElementsSpec('uint32'), padding: schema_1.ValueSpec('number'), dDoubleSided: schema_1.DefineSpec('boolean') });
function SpheresRenderable(ctx, id, values, state, materialId) {
    var schema = __assign({}, schema_1.GlobalUniformSchema, schema_1.InternalSchema, exports.SpheresSchema);
    var internalValues = {
        uObjectId: mol_util_1.ValueCell.create(id),
        uPickable: mol_util_1.ValueCell.create(state.pickable ? 1 : 0)
    };
    var shaderCode = shader_code_1.SpheresShaderCode;
    var renderItem = render_item_1.createGraphicsRenderItem(ctx, 'triangles', shaderCode, schema, __assign({}, values, internalValues), materialId);
    return renderable_1.createRenderable(renderItem, values, state);
}
exports.SpheresRenderable = SpheresRenderable;
