/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Renderable } from './renderable';
import { WebGLContext } from './webgl/context';
import { RenderableValues, BaseValues } from './renderable/schema';
import { GraphicsRenderObject } from './render-object';
import { Object3D } from './object3d';
import { Sphere3D } from '../mol-math/geometry';
interface Scene extends Object3D {
    readonly count: number;
    readonly renderables: ReadonlyArray<Renderable<RenderableValues & BaseValues>>;
    readonly boundingSphere: Sphere3D;
    update: (objects: ArrayLike<GraphicsRenderObject> | undefined, keepBoundingSphere: boolean) => void;
    add: (o: GraphicsRenderObject) => Renderable<any>;
    remove: (o: GraphicsRenderObject) => void;
    has: (o: GraphicsRenderObject) => boolean;
    clear: () => void;
    forEach: (callbackFn: (value: Renderable<RenderableValues & BaseValues>, key: GraphicsRenderObject) => void) => void;
}
declare namespace Scene {
    function create(ctx: WebGLContext): Scene;
}
export default Scene;
