"use strict";
/**
 * Copyright (c) 2017-2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author Michael Krone <michael.krone@uni-tuebingen.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = "\nprecision highp float;\n\nattribute vec3 aPosition;\nattribute mat4 aTransform;\nattribute float aInstance;\n\nvarying vec3 unitCoord;\nvarying vec3 origPos;\nvarying float instance;\n\nuniform vec3 uBboxSize;\nuniform vec3 uBboxMin;\nuniform vec3 uBboxMax;\nuniform vec3 uGridDim;\nuniform mat4 uTransform;\n\nuniform mat4 uModelView;\nuniform mat4 uProjection;\n\nvoid main() {\n    unitCoord = aPosition + vec3(0.5);\n    vec4 mvPosition = uModelView * uTransform * vec4(unitCoord * uGridDim, 1.0);\n    origPos = unitCoord * uBboxSize + uBboxMin;\n    instance = aInstance;\n    gl_Position = uProjection * mvPosition;\n\n    // clamp z position to clip space\n    if(gl_Position.z > gl_Position.w) {\n        gl_Position.z = gl_Position.w - 0.0001;\n    } else if(gl_Position.z < -gl_Position.w) {\n        gl_Position.z = -gl_Position.w + 0.0001;\n    }\n}\n";
