/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
declare const _default: "\nprecision highp float;\nprecision highp int;\n\n#include common\n#include common_frag_params\n#include color_frag_params\n\n#ifdef dPointFilledCircle\n    uniform float uPointEdgeBleach;\n#endif\n\nconst vec2 center = vec2(0.5);\nconst float radius = 0.5;\n\nvoid main(){\n    #include assign_material_color\n\n    #if defined(dColorType_objectPicking) || defined(dColorType_instancePicking) || defined(dColorType_groupPicking)\n        if (uAlpha < uPickingAlphaThreshold)\n            discard; // ignore so the element below can be picked\n        gl_FragColor = material;\n    #elif defined(dColorType_depth)\n        gl_FragColor = material;\n    #else\n        gl_FragColor = material;\n\n        #ifdef dPointFilledCircle\n            float dist = distance(gl_PointCoord, center);\n            float alpha = 1.0 - smoothstep(radius - uPointEdgeBleach, radius, dist);\n            if (alpha < 0.0001) discard;\n            gl_FragColor.a *= alpha;\n        #endif\n\n        #include apply_marker_color\n        #include apply_fog\n    #endif\n}\n";
export default _default;
