/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { WebGLStats } from './context';
import { ReferenceCache } from '../../mol-util/reference-cache';
import { GLRenderingContext } from './compat';
export declare function checkFramebufferStatus(gl: GLRenderingContext): void;
export interface Framebuffer {
    readonly id: number;
    bind: () => void;
    destroy: () => void;
}
export declare function createFramebuffer(gl: GLRenderingContext, stats: WebGLStats): Framebuffer;
export declare type FramebufferCache = ReferenceCache<Framebuffer, string>;
export declare function createFramebufferCache(gl: GLRenderingContext, stats: WebGLStats): FramebufferCache;
