/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { WebGLContext } from './context';
import { Texture } from './texture';
import { Framebuffer } from './framebuffer';
import { TextureImage } from '../renderable/util';
import { PixelData } from '../../mol-util/image';
export interface RenderTarget {
    readonly id: number;
    readonly width: number;
    readonly height: number;
    readonly image: TextureImage<any>;
    readonly texture: Texture;
    readonly framebuffer: Framebuffer;
    /** binds framebuffer and sets viewport to rendertarget's width and height */
    bind: () => void;
    setSize: (width: number, height: number) => void;
    readBuffer: (x: number, y: number, width: number, height: number, dst: Uint8Array) => void;
    getBuffer: () => Uint8Array;
    getPixelData: () => PixelData;
    destroy: () => void;
}
export declare function createRenderTarget(ctx: WebGLContext, _width: number, _height: number): RenderTarget;
