/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { WebGLContext } from './context';
export declare type RenderbufferFormat = 'depth16' | 'stencil8' | 'rgba4' | 'depth-stencil';
export declare type RenderbufferAttachment = 'depth' | 'stencil' | 'depth-stencil' | 'color0';
export declare function getFormat(ctx: WebGLContext, format: RenderbufferFormat): number;
export declare function getAttachment(ctx: WebGLContext, attachment: RenderbufferAttachment): number;
export interface Renderbuffer {
    readonly id: number;
    bind: () => void;
    setSize: (width: number, height: number) => void;
    destroy: () => void;
}
export declare function createRenderbuffer(ctx: WebGLContext, format: RenderbufferFormat, attachment: RenderbufferAttachment, _width: number, _height: number): Renderbuffer;
