/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { ReferenceCache } from '../../mol-util/reference-cache';
import { GLRenderingContext } from './compat';
export declare type ShaderType = 'vert' | 'frag';
export interface ShaderProps {
    type: ShaderType;
    source: string;
}
export interface Shader {
    readonly id: number;
    attach: (program: WebGLProgram) => void;
    destroy: () => void;
}
export declare type ShaderCache = ReferenceCache<Shader, ShaderProps>;
export declare function createShaderCache(gl: GLRenderingContext): ShaderCache;
