/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Mat3, Mat4, Vec2, Vec3, Vec4 } from '../../mol-math/linear-algebra';
import { ValueCell } from '../../mol-util';
import { GLRenderingContext } from './compat';
import { RenderableSchema } from '../../mol-gl/renderable/schema';
export declare type UniformKindValue = {
    'f': number;
    'i': number;
    'v2': Vec2;
    'v3': Vec3;
    'v4': Vec4;
    'm3': Mat3;
    'm4': Mat4;
    't': number;
};
export declare type UniformKind = keyof UniformKindValue;
export declare type UniformType = number | Vec2 | Vec3 | Vec4 | Mat3 | Mat4;
export declare type UniformValues = {
    [k: string]: ValueCell<UniformType>;
};
export declare type UniformsList = [string, ValueCell<UniformType>][];
export declare function getUniformType(gl: GLRenderingContext, kind: UniformKind): number | undefined;
export declare function setUniform(gl: GLRenderingContext, location: WebGLUniformLocation | null, kind: UniformKind, value: any): void;
export declare type UniformSetter = (gl: GLRenderingContext, location: number, value: any) => void;
export declare type UniformSetters = {
    [k: string]: UniformSetter;
};
export declare function getUniformSetters(schema: RenderableSchema): UniformSetters;
