"use strict";
/**
 * Copyright (c) 2017-2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var parser_1 = require("./cif/text/parser");
var parser_2 = require("./cif/binary/parser");
var schema_1 = require("./cif/schema");
var mmcif_1 = require("./cif/schema/mmcif");
var ccd_1 = require("./cif/schema/ccd");
var bird_1 = require("./cif/schema/bird");
var dic_1 = require("./cif/schema/dic");
var density_server_1 = require("./cif/schema/density-server");
exports.CIF = {
    parse: function (data) { return typeof data === 'string' ? parser_1.default(data) : parser_2.default(data); },
    parseText: parser_1.default,
    parseBinary: parser_2.default,
    toDatabaseCollection: schema_1.toDatabaseCollection,
    toDatabase: schema_1.toDatabase,
    schema: {
        mmCIF: function (frame) { return schema_1.toDatabase(mmcif_1.mmCIF_Schema, frame); },
        CCD: function (frame) { return schema_1.toDatabase(ccd_1.CCD_Schema, frame); },
        BIRD: function (frame) { return schema_1.toDatabase(bird_1.BIRD_Schema, frame); },
        dic: function (frame) { return schema_1.toDatabase(dic_1.dic_Schema, frame); },
        densityServer: function (frame) { return schema_1.toDatabase(density_server_1.DensityServer_Data_Schema, frame); }
    }
};
__export(require("./cif/data-model"));
