/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Column } from '../../../../mol-data/db';
export declare const mmCIF_residueId_schema: {
    label_comp_id: Column.Schema.Str;
    label_seq_id: Column.Schema.Int;
    pdbx_PDB_ins_code: Column.Schema.Str;
    label_asym_id: Column.Schema.Str;
    label_entity_id: Column.Schema.Str;
    auth_comp_id: Column.Schema.Str;
    auth_seq_id: Column.Schema.Int;
    auth_asym_id: Column.Schema.Str;
};
export declare const mmCIF_chemCompBond_schema: {
    /** Indicates if the bond entry was taken from the protonation variant dictionary */
    molstar_protonation_variant: Column.Schema.Str;
    atom_id_1: Column.Schema.Str;
    atom_id_2: Column.Schema.Str;
    comp_id: Column.Schema.Str;
    value_order: Column.Schema.Aliased<"sing" | "doub" | "trip" | "quad" | "arom" | "poly" | "delo" | "pi">;
    pdbx_ordinal: Column.Schema.Int;
    pdbx_stereo_config: Column.Schema.Aliased<"E" | "Z" | "N">;
    pdbx_aromatic_flag: Column.Schema.Aliased<"N" | "Y">;
};
