"use strict";
/**
 * Copyright (c) 2017-2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Zepei Xu <xuzepei19950617@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
//               NOTES
// When want to created undefined string column, must use
// undefStr = UndefinedColumn(molecule.num_atoms, ColumnType.str)
// but not
// const undefPooledStr = UndefinedColumn(molecule.num_atoms, ColumnType.pooledStr);
// because latter actuall return a column of zeros
var db_1 = require("../../../mol-data/db");
var tokenizer_1 = require("../common/text/tokenizer");
var token_1 = require("../common/text/column/token");
var result_1 = require("../result");
var mol_task_1 = require("../../../mol-task");
var skipWhitespace = tokenizer_1.Tokenizer.skipWhitespace, eatValue = tokenizer_1.Tokenizer.eatValue, markLine = tokenizer_1.Tokenizer.markLine, getTokenString = tokenizer_1.Tokenizer.getTokenString, readLine = tokenizer_1.Tokenizer.readLine;
function createEmptyMolecule() {
    return {
        mol_name: '',
        num_atoms: 0,
        num_bonds: 0,
        num_subst: 0,
        num_feat: 0,
        num_sets: 0,
        mol_type: '',
        charge_type: '',
        status_bits: '',
        mol_comment: ''
    };
}
function State(tokenizer, runtimeCtx) {
    return {
        tokenizer: tokenizer,
        molecule: createEmptyMolecule(),
        runtimeCtx: runtimeCtx
    };
}
var reWhitespace = /\s+/g;
function handleMolecule(state) {
    var tokenizer = state.tokenizer, molecule = state.molecule;
    while (getTokenString(tokenizer) !== '@<TRIPOS>MOLECULE') {
        markLine(tokenizer);
    }
    markLine(tokenizer);
    molecule.mol_name = getTokenString(tokenizer);
    markLine(tokenizer);
    var values = getTokenString(tokenizer).trim().split(reWhitespace);
    molecule.num_atoms = parseInt(values[0]);
    molecule.num_bonds = parseInt(values[1]);
    molecule.num_subst = parseInt(values[2]);
    molecule.num_feat = parseInt(values[3]);
    molecule.num_sets = parseInt(values[4]);
    markLine(tokenizer);
    molecule.mol_type = getTokenString(tokenizer);
    markLine(tokenizer);
    molecule.charge_type = getTokenString(tokenizer);
    markLine(tokenizer);
    if (getTokenString(tokenizer) === '')
        return;
    molecule.status_bits = getTokenString(tokenizer);
    markLine(tokenizer);
    if (getTokenString(tokenizer) === '')
        return;
    molecule.mol_comment = getTokenString(tokenizer);
}
function isStatus_bit(aString) {
    if (aString.includes('DSPMOD') || aString.includes('TYPECOL') || aString.includes('CAP')
        || aString.includes('BACKBONE') || aString.includes('DICT') || aString.includes('ESSENTIAL')
        || aString.includes('WATER') || aString.includes('DIRECT')) {
        return true;
    }
    return false;
}
function handleAtoms(state) {
    return __awaiter(this, void 0, void 0, function () {
        var tokenizer, molecule, hasSubst_id, hasSubst_name, hasCharge, hasStatus_bit, initialTokenizerPosition, initialTokenizerLineNumber, firstLine, firstLineArray, firstLineLength, i, atom_idTokens, atom_nameTokens, xTokens, yTokens, zTokens, atom_typeTokens, atom_idTokenColumn, atom_nameTokenColumn, xTokenColumn, yTokenColumn, zTokenColumn, atom_typeColumn, subst_idTokens, subst_nameTokens, chargeTokens, status_bitTokens, subst_idTokenColumn, subst_nameTokenColumn, chargeTokenColumn, status_bitTokenColumn, undefFloat, undefInt, undefStr, numOfColumn, length, linesAlreadyRead, ret;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tokenizer = state.tokenizer, molecule = state.molecule;
                    hasSubst_id = false;
                    hasSubst_name = false;
                    hasCharge = false;
                    hasStatus_bit = false;
                    // skip empty lines and '@<TRIPOS>ATOM'
                    while (getTokenString(tokenizer) !== '@<TRIPOS>ATOM') {
                        markLine(tokenizer);
                    }
                    initialTokenizerPosition = tokenizer.position;
                    initialTokenizerLineNumber = tokenizer.lineNumber;
                    firstLine = readLine(tokenizer);
                    firstLineArray = firstLine.trim().split(/\s+/g);
                    firstLineLength = firstLineArray.length;
                    // optional columns are in order "integer string float string".
                    // Use this to find out which column is missing or empty
                    for (i = 6; i < firstLineLength; i++) {
                        if (!isNaN(Number(firstLineArray[i]))) {
                            if (firstLineArray[i].indexOf('.') === -1) {
                                hasSubst_id = true;
                            }
                            else {
                                hasCharge = true;
                            }
                        }
                        else if (isNaN(Number(firstLineArray[i]))) {
                            if (!isStatus_bit(firstLineArray[i])) {
                                hasSubst_name = true;
                            }
                            else {
                                hasStatus_bit = true;
                            }
                        }
                    }
                    atom_idTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    atom_nameTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    xTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    yTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    zTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    atom_typeTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    atom_idTokenColumn = token_1.default(atom_idTokens);
                    atom_nameTokenColumn = token_1.default(atom_nameTokens);
                    xTokenColumn = token_1.default(xTokens);
                    yTokenColumn = token_1.default(yTokens);
                    zTokenColumn = token_1.default(zTokens);
                    atom_typeColumn = token_1.default(atom_typeTokens);
                    subst_idTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    subst_nameTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    chargeTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    status_bitTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_atoms * 2);
                    subst_idTokenColumn = token_1.default(subst_idTokens);
                    subst_nameTokenColumn = token_1.default(subst_nameTokens);
                    chargeTokenColumn = token_1.default(chargeTokens);
                    status_bitTokenColumn = token_1.default(status_bitTokens);
                    undefFloat = db_1.Column.Undefined(molecule.num_atoms, db_1.Column.Schema.float);
                    undefInt = db_1.Column.Undefined(molecule.num_atoms, db_1.Column.Schema.int);
                    undefStr = db_1.Column.Undefined(molecule.num_atoms, db_1.Column.Schema.str);
                    numOfColumn = 6;
                    if (hasSubst_id) {
                        numOfColumn++;
                    }
                    if (hasSubst_name) {
                        numOfColumn++;
                    }
                    if (hasCharge) {
                        numOfColumn++;
                    }
                    if (hasStatus_bit) {
                        numOfColumn++;
                    }
                    tokenizer.position = initialTokenizerPosition;
                    tokenizer.lineNumber = initialTokenizerLineNumber;
                    length = tokenizer.length;
                    linesAlreadyRead = 0;
                    return [4 /*yield*/, mol_task_1.chunkedSubtask(state.runtimeCtx, 100000, void 0, function (chunkSize) {
                            var linesToRead = Math.min(molecule.num_atoms - linesAlreadyRead, chunkSize);
                            for (var i = 0; i < linesToRead; i++) {
                                var subst_idWritten = false;
                                var subst_nameWritten = false;
                                var chargeWritten = false;
                                var status_bitWritten = false;
                                for (var j = 0; j < numOfColumn; j++) {
                                    skipWhitespace(tokenizer);
                                    tokenizer.tokenStart = tokenizer.position;
                                    eatValue(tokenizer);
                                    switch (j) {
                                        case 0:
                                            tokenizer_1.TokenBuilder.addUnchecked(atom_idTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        case 1:
                                            tokenizer_1.TokenBuilder.addUnchecked(atom_nameTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        case 2:
                                            tokenizer_1.TokenBuilder.addUnchecked(xTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        case 3:
                                            tokenizer_1.TokenBuilder.addUnchecked(yTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        case 4:
                                            tokenizer_1.TokenBuilder.addUnchecked(zTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        case 5:
                                            tokenizer_1.TokenBuilder.addUnchecked(atom_typeTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        default:
                                            if (hasSubst_id === true && subst_idWritten === false) {
                                                tokenizer_1.TokenBuilder.addUnchecked(subst_idTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                                subst_idWritten = true;
                                            }
                                            else if (hasSubst_name === true && subst_nameWritten === false) {
                                                tokenizer_1.TokenBuilder.addUnchecked(subst_nameTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                                subst_nameWritten = true;
                                            }
                                            else if (hasCharge === true && chargeWritten === false) {
                                                tokenizer_1.TokenBuilder.addUnchecked(chargeTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                                chargeWritten = true;
                                            }
                                            else if (hasStatus_bit === true && status_bitWritten === false) {
                                                tokenizer_1.TokenBuilder.addUnchecked(status_bitTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                                status_bitWritten = true;
                                            }
                                    }
                                }
                            }
                            linesAlreadyRead += linesToRead;
                            return linesToRead;
                        }, function (ctx) { return ctx.update({ message: 'Parsing...', current: tokenizer.position, max: length }); })];
                case 1:
                    _a.sent();
                    ret = {
                        count: molecule.num_atoms,
                        atom_id: atom_idTokenColumn(db_1.Column.Schema.int),
                        atom_name: atom_nameTokenColumn(db_1.Column.Schema.str),
                        x: xTokenColumn(db_1.Column.Schema.float),
                        y: yTokenColumn(db_1.Column.Schema.float),
                        z: zTokenColumn(db_1.Column.Schema.float),
                        atom_type: atom_typeColumn(db_1.Column.Schema.str),
                        // optional columns
                        subst_id: hasSubst_id ? subst_idTokenColumn(db_1.Column.Schema.int) : undefInt,
                        subst_name: hasSubst_name ? subst_nameTokenColumn(db_1.Column.Schema.str) : undefStr,
                        charge: hasCharge ? chargeTokenColumn(db_1.Column.Schema.float) : undefFloat,
                        status_bit: hasStatus_bit ? status_bitTokenColumn(db_1.Column.Schema.str) : undefStr,
                    };
                    return [2 /*return*/, ret];
            }
        });
    });
}
function handleBonds(state) {
    return __awaiter(this, void 0, void 0, function () {
        var tokenizer, molecule, hasStatus_bit, initialTokenizerPosition, initialTokenizerLineNumber, firstLine, firstLineArray, firstLineLength, bond_idTokens, origin_bond_idTokens, target_bond_idTokens, bondTypeTokens, bond_idTokenColumn, origin_bond_idTokenColumn, target_bond_idTokenColumn, bondTypeTokenColumn, status_bitTokens, status_bitTokenColumn, undefStr, numberOfColumn, length, linesAlreadyRead, ret;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tokenizer = state.tokenizer, molecule = state.molecule;
                    hasStatus_bit = false;
                    while (getTokenString(tokenizer) !== '@<TRIPOS>BOND') {
                        markLine(tokenizer);
                    }
                    initialTokenizerPosition = tokenizer.position;
                    initialTokenizerLineNumber = tokenizer.lineNumber;
                    firstLine = readLine(tokenizer);
                    firstLineArray = firstLine.trim().split(/\s+/g);
                    firstLineLength = firstLineArray.length;
                    if (firstLineLength === 5) {
                        hasStatus_bit = true;
                    }
                    bond_idTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_bonds * 2);
                    origin_bond_idTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_bonds * 2);
                    target_bond_idTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_bonds * 2);
                    bondTypeTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_bonds * 2);
                    bond_idTokenColumn = token_1.default(bond_idTokens);
                    origin_bond_idTokenColumn = token_1.default(origin_bond_idTokens);
                    target_bond_idTokenColumn = token_1.default(target_bond_idTokens);
                    bondTypeTokenColumn = token_1.default(bondTypeTokens);
                    status_bitTokens = tokenizer_1.TokenBuilder.create(tokenizer.data, molecule.num_bonds * 2);
                    status_bitTokenColumn = token_1.default(status_bitTokens);
                    undefStr = db_1.Column.Undefined(molecule.num_bonds, db_1.Column.Schema.str);
                    numberOfColumn = 4;
                    if (hasStatus_bit) {
                        numberOfColumn++;
                    }
                    tokenizer.position = initialTokenizerPosition;
                    tokenizer.lineNumber = initialTokenizerLineNumber;
                    length = tokenizer.length;
                    linesAlreadyRead = 0;
                    return [4 /*yield*/, mol_task_1.chunkedSubtask(state.runtimeCtx, 100000, void 0, function (chunkSize) {
                            var linesToRead = Math.min(molecule.num_bonds - linesAlreadyRead, chunkSize);
                            for (var i = 0; i < linesToRead; i++) {
                                for (var j = 0; j < numberOfColumn; j++) {
                                    skipWhitespace(tokenizer);
                                    tokenizer.tokenStart = tokenizer.position;
                                    eatValue(tokenizer);
                                    switch (j) {
                                        case 0:
                                            tokenizer_1.TokenBuilder.addUnchecked(bond_idTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        case 1:
                                            tokenizer_1.TokenBuilder.addUnchecked(origin_bond_idTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        case 2:
                                            tokenizer_1.TokenBuilder.addUnchecked(target_bond_idTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        case 3:
                                            tokenizer_1.TokenBuilder.addUnchecked(bondTypeTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                        default:
                                            tokenizer_1.TokenBuilder.addUnchecked(status_bitTokens, tokenizer.tokenStart, tokenizer.tokenEnd);
                                            break;
                                    }
                                }
                            }
                            linesAlreadyRead += linesToRead;
                            return linesToRead;
                        }, function (ctx) { return ctx.update({ message: 'Parsing...', current: tokenizer.position, max: length }); })];
                case 1:
                    _a.sent();
                    ret = {
                        count: molecule.num_bonds,
                        bond_id: bond_idTokenColumn(db_1.Column.Schema.int),
                        origin_atom_id: origin_bond_idTokenColumn(db_1.Column.Schema.int),
                        target_atom_id: target_bond_idTokenColumn(db_1.Column.Schema.int),
                        bond_type: bondTypeTokenColumn(db_1.Column.Schema.str),
                        // optional columns
                        status_bits: hasStatus_bit ? status_bitTokenColumn(db_1.Column.Schema.str) : undefStr,
                    };
                    return [2 /*return*/, ret];
            }
        });
    });
}
function parseInternal(data, ctx) {
    return __awaiter(this, void 0, void 0, function () {
        var tokenizer, structures, state, atoms, bonds, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tokenizer = tokenizer_1.Tokenizer(data);
                    ctx.update({ message: 'Parsing...', current: 0, max: data.length });
                    structures = [];
                    _a.label = 1;
                case 1:
                    if (!(tokenizer.position < data.length)) return [3 /*break*/, 4];
                    state = State(tokenizer, ctx);
                    handleMolecule(state);
                    return [4 /*yield*/, handleAtoms(state)];
                case 2:
                    atoms = _a.sent();
                    return [4 /*yield*/, handleBonds(state)];
                case 3:
                    bonds = _a.sent();
                    structures.push({ molecule: state.molecule, atoms: atoms, bonds: bonds });
                    return [3 /*break*/, 1];
                case 4:
                    result = { structures: structures };
                    return [2 /*return*/, result_1.ReaderResult.success(result)];
            }
        });
    });
}
function parse(data) {
    var _this = this;
    return mol_task_1.Task.create('Parse MOL2', function (ctx) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, parseInternal(data, ctx)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    }); });
}
exports.parse = parse;
exports.default = parse;
