/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { Vec3 } from '../../mol-math/linear-algebra/3d';
import { Box3D } from './primitives/box3d';
import { Sphere3D } from './primitives/sphere3d';
/**
 * Usage:
 *
 * 1. .reset(tolerance); tolerance plays part in the "extend" step
 * 2. for each point/sphere call boundaryStep()
 * 3. .finishBoundaryStep
 * 4. for each point/sphere call extendStep
 * 5. use .center/.radius or call getSphere/getBox
 */
export declare class BoundaryHelper {
    private count;
    private extremes;
    private u;
    private v;
    tolerance: number;
    center: Vec3;
    radius: number;
    reset(tolerance: number): void;
    boundaryStep(p: Vec3, r: number): void;
    finishBoundaryStep(): void;
    extendStep(p: Vec3, r: number): void;
    getBox(): Box3D;
    getSphere(): Sphere3D;
    constructor();
}
