/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Box3D } from '../geometry';
import { RuntimeContext, Task } from '../../mol-task';
import { PositionData, DensityData } from './common';
import { WebGLContext } from '../../mol-gl/webgl/context';
import { Texture } from '../../mol-gl/webgl/texture';
export declare const DefaultGaussianDensityGPUProps: {
    resolution: number;
    radiusOffset: number;
    smoothness: number;
};
export declare type GaussianDensityGPUProps = typeof DefaultGaussianDensityGPUProps;
export declare const DefaultGaussianDensityProps: {
    useGpu: boolean;
    resolution: number;
    radiusOffset: number;
    smoothness: number;
};
export declare type GaussianDensityProps = typeof DefaultGaussianDensityProps;
export declare function computeGaussianDensity(position: PositionData, box: Box3D, radius: (index: number) => number, props: GaussianDensityProps, webgl?: WebGLContext): Task<DensityData>;
export declare function GaussianDensity(ctx: RuntimeContext, position: PositionData, box: Box3D, radius: (index: number) => number, props: GaussianDensityProps, webgl?: WebGLContext): Promise<DensityData>;
export declare function computeGaussianDensityTexture(position: PositionData, box: Box3D, radius: (index: number) => number, props: GaussianDensityGPUProps, webgl: WebGLContext, texture?: Texture): Task<import("./common").DensityTextureData>;
export declare function computeGaussianDensityTexture2d(position: PositionData, box: Box3D, radius: (index: number) => number, props: GaussianDensityGPUProps, webgl: WebGLContext, texture?: Texture): Task<import("./common").DensityTextureData>;
export declare function computeGaussianDensityTexture3d(position: PositionData, box: Box3D, radius: (index: number) => number, props: GaussianDensityGPUProps, webgl: WebGLContext, texture?: Texture): Task<import("./common").DensityTextureData>;
