/**
 * Copyright (c) 2017-2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { Column } from '../../../mol-data/db';
import { mmCIF_Database } from '../../../mol-io/reader/cif/schema/mmcif';
import { Model } from '../../../mol-model/structure/model/model';
import { AtomicConformation, AtomicHierarchy } from '../../../mol-model/structure/model/properties/atomic';
import { Entities } from '../../../mol-model/structure/model/properties/common';
import { FormatData } from './parser';
declare type AtomSite = mmCIF_Database['atom_site'];
export declare function getAtomicHierarchyAndConformation(atom_site: AtomSite, sourceIndex: Column<number>, entities: Entities, formatData: FormatData, previous?: Model): {
    sameAsPrevious: boolean;
    hierarchy: AtomicHierarchy;
    conformation: AtomicConformation;
};
export {};
