/**
 * Copyright (c) 2017-2018 Mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Model } from '../../../../mol-model/structure/model/model';
import { CustomPropertyDescriptor } from '../../../../mol-model/structure';
import { mmCIF_Database } from '../../../../mol-io/reader/cif/schema/mmcif';
export interface ComponentBond {
    entries: Map<string, ComponentBond.Entry>;
}
export declare namespace ComponentBond {
    const Descriptor: CustomPropertyDescriptor;
    function attachFromMmCif(model: Model): boolean;
    function attachFromExternalData(model: Model, bonds: ComponentBond, force?: boolean): boolean;
    class ComponentBondImpl implements ComponentBond {
        entries: Map<string, ComponentBond.Entry>;
        addEntry(id: string): Entry;
    }
    class Entry {
        id: string;
        map: Map<string, Map<string, {
            order: number;
            flags: number;
        }>>;
        add(a: string, b: string, order: number, flags: number, swap?: boolean): void;
        constructor(id: string);
    }
    function parseChemCompBond(data: mmCIF_Database['chem_comp_bond']): ComponentBond;
    const PropName = "__ComponentBond__";
    function get(model: Model): ComponentBond | undefined;
}
