/**
 * Copyright (c) 2017-2018 Mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Model } from '../../../../mol-model/structure/model/model';
import { CustomPropertyDescriptor } from '../../../../mol-model/structure';
import { ElementIndex, ResidueIndex } from '../../../../mol-model/structure/model/indexing';
export interface StructConn {
    getResidueEntries(residueAIndex: ResidueIndex, residueBIndex: ResidueIndex): ReadonlyArray<StructConn.Entry>;
    getAtomEntries(atomIndex: ElementIndex): ReadonlyArray<StructConn.Entry>;
    readonly entries: ReadonlyArray<StructConn.Entry>;
}
export declare namespace StructConn {
    const Descriptor: CustomPropertyDescriptor;
    interface Entry {
        rowIndex: number;
        distance: number;
        order: number;
        flags: number;
        partners: {
            residueIndex: ResidueIndex;
            atomIndex: ElementIndex;
            symmetry: string;
        }[];
    }
    function attachFromMmCif(model: Model): boolean;
    const PropName = "__StructConn__";
    function get(model: Model): StructConn | undefined;
}
