/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { mmCIF_Database as mmCIF } from '../../../mol-io/reader/cif/schema/mmcif';
import { CoarseHierarchy, CoarseConformation } from '../../../mol-model/structure/model/properties/coarse';
import { Entities } from '../../../mol-model/structure/model/properties/common';
import { Column } from '../../../mol-data/db';
import { FormatData } from './parser';
export interface IHMData {
    model_id: number;
    model_name: string;
    model_group_name: string;
    entities: Entities;
    atom_site: mmCIF['atom_site'];
    atom_site_sourceIndex: Column<number>;
    ihm_sphere_obj_site: mmCIF['ihm_sphere_obj_site'];
    ihm_gaussian_obj_site: mmCIF['ihm_gaussian_obj_site'];
}
export declare const EmptyIHMCoarse: {
    hierarchy: CoarseHierarchy;
    conformation: any;
};
export declare function getIHMCoarse(data: IHMData, formatData: FormatData): {
    hierarchy: CoarseHierarchy;
    conformation: CoarseConformation;
};
