/**
 * Copyright (c) 2018 Mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Model } from '../../../../mol-model/structure/model/model';
import { Table } from '../../../../mol-data/db';
import { mmCIF_Schema } from '../../../../mol-io/reader/cif/schema/mmcif';
import { Unit } from '../../../../mol-model/structure';
import { ElementIndex } from '../../../../mol-model/structure/model/indexing';
export interface IHMCrossLinkRestraint {
    getIndicesByElement: (element: ElementIndex, kind: Unit.Kind) => number[];
    data: Table<mmCIF_Schema['ihm_cross_link_restraint']>;
}
export declare namespace IHMCrossLinkRestraint {
    const PropName = "__CrossLinkRestraint__";
    function fromModel(model: Model): IHMCrossLinkRestraint | undefined;
}
