/**
 * Copyright (c) 2017-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { RuntimeContext } from '../../../mol-task';
import { Model } from '../../../mol-model/structure/model/model';
import { ModelFormat } from '../format';
import mmCIF_Format = ModelFormat.mmCIF;
export declare function _parse_mmCif(format: mmCIF_Format, ctx: RuntimeContext): Promise<Model[]>;
export interface FormatData {
    modifiedResidues: Model['properties']['modifiedResidues'];
    missingResidues: Model['properties']['missingResidues'];
    chemicalComponentMap: Model['properties']['chemicalComponentMap'];
    saccharideComponentMap: Model['properties']['saccharideComponentMap'];
}
