/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { mmCIF_Database } from '../../../mol-io/reader/cif/schema/mmcif';
import { Column, Table } from '../../../mol-data/db';
import { RuntimeContext } from '../../../mol-task';
export declare type SortedAtomSite = mmCIF_Database['atom_site'] & {
    sourceIndex: Column<number>;
};
export declare function sortAtomSite(ctx: RuntimeContext, atom_site: mmCIF_Database['atom_site'], start: number, end: number): Promise<{
    atom_site: Table<{
        auth_asym_id: Column.Schema.Str;
        auth_atom_id: Column.Schema.Str;
        auth_comp_id: Column.Schema.Str;
        auth_seq_id: Column.Schema.Int;
        B_iso_or_equiv: Column.Schema.Float;
        Cartn_x: Column.Schema.Coordinate;
        Cartn_y: Column.Schema.Coordinate;
        Cartn_z: Column.Schema.Coordinate;
        group_PDB: Column.Schema.Aliased<"ATOM" | "HETATM">;
        id: Column.Schema.Int;
        label_alt_id: Column.Schema.Str;
        label_asym_id: Column.Schema.Str;
        label_atom_id: Column.Schema.Str;
        label_comp_id: Column.Schema.Str;
        label_entity_id: Column.Schema.Str;
        label_seq_id: Column.Schema.Int;
        occupancy: Column.Schema.Float;
        type_symbol: Column.Schema.Str;
        pdbx_PDB_ins_code: Column.Schema.Str;
        pdbx_PDB_model_num: Column.Schema.Int;
        pdbx_formal_charge: Column.Schema.Int;
        ihm_model_id: Column.Schema.Int;
    }>;
    sourceIndex: Column<number>;
}>;
