"use strict";
/**
 * Copyright (c) 2017-2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
function findEntityIdByAsymId(model, asymId) {
    if (model.sourceData.kind !== 'mmCIF')
        return '';
    var struct_asym = model.sourceData.data.struct_asym;
    for (var i = 0, n = struct_asym._rowCount; i < n; ++i) {
        if (struct_asym.id.value(i) === asymId)
            return struct_asym.entity_id.value(i);
    }
    return '';
}
exports.findEntityIdByAsymId = findEntityIdByAsymId;
function findAtomIndexByLabelName(model, residueIndex, atomName, altLoc) {
    var offsets = model.atomicHierarchy.residueAtomSegments.offsets;
    var _a = model.atomicHierarchy.atoms, label_atom_id = _a.label_atom_id, label_alt_id = _a.label_alt_id;
    for (var i = offsets[residueIndex], n = offsets[residueIndex + 1]; i < n; ++i) {
        if (label_atom_id.value(i) === atomName && (!altLoc || label_alt_id.value(i) === altLoc))
            return i;
    }
    return -1;
}
exports.findAtomIndexByLabelName = findAtomIndexByLabelName;
