/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { VolumeData } from '../../mol-model/volume/data';
import { Task } from '../../mol-task';
import { Vec3 } from '../../mol-math/linear-algebra';
import { Ccp4File, Ccp4Header } from '../../mol-io/reader/ccp4/schema';
/** When available (e.g. in MRC files) use ORIGIN records instead of N[CRS]START */
export declare function getCcp4Origin(header: Ccp4Header): number[];
export declare function volumeFromCcp4(source: Ccp4File, params?: {
    voxelSize?: Vec3;
}): Task<VolumeData>;
