/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { ElementIndex, Model } from '../../mol-model/structure';
import { StructureElement } from '../../mol-model/structure/structure';
import { CustomPropertyRegistry } from './custom-property-registry';
import { Task } from '../../mol-task';
import { ThemeProvider } from '../../mol-theme/theme';
import { ColorTheme } from '../../mol-theme/color';
import { Color } from '../../mol-util/color';
import { Loci } from '../../mol-model/loci';
export { CustomElementProperty };
declare namespace CustomElementProperty {
    interface CreateParams<T> {
        isStatic: boolean;
        name: string;
        autoAttach?: boolean;
        display: string;
        attachableTo?: (model: Model) => boolean;
        getData(model: Model): Map<ElementIndex, T> | Promise<Map<ElementIndex, T>>;
        format?(e: T): string | undefined;
        coloring?: {
            getColor: (e: T) => Color;
            defaultColor: Color;
        };
    }
    function create<T>(params: CreateParams<T>): {
        Descriptor: {
            isStatic: boolean;
            name: string;
        };
        attach: (model: Model) => Task<boolean>;
        get: (e: StructureElement<import("../../mol-model/structure/structure/unit").default>) => any;
        propertyProvider: CustomPropertyRegistry.Provider<Model>;
        colorTheme: ThemeProvider<ColorTheme<{}>, {}> | undefined;
        labelProvider: (loci: Loci) => string | undefined;
    };
}
