/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { CustomPropertyDescriptor, Model, Structure } from '../../mol-model/structure';
import { ParamDefinition } from '../../mol-util/param-definition';
import { Task } from '../../mol-task';
export { CustomPropertyRegistry };
declare class CustomPropertyRegistry<T = never> {
    private providers;
    getSelect(object: T): ParamDefinition.MultiSelect<string, string[]>;
    getDefault(object: T): string[];
    get(name: string): CustomPropertyRegistry.Provider<T>;
    register(provider: CustomPropertyRegistry.Provider<T>): void;
    unregister(name: string): void;
}
declare namespace CustomPropertyRegistry {
    interface Provider<T> {
        option: [string, string];
        defaultSelected: boolean;
        descriptor: CustomPropertyDescriptor<any, any>;
        attachableTo: (object: T) => boolean;
        attach: (object: T) => Task<boolean>;
    }
    type ModelProvider = Provider<Model>;
    type StructureProvider = Provider<Structure>;
}
