/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Structure } from '../../mol-model/structure';
import { Task } from '../../mol-task';
import { SecondaryStructure } from '../../mol-model/structure/model/properties/seconday-structure';
import { ParamDefinition as PD } from '../../mol-util/param-definition';
export declare namespace ComputedSecondaryStructure {
    type Property = {
        id: number;
        map: Map<number, SecondaryStructure>;
    };
    function get(structure: Structure): Property | undefined;
    function createAttachTask(params?: Partial<SecondaryStructureComputationProps>): (structure: Structure) => Task<boolean>;
    const Descriptor: {
        isStatic: true;
        name: string;
    };
    function attachFromCifOrCompute(structure: Structure, params?: Partial<SecondaryStructureComputationProps>): Promise<boolean>;
}
export declare const SecondaryStructureComputationParams: {
    oldDefinition: PD.BooleanParam;
    oldOrdering: PD.BooleanParam;
};
export declare type SecondaryStructureComputationParams = typeof SecondaryStructureComputationParams;
export declare type SecondaryStructureComputationProps = PD.Values<SecondaryStructureComputationParams>;
