"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var structure_1 = require("../../mol-model/structure");
var mol_task_1 = require("../../mol-task");
var dssp_1 = require("./secondary-structure/dssp");
var param_definition_1 = require("../../mol-util/param-definition");
var structure_2 = require("../../mol-model/structure/structure");
var id_factory_1 = require("../../mol-util/id-factory");
var nextSecondaryStructureId = id_factory_1.idFactory();
var ComputedSecondaryStructure;
(function (ComputedSecondaryStructure) {
    function get(structure) {
        return structure.inheritedPropertyData.__ComputedSecondaryStructure__;
    }
    ComputedSecondaryStructure.get = get;
    function set(structure, prop) {
        structure.inheritedPropertyData.__ComputedSecondaryStructure__ = prop;
    }
    function createAttachTask(params) {
        var _this = this;
        if (params === void 0) { params = {}; }
        return function (structure) { return mol_task_1.Task.create('Compute Secondary Structure', function (ctx) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (get(structure))
                            return [2 /*return*/, true];
                        return [4 /*yield*/, attachFromCifOrCompute(structure, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); }); };
    }
    ComputedSecondaryStructure.createAttachTask = createAttachTask;
    ComputedSecondaryStructure.Descriptor = structure_1.CustomPropertyDescriptor({
        isStatic: true,
        name: 'molstar_computed_secondary_structure',
    });
    function attachFromCifOrCompute(structure, params) {
        if (params === void 0) { params = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var compSecStruc;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (structure.customPropertyDescriptors.has(ComputedSecondaryStructure.Descriptor))
                            return [2 /*return*/, true];
                        return [4 /*yield*/, computeSecondaryStructure(structure, params)];
                    case 1:
                        compSecStruc = _a.sent();
                        structure.customPropertyDescriptors.add(ComputedSecondaryStructure.Descriptor);
                        set(structure, compSecStruc);
                        return [2 /*return*/, true];
                }
            });
        });
    }
    ComputedSecondaryStructure.attachFromCifOrCompute = attachFromCifOrCompute;
})(ComputedSecondaryStructure = exports.ComputedSecondaryStructure || (exports.ComputedSecondaryStructure = {}));
exports.SecondaryStructureComputationParams = __assign({}, dssp_1.DSSPComputationParams);
function computeSecondaryStructure(structure, params) {
    return __awaiter(this, void 0, void 0, function () {
        var p, map, i, il, u, secondaryStructure;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    p = __assign({}, param_definition_1.ParamDefinition.getDefaultValues(exports.SecondaryStructureComputationParams), { params: params });
                    map = new Map();
                    i = 0, il = structure.unitSymmetryGroups.length;
                    _a.label = 1;
                case 1:
                    if (!(i < il)) return [3 /*break*/, 4];
                    u = structure.unitSymmetryGroups[i].units[0];
                    if (!structure_2.Unit.isAtomic(u)) return [3 /*break*/, 3];
                    return [4 /*yield*/, dssp_1.computeUnitDSSP(u, p)];
                case 2:
                    secondaryStructure = _a.sent();
                    map.set(u.invariantId, secondaryStructure);
                    _a.label = 3;
                case 3:
                    ++i;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, { id: nextSecondaryStructureId(), map: map }];
            }
        });
    });
}
