"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var geometry_1 = require("../../../../mol-math/geometry");
var int_1 = require("../../../../mol-data/int");
function calcUnitProteinTraceLookup3D(unit, unitProteinResidues) {
    var _a = unit.model.atomicConformation, x = _a.x, y = _a.y, z = _a.z;
    var traceElementIndex = unit.model.atomicHierarchy.derived.residue.traceElementIndex;
    var indices = new Uint32Array(unitProteinResidues.length);
    for (var i = 0, il = unitProteinResidues.length; i < il; ++i) {
        indices[i] = traceElementIndex[unitProteinResidues[i]];
    }
    return geometry_1.GridLookup3D({ x: x, y: y, z: z, indices: int_1.SortedArray.ofSortedArray(indices) });
}
exports.calcUnitProteinTraceLookup3D = calcUnitProteinTraceLookup3D;
