"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var db_1 = require("../../mol-data/db");
var schema_1 = require("../../mol-io/reader/cif/schema");
var cif_1 = require("../../mol-io/writer/cif");
var structure_1 = require("../../mol-model/structure");
var wrapper_1 = require("../common/wrapper");
var PDBeStructRefDomain;
(function (PDBeStructRefDomain) {
    function get(model) {
        return model._staticPropertyData.__PDBeStructRefSeq__;
    }
    PDBeStructRefDomain.get = get;
    function set(model, prop) {
        model._staticPropertyData.__PDBeStructRefSeq__ = prop;
    }
    PDBeStructRefDomain.Schema = {
        pdbe_struct_ref_domain: {
            id: db_1.Column.Schema.int,
            db_name: db_1.Column.Schema.str,
            db_code: db_1.Column.Schema.str,
            identifier: db_1.Column.Schema.str,
            name: db_1.Column.Schema.str,
            label_entity_id: db_1.Column.Schema.str,
            label_asym_id: db_1.Column.Schema.str,
            beg_label_seq_id: db_1.Column.Schema.int,
            beg_pdbx_PDB_ins_code: db_1.Column.Schema.str,
            end_label_seq_id: db_1.Column.Schema.int,
            end_pdbx_PDB_ins_code: db_1.Column.Schema.str
        }
    };
    PDBeStructRefDomain.Descriptor = structure_1.CustomPropertyDescriptor({
        isStatic: true,
        name: 'pdbe_struct_ref_domain',
        cifExport: {
            prefix: 'pdbe',
            context: function (ctx) { return get(ctx.firstModel); },
            categories: [
                wrapper_1.PropertyWrapper.defaultInfoCategory('pdbe_struct_ref_domain_info', function (ctx) { return ctx.info; }),
                {
                    name: 'pdbe_struct_ref_domain',
                    instance: function (ctx) {
                        if (!ctx || !ctx.data)
                            return cif_1.CifWriter.Category.Empty;
                        return cif_1.CifWriter.Category.ofTable(ctx.data);
                    }
                }
            ]
        }
    });
    function fromCifData(model) {
        if (model.sourceData.kind !== 'mmCIF')
            return void 0;
        var cat = model.sourceData.frame.categories.pdbe_struct_ref_domain;
        if (!cat)
            return void 0;
        return schema_1.toTable(PDBeStructRefDomain.Schema.pdbe_struct_ref_domain, cat);
    }
    function attachFromCifOrApi(model, params) {
        return __awaiter(this, void 0, void 0, function () {
            var table, info, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (model.customProperties.has(PDBeStructRefDomain.Descriptor))
                            return [2 /*return*/, true];
                        info = wrapper_1.PropertyWrapper.tryGetInfoFromCif('pdbe_struct_ref_domain_info', model);
                        if (!info) return [3 /*break*/, 1];
                        table = fromCifData(model);
                        return [3 /*break*/, 4];
                    case 1:
                        if (!params.PDBe_apiSourceJson) return [3 /*break*/, 3];
                        return [4 /*yield*/, params.PDBe_apiSourceJson(model)];
                    case 2:
                        data = _a.sent();
                        if (!data)
                            return [2 /*return*/, false];
                        info = wrapper_1.PropertyWrapper.createInfo();
                        table = fromPDBeJson(model, data);
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, false];
                    case 4:
                        model.customProperties.add(PDBeStructRefDomain.Descriptor);
                        set(model, { info: info, data: table });
                        return [2 /*return*/, true];
                }
            });
        });
    }
    PDBeStructRefDomain.attachFromCifOrApi = attachFromCifOrApi;
})(PDBeStructRefDomain = exports.PDBeStructRefDomain || (exports.PDBeStructRefDomain = {}));
function fromPDBeJson(modelData, data) {
    var rows = [];
    var id = 1;
    for (var _i = 0, _a = Object.keys(data); _i < _a.length; _i++) {
        var db_name = _a[_i];
        var db = data[db_name];
        for (var _b = 0, _c = Object.keys(db); _b < _c.length; _b++) {
            var db_code = _c[_b];
            var domain = db[db_code];
            for (var _d = 0, _e = domain.mappings; _d < _e.length; _d++) {
                var map = _e[_d];
                rows.push({
                    id: id++,
                    db_name: db_name,
                    db_code: db_code,
                    identifier: domain.identifier,
                    name: domain.name,
                    label_entity_id: '' + map.entity_id,
                    label_asym_id: map.struct_asym_id,
                    beg_label_seq_id: map.start.residue_number,
                    beg_pdbx_PDB_ins_code: map.start.author_insertion_code,
                    end_label_seq_id: map.end.residue_number,
                    end_pdbx_PDB_ins_code: map.end.author_insertion_code,
                });
            }
        }
    }
    return db_1.Table.ofRows(PDBeStructRefDomain.Schema.pdbe_struct_ref_domain, rows);
}
