export declare type Maybe<T> = T | null;
/** Built-in scalar representing an instant in time */
export declare type Date = any;
/** Unrepresentable type */
export declare type Unrepresentable = any;
export declare namespace AssemblySymmetry {
    type Variables = {
        pdbId: string;
    };
    type Query = {
        __typename?: "Query";
        entry: Maybe<Entry>;
    };
    type Entry = {
        __typename?: "CoreEntry";
        assemblies: Maybe<(Maybe<Assemblies>)[]>;
    };
    type Assemblies = {
        __typename?: "CoreAssembly";
        pdbx_struct_assembly: Maybe<PdbxStructAssembly>;
        rcsb_struct_symmetry: Maybe<(Maybe<RcsbStructSymmetry>)[]>;
    };
    type PdbxStructAssembly = {
        __typename?: "PdbxStructAssembly";
        id: string;
    };
    type RcsbStructSymmetry = {
        __typename?: "RcsbStructSymmetry";
        clusters: (Maybe<Clusters>)[];
        kind: string;
        oligomeric_state: string;
        rotation_axes: Maybe<(Maybe<RotationAxes>)[]>;
        stoichiometry: (Maybe<string>)[];
        symbol: string;
        type: string;
    };
    type Clusters = {
        __typename?: "RcsbStructSymmetryClusters";
        avg_rmsd: Maybe<number>;
        members: (Maybe<Members>)[];
    };
    type Members = {
        __typename?: "ClustersMembers";
        asym_id: string;
        pdbx_struct_oper_list_ids: Maybe<(Maybe<string>)[]>;
    };
    type RotationAxes = {
        __typename?: "RcsbStructSymmetryRotationAxes";
        start: (Maybe<number>)[];
        end: (Maybe<number>)[];
        order: Maybe<number>;
    };
}
