/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { CifWriter } from '../../../mol-io/writer/cif';
import { CifExportContext } from '../export/mmcif';
import { QuerySymbolRuntime } from '../../../mol-script/runtime/query/compiler';
import { UUID } from '../../../mol-util';
export { CustomPropertyDescriptor, CustomProperties };
interface CustomPropertyDescriptor<ExportCtx = CifExportContext, Symbols extends {
    [name: string]: QuerySymbolRuntime;
} = {}> {
    readonly isStatic: boolean;
    readonly name: string;
    cifExport?: {
        prefix: string;
        context?: (ctx: CifExportContext) => ExportCtx | undefined;
        categories: CifWriter.Category<ExportCtx>[];
    };
    symbols?: Symbols;
}
declare function CustomPropertyDescriptor<Ctx, Desc extends CustomPropertyDescriptor<Ctx>>(desc: Desc): Desc;
declare namespace CustomPropertyDescriptor {
    function getUUID(prop: CustomPropertyDescriptor): UUID;
}
declare class CustomProperties {
    private _list;
    private _set;
    readonly all: ReadonlyArray<CustomPropertyDescriptor>;
    add(desc: CustomPropertyDescriptor<any>): void;
    has(desc: CustomPropertyDescriptor<any>): boolean;
}
