/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { Column } from '../../../../mol-data/db';
import { AtomicHierarchy } from './atomic/hierarchy';
import { Entities } from './common';
import { Sequence } from '../../../sequence';
interface StructureSequence {
    readonly sequences: ReadonlyArray<StructureSequence.Entity>;
    readonly byEntityKey: {
        [key: number]: StructureSequence.Entity;
    };
}
declare namespace StructureSequence {
    interface Entity {
        readonly entityId: string;
        readonly num: Column<number>;
        readonly compId: Column<string>;
        readonly sequence: Sequence;
    }
    function fromAtomicHierarchy(entities: Entities, hierarchy: AtomicHierarchy, modResMap?: ReadonlyMap<string, string>): StructureSequence;
}
export default StructureSequence;
