"use strict";
/**
 * Copyright (c) 2017 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../../../../mol-data/util");
var geometry_1 = require("../../../../mol-math/geometry");
var Assembly = /** @class */ (function () {
    function Assembly(id, details, operatorsProvider) {
        this.operatorsProvider = operatorsProvider;
        this.id = id;
        this.details = details;
    }
    Object.defineProperty(Assembly.prototype, "operatorGroups", {
        get: function () {
            if (this._operators)
                return this._operators;
            this._operators = this.operatorsProvider();
            return this._operators;
        },
        enumerable: true,
        configurable: true
    });
    return Assembly;
}());
exports.Assembly = Assembly;
(function (Assembly) {
    function create(id, details, operatorsProvider) {
        return new Assembly(id, details, operatorsProvider);
    }
    Assembly.create = create;
})(Assembly = exports.Assembly || (exports.Assembly = {}));
exports.Assembly = Assembly;
var ModelSymmetry;
(function (ModelSymmetry) {
    ModelSymmetry.Default = { assemblies: [], spacegroup: geometry_1.Spacegroup.ZeroP1, isNonStandardCrytalFrame: false };
    function findAssembly(model, id) {
        var _id = id.toLocaleLowerCase();
        return util_1.arrayFind(model.symmetry.assemblies, function (a) { return a.id.toLowerCase() === _id; });
    }
    ModelSymmetry.findAssembly = findAssembly;
})(ModelSymmetry || (ModelSymmetry = {}));
exports.ModelSymmetry = ModelSymmetry;
