/**
 * Copyright (c) 2017-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Unit, StructureElement } from '../../structure';
import Structure from '../structure';
import { LinkType } from '../../model/types';
export * from './links/data';
export * from './links/intra-compute';
export * from './links/inter-compute';
declare namespace Link {
    interface Location<U extends Unit = Unit> {
        readonly kind: 'link-location';
        aUnit: U;
        /** Index into aUnit.elements */
        aIndex: StructureElement.UnitIndex;
        bUnit: U;
        /** Index into bUnit.elements */
        bIndex: StructureElement.UnitIndex;
    }
    function Location(aUnit?: Unit, aIndex?: StructureElement.UnitIndex, bUnit?: Unit, bIndex?: StructureElement.UnitIndex): Location;
    function isLocation(x: any): x is Location;
    function areLocationsEqual(locA: Location, locB: Location): boolean;
    interface Loci {
        readonly kind: 'link-loci';
        readonly structure: Structure;
        readonly links: ReadonlyArray<Location>;
    }
    function Loci(structure: Structure, links: ArrayLike<Location>): Loci;
    function isLoci(x: any): x is Loci;
    function areLociEqual(a: Loci, b: Loci): boolean;
    function toStructureElementLoci(loci: Loci): StructureElement.Loci;
    function getType(structure: Structure, link: Location<Unit.Atomic>): LinkType;
    function getOrder(structure: Structure, link: Location<Unit.Atomic>): number;
}
export { Link };
