/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import Structure from '../structure';
import { Box3D, Sphere3D, Result } from '../../../../mol-math/geometry';
import { StructureUniqueSubsetBuilder } from './unique-subset-builder';
import StructureElement from '../element';
import Unit from '../unit';
export interface StructureResult extends Result<number> {
    units: Unit[];
}
export declare namespace StructureResult {
    function add(result: StructureResult, unit: Unit, index: number, distSq: number): void;
    function create(): StructureResult;
}
export declare class StructureLookup3D {
    private structure;
    private unitLookup;
    private pivot;
    findUnitIndices(x: number, y: number, z: number, radius: number): Result<number>;
    private result;
    find(x: number, y: number, z: number, radius: number): StructureResult;
    findIntoBuilder(x: number, y: number, z: number, radius: number, builder: StructureUniqueSubsetBuilder): void;
    findIntoBuilderWithRadius(x: number, y: number, z: number, pivotR: number, maxRadius: number, radius: number, eRadius: StructureElement.Property<number>, builder: StructureUniqueSubsetBuilder): void;
    check(x: number, y: number, z: number, radius: number): boolean;
    _boundary: {
        box: Box3D;
        sphere: Sphere3D;
    } | undefined;
    readonly boundary: {
        box: Box3D;
        sphere: Sphere3D;
    };
    constructor(structure: Structure);
}
