/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Model, ResidueIndex, ElementIndex } from './model';
import { MoleculeType, AtomRole } from './model/types';
import { Unit } from './structure';
import Matrix from '../../mol-math/linear-algebra/matrix/matrix';
export declare function getCoarseBegCompId(unit: Unit.Spheres | Unit.Gaussians, element: ElementIndex): string;
export declare function getElementMoleculeType(unit: Unit, element: ElementIndex): MoleculeType;
export declare function getAtomicMoleculeType(model: Model, rI: ResidueIndex): MoleculeType;
export declare function getAtomIdForAtomRole(moleculeType: MoleculeType, atomRole: AtomRole): Set<string>;
export declare function residueLabel(model: Model, rI: number): string;
export declare function elementLabel(model: Model, index: ElementIndex): string;
export declare function getPositionMatrix(unit: Unit, indices: ArrayLike<number>): Matrix;
