"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(require("./behavior/behavior"));
var StaticState = require("./behavior/static/state");
var StaticRepresentation = require("./behavior/static/representation");
var StaticCamera = require("./behavior/static/camera");
var StaticMisc = require("./behavior/static/misc");
var DynamicRepresentation = require("./behavior/dynamic/representation");
var DynamicCamera = require("./behavior/dynamic/camera");
var DynamicCustomProps = require("./behavior/dynamic/custom-props");
var DynamicLabels = require("./behavior/dynamic/labels");
exports.BuiltInPluginBehaviors = {
    State: StaticState,
    Representation: StaticRepresentation,
    Camera: StaticCamera,
    Misc: StaticMisc
};
exports.PluginBehaviors = {
    Representation: DynamicRepresentation,
    Camera: DynamicCamera,
    CustomProps: DynamicCustomProps,
    Labels: DynamicLabels
};
