"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var param_definition_1 = require("../../../../../mol-util/param-definition");
var behavior_1 = require("../../../behavior");
var secondary_structure_1 = require("../../../../../mol-model-props/computed/secondary-structure");
exports.MolstarSecondaryStructure = behavior_1.PluginBehavior.create({
    name: 'molstar-computed-secondary-structure-prop',
    category: 'custom-props',
    display: { name: 'Computed Secondary Structure' },
    ctor: /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.attach = secondary_structure_1.ComputedSecondaryStructure.createAttachTask();
            _this.provider = {
                option: [secondary_structure_1.ComputedSecondaryStructure.Descriptor.name, 'Computed Secondary Structure'],
                descriptor: secondary_structure_1.ComputedSecondaryStructure.Descriptor,
                defaultSelected: _this.params.autoAttach,
                attachableTo: function () { return true; },
                attach: _this.attach
            };
            return _this;
        }
        class_1.prototype.register = function () {
            this.ctx.customStructureProperties.register(this.provider);
        };
        class_1.prototype.update = function (p) {
            var updated = this.params.autoAttach !== p.autoAttach;
            this.params.autoAttach = p.autoAttach;
            this.provider.defaultSelected = p.autoAttach;
            return updated;
        };
        class_1.prototype.unregister = function () {
            this.ctx.customStructureProperties.unregister(secondary_structure_1.ComputedSecondaryStructure.Descriptor.name);
        };
        return class_1;
    }(behavior_1.PluginBehavior.Handler)),
    params: function () { return ({
        autoAttach: param_definition_1.ParamDefinition.Boolean(false)
    }); }
});
