"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var behavior_1 = require("../behavior");
var param_definition_1 = require("../../../mol-util/param-definition");
var linear_algebra_1 = require("../../../mol-math/linear-algebra");
var objects_1 = require("../../state/objects");
var mol_state_1 = require("../../../mol-state");
var shape_1 = require("../../../mol-model/shape");
var text_1 = require("../../../mol-geo/geometry/text/text");
var representation_1 = require("../../../mol-repr/shape/representation");
var tables_1 = require("../../../mol-util/color/tables");
var text_builder_1 = require("../../../mol-geo/geometry/text/text-builder");
var structure_1 = require("../../../mol-model/structure");
var set_1 = require("../../../mol-util/set");
var mol_util_1 = require("../../../mol-util");
var util_1 = require("../../../mol-model/structure/util");
exports.SceneLabelsParams = __assign({}, text_1.Text.Params, { background: param_definition_1.ParamDefinition.Boolean(true), backgroundMargin: param_definition_1.ParamDefinition.Numeric(0.2, { min: 0, max: 1, step: 0.01 }), backgroundColor: param_definition_1.ParamDefinition.Color(tables_1.ColorNames.snow), backgroundOpacity: param_definition_1.ParamDefinition.Numeric(0.9, { min: 0, max: 1, step: 0.01 }), levels: param_definition_1.ParamDefinition.MultiSelect([], [
        ['structure', 'structure'], ['polymer', 'polymer'], ['ligand', 'ligand']
    ]) });
function getLabelsText(data, props, text) {
    var texts = data.texts, positions = data.positions, depths = data.depths;
    var textBuilder = text_builder_1.TextBuilder.create(props, texts.length * 10, texts.length * 10 / 2, text);
    for (var i = 0, il = texts.length; i < il; ++i) {
        var p = positions[i];
        textBuilder.add(texts[i], p[0], p[1], p[2], depths[i], i);
    }
    return textBuilder.getText();
}
exports.SceneLabels = behavior_1.PluginBehavior.create({
    name: 'scene-labels',
    category: 'representation',
    display: { name: 'Scene Labels' },
    canAutoUpdate: function () { return true; },
    ctor: /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1(ctx, params) {
            var _this = _super.call(this, ctx, params) || this;
            _this.ctx = ctx;
            _this.params = params;
            _this.data = {
                transforms: [linear_algebra_1.Mat4.identity()],
                texts: [],
                positions: [],
                sizes: [],
                depths: []
            };
            _this.geo = text_1.Text.createEmpty();
            _this.structures = new Set();
            _this.triggerUpdate = function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.update(this.params)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); };
            _this.getColor = function () { return tables_1.ColorNames.dimgrey; };
            _this.getSize = function (groupId) { return _this.data.sizes[groupId]; };
            _this.getLabel = function () { return ''; };
            _this.getLabelsShape = function (ctx, data, props, shape) {
                _this.geo = getLabelsText(data, props, _this.geo);
                return shape_1.Shape.create('Scene Labels', data, _this.geo, _this.getColor, _this.getSize, _this.getLabel, data.transforms);
            };
            _this.repr = representation_1.ShapeRepresentation(_this.getLabelsShape, text_1.Text.Utils);
            ctx.events.state.object.created.subscribe(_this.triggerUpdate);
            ctx.events.state.object.removed.subscribe(_this.triggerUpdate);
            ctx.events.state.object.updated.subscribe(_this.triggerUpdate);
            ctx.events.state.cell.stateUpdated.subscribe(_this.triggerUpdate);
            return _this;
        }
        /** Update structures to be labeled, returns true if changed */
        class_1.prototype.updateStructures = function (p) {
            var state = this.ctx.state.dataState;
            var structures = state.selectQ(function (q) { return q.rootsOfType(objects_1.PluginStateObject.Molecule.Structure); });
            var rootStructures = new Set();
            for (var _i = 0, structures_1 = structures; _i < structures_1.length; _i++) {
                var s = structures_1[_i];
                var rootStructure = getRootStructure(s, state);
                if (!rootStructure || !objects_1.PluginStateObject.Molecule.Structure.is(rootStructure.obj))
                    continue;
                if (!s.state.isHidden) {
                    rootStructures.add(rootStructure.obj);
                }
            }
            if (!set_1.SetUtils.areEqual(rootStructures, this.structures)) {
                this.structures = rootStructures;
                return true;
            }
            else {
                return false;
            }
        };
        class_1.prototype.updateLabels = function (p) {
            var l = structure_1.StructureElement.create();
            var _a = this.data, texts = _a.texts, positions = _a.positions, sizes = _a.sizes, depths = _a.depths;
            texts.length = 0;
            positions.length = 0;
            sizes.length = 0;
            depths.length = 0;
            this.structures.forEach(function (structure) {
                if (p.levels.includes('structure')) {
                    texts.push("" + structure.data.model.label);
                    positions.push(structure.data.boundary.sphere.center);
                    sizes.push(structure.data.boundary.sphere.radius / 10);
                    depths.push(structure.data.boundary.sphere.radius);
                }
                for (var i = 0, il = structure.data.units.length; i < il; ++i) {
                    var label = '';
                    var u = structure.data.units[i];
                    l.unit = u;
                    l.element = u.elements[0];
                    if (p.levels.includes('polymer') && u.polymerElements.length) {
                        label = structure_1.StructureProperties.entity.pdbx_description(l).join(', ') + " (" + getAsymId(u)(l) + ")";
                    }
                    if (p.levels.includes('ligand') && !u.polymerElements.length) {
                        var moleculeType = util_1.getElementMoleculeType(u, u.elements[0]);
                        if (moleculeType === 1 /* other */ || moleculeType === 8 /* saccharide */) {
                            label = structure_1.StructureProperties.entity.pdbx_description(l).join(', ') + " (" + getAsymId(u)(l) + ")";
                        }
                    }
                    if (label) {
                        texts.push(label);
                        var _a = u.lookup3d.boundary.sphere, center = _a.center, radius = _a.radius;
                        var transformedCenter = linear_algebra_1.Vec3.transformMat4(linear_algebra_1.Vec3.zero(), center, u.conformation.operator.matrix);
                        positions.push(transformedCenter);
                        sizes.push(Math.max(2, radius / 10));
                        depths.push(radius);
                    }
                }
            });
        };
        class_1.prototype.register = function () { };
        class_1.prototype.update = function (p) {
            return __awaiter(this, void 0, void 0, function () {
                var updated;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            updated = false;
                            if (!(this.updateStructures(p) || !mol_util_1.arrayEqual(this.params.levels, p.levels))) return [3 /*break*/, 2];
                            // console.log('update with data')
                            this.updateLabels(p);
                            return [4 /*yield*/, this.repr.createOrUpdate(p, this.data).run()];
                        case 1:
                            _a.sent();
                            updated = true;
                            return [3 /*break*/, 4];
                        case 2:
                            if (!!param_definition_1.ParamDefinition.areEqual(exports.SceneLabelsParams, this.params, p)) return [3 /*break*/, 4];
                            // console.log('update props only')
                            return [4 /*yield*/, this.repr.createOrUpdate(p).run()];
                        case 3:
                            // console.log('update props only')
                            _a.sent();
                            updated = true;
                            _a.label = 4;
                        case 4:
                            if (updated) {
                                Object.assign(this.params, p);
                                this.ctx.canvas3d.add(this.repr);
                            }
                            return [2 /*return*/, updated];
                    }
                });
            });
        };
        class_1.prototype.unregister = function () {
        };
        return class_1;
    }(behavior_1.PluginBehavior.Handler)),
    params: function () { return exports.SceneLabelsParams; }
});
//
function getRootStructure(root, state) {
    var parent;
    while (true) {
        var _parent = mol_state_1.StateSelection.findAncestorOfType(state.tree, state.cells, root.transform.ref, [objects_1.PluginStateObject.Molecule.Structure]);
        if (_parent) {
            parent = _parent;
            root = _parent;
        }
        else {
            break;
        }
    }
    return parent ? parent :
        objects_1.PluginStateObject.Molecule.Structure.is(root.obj) ? root : undefined;
}
function getAsymId(unit) {
    switch (unit.kind) {
        case 0 /* Atomic */:
            return structure_1.StructureProperties.chain.auth_asym_id;
        case 1 /* Spheres */:
        case 2 /* Gaussians */:
            return structure_1.StructureProperties.coarse.asym_id;
    }
}
