"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var structure_1 = require("../../../../mol-model/structure");
var behavior_1 = require("../../../../mol-plugin/behavior");
var command_1 = require("../../../../mol-plugin/command");
var objects_1 = require("../../../../mol-plugin/state/objects");
var transforms_1 = require("../../../../mol-plugin/state/transforms");
var representation_1 = require("../../../../mol-plugin/state/transforms/representation");
var registry_1 = require("../../../../mol-repr/structure/registry");
var builder_1 = require("../../../../mol-script/language/builder");
var mol_state_1 = require("../../../../mol-state");
var color_1 = require("../../../../mol-theme/color");
var size_1 = require("../../../../mol-theme/size");
var tables_1 = require("../../../../mol-util/color/tables");
var representation_2 = require("../../../../mol-repr/representation");
var Tags;
(function (Tags) {
    Tags["Group"] = "structure-interaction-group";
    Tags["ResidueSel"] = "structure-interaction-residue-sel";
    Tags["ResidueRepr"] = "structure-interaction-residue-repr";
    Tags["SurrSel"] = "structure-interaction-surr-sel";
    Tags["SurrRepr"] = "structure-interaction-surr-repr";
})(Tags || (Tags = {}));
var TagSet = new Set([Tags.Group, Tags.ResidueSel, Tags.ResidueRepr, Tags.SurrSel, Tags.SurrRepr]);
var StructureRepresentationInteractionBehavior = /** @class */ (function (_super) {
    __extends(StructureRepresentationInteractionBehavior, _super);
    function StructureRepresentationInteractionBehavior(plugin) {
        var _this = _super.call(this, plugin) || this;
        _this.plugin = plugin;
        return _this;
    }
    StructureRepresentationInteractionBehavior.prototype.createResVisualParams = function (s) {
        return representation_1.StructureRepresentation3DHelpers.createParams(this.plugin, s, {
            repr: registry_1.BuiltInStructureRepresentations['ball-and-stick'],
            size: [size_1.BuiltInSizeThemes.uniform, function () { return ({ value: 0.85 }); }]
        });
    };
    StructureRepresentationInteractionBehavior.prototype.createSurVisualParams = function (s) {
        return representation_1.StructureRepresentation3DHelpers.createParams(this.plugin, s, {
            repr: registry_1.BuiltInStructureRepresentations['ball-and-stick'],
            color: [color_1.BuiltInColorThemes.uniform, function () { return ({ value: tables_1.ColorNames.gray }); }],
            size: [size_1.BuiltInSizeThemes.uniform, function () { return ({ value: 0.33 }); }]
        });
    };
    StructureRepresentationInteractionBehavior.prototype.ensureShape = function (cell) {
        var state = this.plugin.state.dataState, tree = state.tree;
        var builder = state.build();
        var refs = mol_state_1.StateSelection.findUniqueTagsInSubtree(tree, cell.transform.ref, TagSet);
        if (!refs['structure-interaction-group']) {
            refs['structure-interaction-group'] = builder.to(cell).group(transforms_1.StateTransforms.Misc.CreateGroup, { label: 'Current Interaction' }, { tags: Tags.Group }).ref;
        }
        // Selections
        if (!refs[Tags.ResidueSel]) {
            refs[Tags.ResidueSel] = builder.to(refs['structure-interaction-group']).apply(transforms_1.StateTransforms.Model.StructureSelection, { query: {}, label: 'Residue' }, { tags: Tags.ResidueSel }).ref;
        }
        if (!refs[Tags.SurrSel]) {
            refs[Tags.SurrSel] = builder.to(refs['structure-interaction-group']).apply(transforms_1.StateTransforms.Model.StructureSelection, { query: {}, label: 'Surroundings' }, { tags: Tags.SurrSel }).ref;
        }
        // Representations
        // TODO: ability to customize how it looks in the behavior params
        if (!refs[Tags.ResidueRepr]) {
            refs[Tags.ResidueRepr] = builder.to(refs['structure-interaction-residue-sel']).apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, this.createResVisualParams(cell.obj.data), { tags: Tags.ResidueRepr }).ref;
        }
        if (!refs[Tags.SurrRepr]) {
            refs[Tags.SurrRepr] = builder.to(refs['structure-interaction-surr-sel']).apply(transforms_1.StateTransforms.Representation.StructureRepresentation3D, this.createSurVisualParams(cell.obj.data), { tags: Tags.SurrRepr }).ref;
        }
        return { state: state, builder: builder, refs: refs };
    };
    StructureRepresentationInteractionBehavior.prototype.clear = function (root) {
        var state = this.plugin.state.dataState;
        var groups = state.select(mol_state_1.StateSelection.Generators.byRef(root).subtree().withTag(Tags.Group));
        if (groups.length === 0)
            return;
        var update = state.build();
        var query = builder_1.MolScriptBuilder.struct.generator.empty();
        for (var _i = 0, groups_1 = groups; _i < groups_1.length; _i++) {
            var g = groups_1[_i];
            // TODO: update props of the group node to ghost
            var res = mol_state_1.StateSelection.findTagInSubtree(state.tree, g.transform.ref, Tags.ResidueSel);
            var surr = mol_state_1.StateSelection.findTagInSubtree(state.tree, g.transform.ref, Tags.SurrSel);
            if (res)
                update.to(res).update(transforms_1.StateTransforms.Model.StructureSelection, function (old) { return (__assign({}, old, { query: query })); });
            if (surr)
                update.to(surr).update(transforms_1.StateTransforms.Model.StructureSelection, function (old) { return (__assign({}, old, { query: query })); });
        }
        command_1.PluginCommands.State.Update.dispatch(this.plugin, { state: state, tree: update, options: { doNotLogTiming: true, doNotUpdateCurrent: true } });
    };
    StructureRepresentationInteractionBehavior.prototype.register = function (ref) {
        var _this = this;
        var lastLoci = representation_2.Representation.Loci.Empty;
        this.subscribeObservable(this.plugin.events.state.object.removed, function (o) {
            if (!objects_1.PluginStateObject.Molecule.Structure.is(o.obj) || lastLoci.loci.kind !== 'element-loci')
                return;
            if (lastLoci.loci.structure === o.obj.data) {
                lastLoci = representation_2.Representation.Loci.Empty;
            }
        });
        this.subscribeObservable(this.plugin.events.state.object.updated, function (o) {
            if (!objects_1.PluginStateObject.Molecule.Structure.is(o.oldObj) || lastLoci.loci.kind !== 'element-loci')
                return;
            if (lastLoci.loci.structure === o.oldObj.data) {
                lastLoci = representation_2.Representation.Loci.Empty;
            }
        });
        this.subscribeObservable(this.plugin.behaviors.interaction.click, function (_a) {
            var current = _a.current, buttons = _a.buttons, modifiers = _a.modifiers;
            if (buttons !== 2 /* Secondary */)
                return;
            if (current.loci.kind === 'empty-loci') {
                if (modifiers.control && buttons === 2 /* Secondary */) {
                    _this.clear(mol_state_1.StateTransform.RootRef);
                    return;
                }
            }
            // TODO: support link loci as well?
            if (!structure_1.StructureElement.isLoci(current.loci))
                return;
            var parent = _this.plugin.helpers.substructureParent.get(current.loci.structure);
            if (!parent || !parent.obj)
                return;
            if (representation_2.Representation.Loci.areEqual(lastLoci, current)) {
                lastLoci = representation_2.Representation.Loci.Empty;
                _this.clear(parent.transform.ref);
                return;
            }
            lastLoci = current;
            var core = builder_1.MolScriptBuilder.struct.modifier.wholeResidues([
                structure_1.StructureElement.Loci.toScriptExpression(current.loci)
            ]);
            var surroundings = builder_1.MolScriptBuilder.struct.modifier.includeSurroundings({
                0: core,
                radius: 5,
                'as-whole-residues': true
            });
            // const surroundings = MS.struct.modifier.exceptBy({
            //     0: MS.struct.modifier.includeSurroundings({
            //         0: core,
            //         radius: 5,
            //         'as-whole-residues': true
            //     }),
            //     by: core
            // });
            var _b = _this.ensureShape(parent), state = _b.state, builder = _b.builder, refs = _b.refs;
            builder.to(refs[Tags.ResidueSel]).update(transforms_1.StateTransforms.Model.StructureSelection, function (old) { return (__assign({}, old, { query: core })); });
            builder.to(refs[Tags.SurrSel]).update(transforms_1.StateTransforms.Model.StructureSelection, function (old) { return (__assign({}, old, { query: surroundings })); });
            command_1.PluginCommands.State.Update.dispatch(_this.plugin, { state: state, tree: builder, options: { doNotLogTiming: true, doNotUpdateCurrent: true } });
        });
    };
    StructureRepresentationInteractionBehavior.prototype.update = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, false];
            });
        });
    };
    return StructureRepresentationInteractionBehavior;
}(behavior_1.PluginBehavior.WithSubscribers));
exports.StructureRepresentationInteractionBehavior = StructureRepresentationInteractionBehavior;
exports.StructureRepresentationInteraction = behavior_1.PluginBehavior.create({
    name: 'create-structure-representation-interaction',
    display: { name: 'Structure Representation Interaction' },
    category: 'interaction',
    ctor: StructureRepresentationInteractionBehavior
});
