/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { PluginStateObject as SO } from '../../../state/objects';
import { VolumeServerInfo } from './model';
import { ParamDefinition as PD } from '../../../../mol-util/param-definition';
import { StateAction, StateTransformer } from '../../../../mol-state';
import { VolumeStreaming } from './behavior';
export declare const InitVolumeStreaming: StateAction<SO.Molecule.Structure, void, PD.Normalize<{
    method: VolumeServerInfo.Kind;
    id: string;
    serverUrl: string;
    defaultView: VolumeStreaming.ViewTypes;
    behaviorRef: string;
}>>;
export declare const BoxifyVolumeStreaming: StateAction<VolumeStreaming, void, PD.Normalize<{}>>;
export { CreateVolumeStreamingInfo };
declare type CreateVolumeStreamingInfo = typeof CreateVolumeStreamingInfo;
declare const CreateVolumeStreamingInfo: StateTransformer<SO.Molecule.Structure, VolumeServerInfo, PD.Normalize<{
    serverUrl: string;
    source: PD.NamedParams<PD.Normalize<{
        isoValue: any;
    }>, "em"> | PD.NamedParams<PD.Normalize<unknown>, "x-ray">;
    dataId: string;
}>>;
export { CreateVolumeStreamingBehavior };
declare type CreateVolumeStreamingBehavior = typeof CreateVolumeStreamingBehavior;
declare const CreateVolumeStreamingBehavior: StateTransformer<VolumeServerInfo, VolumeStreaming, PD.Normalize<{
    view: PD.NamedParams<PD.Normalize<unknown>, "cell"> | PD.NamedParams<PD.Normalize<{
        bottomLeft: any;
        topRight: any;
    }>, "box"> | PD.NamedParams<PD.Normalize<{
        radius: any;
        bottomLeft: any;
        topRight: any;
    }>, "selection-box">;
    detailLevel: number;
    channels: PD.Normalize<{
        'em': any;
    }> | PD.Normalize<{
        '2fo-fc': any;
        'fo-fc(+ve)': any;
        'fo-fc(-ve)': any;
    }>;
}>>;
export { VolumeStreamingVisual };
declare type VolumeStreamingVisual = typeof VolumeStreamingVisual;
declare const VolumeStreamingVisual: StateTransformer<VolumeStreaming, SO.Volume.Representation3D, PD.Normalize<{
    channel: VolumeStreaming.ChannelType;
}>>;
