"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var command_1 = require("../../../mol-plugin/command");
var camera_1 = require("../../../mol-plugin/state/camera");
function registerDefault(ctx) {
    Reset(ctx);
    SetSnapshot(ctx);
    Snapshots(ctx);
}
exports.registerDefault = registerDefault;
function Reset(ctx) {
    command_1.PluginCommands.Camera.Reset.subscribe(ctx, function () {
        ctx.canvas3d.resetCamera();
    });
}
exports.Reset = Reset;
function SetSnapshot(ctx) {
    command_1.PluginCommands.Camera.SetSnapshot.subscribe(ctx, function (_a) {
        var snapshot = _a.snapshot, durationMs = _a.durationMs;
        ctx.canvas3d.camera.transition.apply(snapshot, durationMs);
    });
}
exports.SetSnapshot = SetSnapshot;
function Snapshots(ctx) {
    command_1.PluginCommands.Camera.Snapshots.Clear.subscribe(ctx, function () {
        ctx.state.cameraSnapshots.clear();
    });
    command_1.PluginCommands.Camera.Snapshots.Remove.subscribe(ctx, function (_a) {
        var id = _a.id;
        ctx.state.cameraSnapshots.remove(id);
    });
    command_1.PluginCommands.Camera.Snapshots.Add.subscribe(ctx, function (_a) {
        var name = _a.name, description = _a.description;
        var entry = camera_1.CameraSnapshotManager.Entry(ctx.canvas3d.camera.getSnapshot(), name, description);
        ctx.state.cameraSnapshots.add(entry);
    });
    command_1.PluginCommands.Camera.Snapshots.Apply.subscribe(ctx, function (_a) {
        var id = _a.id;
        var e = ctx.state.cameraSnapshots.getEntry(id);
        return command_1.PluginCommands.Camera.SetSnapshot.dispatch(ctx, { snapshot: e.snapshot, durationMs: 200 });
    });
}
exports.Snapshots = Snapshots;
