"use strict";
/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var command_1 = require("../../../mol-plugin/command");
function registerDefault(ctx) {
    Canvas3DSetSettings(ctx);
    InteractivitySetProps(ctx);
}
exports.registerDefault = registerDefault;
function Canvas3DSetSettings(ctx) {
    command_1.PluginCommands.Canvas3D.SetSettings.subscribe(ctx, function (e) {
        ctx.canvas3d.setProps(e.settings);
        ctx.events.canvas3d.settingsUpdated.next();
    });
}
exports.Canvas3DSetSettings = Canvas3DSetSettings;
function InteractivitySetProps(ctx) {
    command_1.PluginCommands.Interactivity.SetProps.subscribe(ctx, function (e) {
        ctx.interactivity.setProps(e.props);
        ctx.events.interactivity.propsUpdated.next();
    });
}
exports.InteractivitySetProps = InteractivitySetProps;
