"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./command/base");
__export(require("./command/base"));
exports.PluginCommands = {
    State: {
        SetCurrentObject: base_1.PluginCommand(),
        ApplyAction: base_1.PluginCommand(),
        Update: base_1.PluginCommand(),
        RemoveObject: base_1.PluginCommand(),
        ToggleExpanded: base_1.PluginCommand(),
        ToggleVisibility: base_1.PluginCommand(),
        Highlight: base_1.PluginCommand(),
        ClearHighlight: base_1.PluginCommand(),
        Snapshots: {
            Add: base_1.PluginCommand(),
            Replace: base_1.PluginCommand(),
            Move: base_1.PluginCommand(),
            Remove: base_1.PluginCommand(),
            Apply: base_1.PluginCommand(),
            Clear: base_1.PluginCommand(),
            Upload: base_1.PluginCommand(),
            Fetch: base_1.PluginCommand(),
            DownloadToFile: base_1.PluginCommand(),
            OpenFile: base_1.PluginCommand(),
        }
    },
    Interactivity: {
        SetProps: base_1.PluginCommand(),
        Structure: {
            Highlight: base_1.PluginCommand(),
            Select: base_1.PluginCommand()
        }
    },
    Layout: {
        Update: base_1.PluginCommand()
    },
    Camera: {
        Reset: base_1.PluginCommand(),
        SetSnapshot: base_1.PluginCommand(),
        Snapshots: {
            Add: base_1.PluginCommand(),
            Remove: base_1.PluginCommand(),
            Apply: base_1.PluginCommand(),
            Clear: base_1.PluginCommand(),
        }
    },
    Canvas3D: {
        SetSettings: base_1.PluginCommand()
    }
};
