/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { ParamDefinition as PD } from '../mol-util/param-definition';
import { PluginComponent } from './component';
import { PluginContext } from './context';
export declare const PluginLayoutStateParams: {
    isExpanded: PD.BooleanParam;
    showControls: PD.BooleanParam;
};
export declare type PluginLayoutStateProps = PD.Values<typeof PluginLayoutStateParams>;
export declare class PluginLayout extends PluginComponent<PluginLayoutStateProps> {
    private context;
    readonly events: {
        updated: import("rxjs").Subject<unknown>;
    };
    private updateProps;
    private root;
    private rootState;
    private expandedViewport;
    setProps(props: Partial<PluginLayoutStateProps>): void;
    setRoot(root: HTMLElement): void;
    private getScrollElement;
    private handleExpand;
    constructor(context: PluginContext);
}
