/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { StateAction } from '../../../mol-state';
import { ParamDefinition as PD } from '../../../mol-util/param-definition';
import { PluginStateObject } from '../objects';
import { DataFormatProvider } from './data-format';
export declare const Ccp4Provider: DataFormatProvider<any>;
export declare const Dsn6Provider: DataFormatProvider<any>;
export declare const DscifProvider: DataFormatProvider<any>;
export { DownloadDensity };
declare type DownloadDensity = typeof DownloadDensity;
declare const DownloadDensity: StateAction<PluginStateObject.Root, void, PD.Normalize<{
    source: PD.NamedParams<PD.Normalize<{
        url: any;
        isBinary: any;
        format: any;
    }>, "url"> | PD.NamedParams<PD.Normalize<{
        id: any;
        type: any;
    }>, "pdbe"> | PD.NamedParams<PD.Normalize<{
        id: any;
        type: any;
    }>, "rcsb"> | PD.NamedParams<PD.Normalize<{
        id: any;
        detail: any;
    }>, "pdbe-emd-ds"> | PD.NamedParams<PD.Normalize<{
        id: any;
        detail: any;
    }>, "pdbe-xray-ds">;
}>>;
