/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { PluginComponent } from '../../../mol-plugin/component';
import { PluginContext } from '../../../mol-plugin/context';
import { PluginStateAnimation } from './model';
import { ParamDefinition as PD } from '../../../mol-util/param-definition';
export { PluginAnimationManager };
declare class PluginAnimationManager extends PluginComponent<PluginAnimationManager.State> {
    private context;
    private map;
    private animations;
    private _current;
    private _params?;
    readonly events: {
        updated: import("rxjs").Subject<unknown>;
    };
    readonly isEmpty: boolean;
    readonly current: PluginAnimationManager.Current;
    private triggerUpdate;
    getParams(): PD.Params;
    updateParams(newParams: Partial<PluginAnimationManager.State['params']>): void;
    updateCurrentParams(values: any): void;
    register(animation: PluginStateAnimation): void;
    play<P>(animation: PluginStateAnimation<P>, params: P): void;
    start(): Promise<void>;
    stop(): Promise<void>;
    readonly isAnimating: boolean;
    private _frame;
    private animate;
    getSnapshot(): PluginAnimationManager.Snapshot;
    setSnapshot(snapshot: PluginAnimationManager.Snapshot): void;
    private resume;
    constructor(context: PluginContext);
}
declare namespace PluginAnimationManager {
    interface Current {
        anim: PluginStateAnimation;
        params: PD.Params;
        paramValues: any;
        state: any;
        startedTime: number;
        lastTime: number;
    }
    interface State {
        params: {
            current: string;
        };
        animationState: 'stopped' | 'playing';
    }
    interface Snapshot {
        state: State;
        current?: {
            paramValues: any;
            state: any;
        };
    }
}
