/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { Camera } from '../../mol-canvas3d/camera';
import { OrderedMap } from 'immutable';
import { UUID } from '../../mol-util';
import { PluginComponent } from '../../mol-plugin/component';
export { CameraSnapshotManager };
declare class CameraSnapshotManager extends PluginComponent<{
    entries: OrderedMap<string, CameraSnapshotManager.Entry>;
}> {
    readonly events: {
        changed: import("rxjs").Subject<unknown>;
    };
    getEntry(id: string): CameraSnapshotManager.Entry;
    remove(id: string): void;
    add(e: CameraSnapshotManager.Entry): void;
    clear(): void;
    getStateSnapshot(): CameraSnapshotManager.StateSnapshot;
    setStateSnapshot(state: CameraSnapshotManager.StateSnapshot): void;
    constructor();
}
declare namespace CameraSnapshotManager {
    interface Entry {
        id: UUID;
        timestamp: string;
        name?: string;
        description?: string;
        snapshot: Camera.Snapshot;
    }
    function Entry(snapshot: Camera.Snapshot, name?: string, description?: string): Entry;
    interface StateSnapshot {
        entries: Entry[];
    }
}
