/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { PluginStateObject as SO } from '../objects';
import { ParamDefinition as PD } from '../../../mol-util/param-definition';
import { StateTransformer } from '../../../mol-state';
export { Download };
declare type Download = typeof Download;
declare const Download: StateTransformer<SO.Root, SO.Data.String | SO.Data.Binary, PD.Normalize<{
    url: string;
    label: string | undefined;
    isBinary: boolean | undefined;
}>>;
export { DownloadBlob };
declare type DownloadBlob = typeof DownloadBlob;
declare const DownloadBlob: StateTransformer<SO.Root, SO.Data.Blob, PD.Normalize<{
    sources: PD.Normalize<{
        id: any;
        url: any;
        isBinary: any;
        canFail: any;
    }>[];
    maxConcurrency: number | undefined;
}>>;
export { ReadFile };
declare type ReadFile = typeof ReadFile;
declare const ReadFile: StateTransformer<SO.Root, SO.Data.String | SO.Data.Binary, PD.Normalize<{
    file: File;
    label: string | undefined;
    isBinary: boolean | undefined;
}>>;
export { ParseBlob };
declare type ParseBlob = typeof ParseBlob;
declare const ParseBlob: StateTransformer<SO.Data.Blob, SO.Format.Blob, PD.Normalize<{
    formats: PD.Normalize<{
        id: any;
        format: any;
    }>[];
}>>;
export { ParseCif };
declare type ParseCif = typeof ParseCif;
declare const ParseCif: StateTransformer<SO.Data.String | SO.Data.Binary, SO.Format.Cif, PD.Normalize<{}>>;
export { ParsePly };
declare type ParsePly = typeof ParsePly;
declare const ParsePly: StateTransformer<SO.Data.String, SO.Format.Ply, PD.Normalize<{}>>;
export { ParseCcp4 };
declare type ParseCcp4 = typeof ParseCcp4;
declare const ParseCcp4: StateTransformer<SO.Data.Binary, SO.Format.Ccp4, PD.Normalize<{}>>;
export { ParseDsn6 };
declare type ParseDsn6 = typeof ParseDsn6;
declare const ParseDsn6: StateTransformer<SO.Data.Binary, SO.Format.Dsn6, PD.Normalize<{}>>;
