/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Structure } from '../../../mol-model/structure';
import { Color } from '../../../mol-util/color';
import { Overpaint } from '../../../mol-theme/overpaint';
import { Transparency } from '../../../mol-theme/transparency';
declare type Script = {
    language: string;
    expression: string;
};
export declare function getStructureOverpaint(structure: Structure, scriptLayers: {
    script: Script;
    color: Color;
}[], alpha: number): Overpaint;
export declare function getStructureTransparency(structure: Structure, script: Script, value: number, variant: Transparency.Variant): Transparency;
/**
 * Attaches ComputedSecondaryStructure property when unavailable in sourceData
 */
export declare function ensureSecondaryStructure(s: Structure): Promise<void>;
export {};
