"use strict";
/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var mol_state_1 = require("../../../mol-state");
var mol_util_1 = require("../../../mol-util");
var param_definition_1 = require("../../../mol-util/param-definition");
var objects_1 = require("../objects");
var CreateGroup = objects_1.PluginStateTransform.BuiltIn({
    name: 'create-group',
    display: { name: 'Parse CIF', description: 'Parse CIF from String or Binary data' },
    from: [],
    to: objects_1.PluginStateObject.Group,
    params: {
        label: param_definition_1.ParamDefinition.Text('Group'),
        description: param_definition_1.ParamDefinition.Optional(param_definition_1.ParamDefinition.Text(''))
    }
})({
    apply: function (_a) {
        var params = _a.params;
        return new objects_1.PluginStateObject.Group({}, params);
    },
    update: function (_a) {
        var oldParams = _a.oldParams, newParams = _a.newParams, b = _a.b;
        if (mol_util_1.shallowEqual(oldParams, newParams))
            return mol_state_1.StateTransformer.UpdateResult.Unchanged;
        b.label = newParams.label;
        b.description = newParams.description;
        return mol_state_1.StateTransformer.UpdateResult.Updated;
    }
});
exports.CreateGroup = CreateGroup;
