/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Vec3 } from '../../../mol-math/linear-algebra';
import { ParamDefinition as PD } from '../../../mol-util/param-definition';
import { PluginStateObject as SO } from '../objects';
export { VolumeFromCcp4 };
export { VolumeFromDsn6 };
export { VolumeFromDensityServerCif };
declare type VolumeFromCcp4 = typeof VolumeFromCcp4;
declare const VolumeFromCcp4: import("../../../mol-state/transformer").StateTransformer<SO.Format.Ccp4, SO.Volume.Data, PD.Normalize<{
    voxelSize: Vec3;
}>>;
declare type VolumeFromDsn6 = typeof VolumeFromDsn6;
declare const VolumeFromDsn6: import("../../../mol-state/transformer").StateTransformer<SO.Format.Dsn6, SO.Volume.Data, PD.Normalize<{
    voxelSize: Vec3;
}>>;
declare type VolumeFromDensityServerCif = typeof VolumeFromDensityServerCif;
declare const VolumeFromDensityServerCif: import("../../../mol-state/transformer").StateTransformer<SO.Format.Cif, SO.Volume.Data, PD.Normalize<{
    blockHeader: string | undefined;
}>>;
