/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import * as React from 'react';
import { Observable } from 'rxjs';
import { PluginContext } from '../context';
export declare const PluginReactContext: React.Context<PluginContext>;
export declare abstract class PluginUIComponent<P = {}, S = {}, SS = {}> extends React.Component<P, S, SS> {
    static contextType: React.Context<PluginContext>;
    readonly plugin: PluginContext;
    private subs;
    protected subscribe<T>(obs: Observable<T>, action: (v: T) => void): void;
    componentWillUnmount(): void;
    protected init?(): void;
    constructor(props: P, context?: any);
}
export declare abstract class PurePluginUIComponent<P = {}, S = {}, SS = {}> extends React.PureComponent<P, S, SS> {
    static contextType: React.Context<PluginContext>;
    readonly plugin: PluginContext;
    private subs;
    protected subscribe<T>(obs: Observable<T>, action: (v: T) => void): void;
    componentWillUnmount(): void;
    protected init?(): void;
    constructor(props: P, context?: any);
}
export declare type _Props<C extends React.Component> = C extends React.Component<infer P> ? P : never;
export declare type _State<C extends React.Component> = C extends React.Component<any, infer S> ? S : never;
