"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var command_1 = require("../../mol-plugin/command");
var React = require("react");
var base_1 = require("./base");
var param_definition_1 = require("../../mol-util/param-definition");
var parameters_1 = require("./controls/parameters");
var common_1 = require("./controls/common");
var CameraSnapshots = /** @class */ (function (_super) {
    __extends(CameraSnapshots, _super);
    function CameraSnapshots() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CameraSnapshots.prototype.render = function () {
        return React.createElement("div", null,
            React.createElement("div", { className: 'msp-section-header' },
                React.createElement(common_1.Icon, { name: 'code' }),
                " Camera Snapshots"),
            React.createElement(CameraSnapshotControls, null),
            React.createElement(CameraSnapshotList, null));
    };
    return CameraSnapshots;
}(base_1.PluginUIComponent));
exports.CameraSnapshots = CameraSnapshots;
var CameraSnapshotControls = /** @class */ (function (_super) {
    __extends(CameraSnapshotControls, _super);
    function CameraSnapshotControls() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = param_definition_1.ParamDefinition.getDefaultValues(CameraSnapshotControls.Params);
        _this.add = function () {
            command_1.PluginCommands.Camera.Snapshots.Add.dispatch(_this.plugin, _this.state);
            _this.setState({ name: '', description: '' });
        };
        _this.clear = function () {
            command_1.PluginCommands.Camera.Snapshots.Clear.dispatch(_this.plugin, {});
        };
        return _this;
    }
    CameraSnapshotControls.prototype.render = function () {
        var _this = this;
        return React.createElement("div", null,
            React.createElement(parameters_1.ParameterControls, { params: CameraSnapshotControls.Params, values: this.state, onEnter: this.add, onChange: function (p) {
                    var _a;
                    return _this.setState((_a = {}, _a[p.name] = p.value, _a));
                } }),
            React.createElement("div", { className: 'msp-btn-row-group' },
                React.createElement("button", { className: 'msp-btn msp-btn-block msp-form-control', onClick: this.add }, "Add"),
                React.createElement("button", { className: 'msp-btn msp-btn-block msp-form-control', onClick: this.clear }, "Clear")));
    };
    CameraSnapshotControls.Params = {
        name: param_definition_1.ParamDefinition.Text(),
        description: param_definition_1.ParamDefinition.Text()
    };
    return CameraSnapshotControls;
}(base_1.PluginUIComponent));
var CameraSnapshotList = /** @class */ (function (_super) {
    __extends(CameraSnapshotList, _super);
    function CameraSnapshotList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CameraSnapshotList.prototype.componentDidMount = function () {
        var _this = this;
        this.subscribe(this.plugin.events.state.cameraSnapshots.changed, function () { return _this.forceUpdate(); });
    };
    CameraSnapshotList.prototype.apply = function (id) {
        var _this = this;
        return function () { return command_1.PluginCommands.Camera.Snapshots.Apply.dispatch(_this.plugin, { id: id }); };
    };
    CameraSnapshotList.prototype.remove = function (id) {
        var _this = this;
        return function () {
            command_1.PluginCommands.Camera.Snapshots.Remove.dispatch(_this.plugin, { id: id });
        };
    };
    CameraSnapshotList.prototype.render = function () {
        var _this = this;
        return React.createElement("ul", { style: { listStyle: 'none' }, className: 'msp-state-list' }, this.plugin.state.cameraSnapshots.state.entries.valueSeq().map(function (e) { return React.createElement("li", { key: e.id },
            React.createElement("button", { className: 'msp-btn msp-btn-block msp-form-control', onClick: _this.apply(e.id) },
                e.name || e.timestamp,
                " ",
                React.createElement("small", null, e.description)),
            React.createElement("button", { onClick: _this.remove(e.id), className: 'msp-btn msp-btn-link msp-state-list-remove-button' },
                React.createElement("span", { className: 'msp-icon msp-icon-remove' }))); }));
    };
    return CameraSnapshotList;
}(base_1.PluginUIComponent));
