/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import * as React from 'react';
import { PluginUIComponent } from './base';
import { LociLabelEntry } from '../../mol-plugin/util/loci-label-manager';
export declare class TrajectoryViewportControls extends PluginUIComponent<{}, {
    show: boolean;
    label: string;
}> {
    state: {
        show: boolean;
        label: string;
    };
    private update;
    componentDidMount(): void;
    reset: () => Promise<void>;
    prev: () => Promise<void>;
    next: () => Promise<void>;
    render(): JSX.Element | null;
}
export declare class StateSnapshotViewportControls extends PluginUIComponent<{}, {
    isBusy: boolean;
    show: boolean;
}> {
    state: {
        isBusy: boolean;
        show: boolean;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    keyUp: (e: KeyboardEvent) => void;
    update(id: string): Promise<void>;
    change: (e: React.ChangeEvent<HTMLSelectElement>) => void;
    prev: () => void;
    next: () => void;
    togglePlay: () => void;
    render(): JSX.Element | null;
}
export declare class AnimationViewportControls extends PluginUIComponent<{}, {
    isEmpty: boolean;
    isExpanded: boolean;
    isUpdating: boolean;
    isAnimating: boolean;
    isPlaying: boolean;
}> {
    state: {
        isEmpty: boolean;
        isExpanded: boolean;
        isUpdating: boolean;
        isAnimating: boolean;
        isPlaying: boolean;
    };
    componentDidMount(): void;
    toggleExpanded: () => void;
    stop: () => void;
    render(): JSX.Element | null;
}
export declare class LociLabelControl extends PluginUIComponent<{}, {
    entries: ReadonlyArray<LociLabelEntry>;
}> {
    state: {
        entries: never[];
    };
    componentDidMount(): void;
    render(): JSX.Element | null;
}
