"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var command_1 = require("../../mol-plugin/command");
var structure_1 = require("../../mol-plugin/state/actions/structure");
var base_1 = require("./base");
var common_1 = require("./controls/common");
var transforms_1 = require("../../mol-plugin/state/transforms");
var animation_1 = require("./state/animation");
var TrajectoryViewportControls = /** @class */ (function (_super) {
    __extends(TrajectoryViewportControls, _super);
    function TrajectoryViewportControls() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { show: false, label: '' };
        _this.update = function () {
            var state = _this.plugin.state.dataState;
            var models = state.selectQ(function (q) { return q.ofTransformer(transforms_1.StateTransforms.Model.ModelFromTrajectory); });
            if (models.length === 0) {
                _this.setState({ show: false });
                return;
            }
            var label = '', count = 0, parents = new Set();
            for (var _i = 0, models_1 = models; _i < models_1.length; _i++) {
                var m = models_1[_i];
                if (!m.sourceRef)
                    continue;
                var parent_1 = state.cells.get(m.sourceRef).obj;
                if (!parent_1)
                    continue;
                if (parent_1.data.length > 1) {
                    if (parents.has(m.sourceRef)) {
                        // do not show the controls if there are 2 models of the same trajectory present
                        _this.setState({ show: false });
                    }
                    parents.add(m.sourceRef);
                    count++;
                    if (!label) {
                        var idx = m.transform.params.modelIndex;
                        label = "Model " + (idx + 1) + " / " + parent_1.data.length;
                    }
                }
            }
            if (count > 1)
                label = '';
            _this.setState({ show: count > 0, label: label });
        };
        _this.reset = function () { return command_1.PluginCommands.State.ApplyAction.dispatch(_this.plugin, {
            state: _this.plugin.state.dataState,
            action: structure_1.UpdateTrajectory.create({ action: 'reset' })
        }); };
        _this.prev = function () { return command_1.PluginCommands.State.ApplyAction.dispatch(_this.plugin, {
            state: _this.plugin.state.dataState,
            action: structure_1.UpdateTrajectory.create({ action: 'advance', by: -1 })
        }); };
        _this.next = function () { return command_1.PluginCommands.State.ApplyAction.dispatch(_this.plugin, {
            state: _this.plugin.state.dataState,
            action: structure_1.UpdateTrajectory.create({ action: 'advance', by: 1 })
        }); };
        return _this;
    }
    TrajectoryViewportControls.prototype.componentDidMount = function () {
        this.subscribe(this.plugin.state.dataState.events.changed, this.update);
        this.subscribe(this.plugin.behaviors.state.isAnimating, this.update);
    };
    // stopAnimation = () => {
    //     this.plugin.state.animation.stop();
    // }
    // playAnimation = () => {
    //     const anim = this.plugin.state.animation;
    //     if (anim.state.params.current === AnimateModelIndex.name) {
    //         anim.start();
    //     } else {
    //         anim.play(AnimateModelIndex, ParamDefinition.getDefaultValues(AnimateModelIndex.params(this.plugin) as any as ParamDefinition.Params))
    //     }
    // }
    TrajectoryViewportControls.prototype.render = function () {
        var isAnimating = this.plugin.behaviors.state.isAnimating.value;
        if (!this.state.show || (isAnimating && !this.state.label))
            return null;
        return React.createElement("div", { className: 'msp-traj-controls' },
            !isAnimating && React.createElement(common_1.IconButton, { icon: 'model-first', title: 'First Model', onClick: this.reset, disabled: isAnimating }),
            !isAnimating && React.createElement(common_1.IconButton, { icon: 'model-prev', title: 'Previous Model', onClick: this.prev, disabled: isAnimating }),
            !isAnimating && React.createElement(common_1.IconButton, { icon: 'model-next', title: 'Next Model', onClick: this.next, disabled: isAnimating }),
            !!this.state.label && React.createElement("span", null, this.state.label));
    };
    return TrajectoryViewportControls;
}(base_1.PluginUIComponent));
exports.TrajectoryViewportControls = TrajectoryViewportControls;
var StateSnapshotViewportControls = /** @class */ (function (_super) {
    __extends(StateSnapshotViewportControls, _super);
    function StateSnapshotViewportControls() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { isBusy: false, show: true };
        _this.keyUp = function (e) {
            if (!e.ctrlKey || _this.state.isBusy || e.target !== document.body)
                return;
            var snapshots = _this.plugin.state.snapshots;
            if (e.keyCode === 37) { // left
                if (snapshots.state.isPlaying)
                    snapshots.stop();
                _this.prev();
            }
            else if (e.keyCode === 38) { // up
                if (snapshots.state.isPlaying)
                    snapshots.stop();
                if (snapshots.state.entries.size === 0)
                    return;
                var e_1 = snapshots.state.entries.get(0);
                _this.update(e_1.snapshot.id);
            }
            else if (e.keyCode === 39) { // right
                if (snapshots.state.isPlaying)
                    snapshots.stop();
                _this.next();
            }
            else if (e.keyCode === 40) { // down
                if (snapshots.state.isPlaying)
                    snapshots.stop();
                if (snapshots.state.entries.size === 0)
                    return;
                var e_2 = snapshots.state.entries.get(snapshots.state.entries.size - 1);
                _this.update(e_2.snapshot.id);
            }
        };
        _this.change = function (e) {
            if (e.target.value === 'none')
                return;
            _this.update(e.target.value);
        };
        _this.prev = function () {
            var s = _this.plugin.state.snapshots;
            var id = s.getNextId(s.state.current, -1);
            if (id)
                _this.update(id);
        };
        _this.next = function () {
            var s = _this.plugin.state.snapshots;
            var id = s.getNextId(s.state.current, 1);
            if (id)
                _this.update(id);
        };
        _this.togglePlay = function () {
            _this.plugin.state.snapshots.togglePlay();
        };
        return _this;
    }
    StateSnapshotViewportControls.prototype.componentDidMount = function () {
        var _this = this;
        // TODO: this needs to be diabled when the state is updating!
        this.subscribe(this.plugin.state.snapshots.events.changed, function () { return _this.forceUpdate(); });
        this.subscribe(this.plugin.behaviors.state.isUpdating, function (isBusy) { return _this.setState({ isBusy: isBusy }); });
        this.subscribe(this.plugin.behaviors.state.isAnimating, function (isBusy) { return _this.setState({ isBusy: isBusy }); });
        window.addEventListener('keyup', this.keyUp, false);
    };
    StateSnapshotViewportControls.prototype.componentWillUnmount = function () {
        _super.prototype.componentWillUnmount.call(this);
        window.removeEventListener('keyup', this.keyUp, false);
    };
    StateSnapshotViewportControls.prototype.update = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.setState({ isBusy: true });
                        return [4 /*yield*/, command_1.PluginCommands.State.Snapshots.Apply.dispatch(this.plugin, { id: id })];
                    case 1:
                        _a.sent();
                        this.setState({ isBusy: false });
                        return [2 /*return*/];
                }
            });
        });
    };
    StateSnapshotViewportControls.prototype.render = function () {
        var snapshots = this.plugin.state.snapshots;
        var count = snapshots.state.entries.size;
        if (count < 2 || !this.state.show) {
            return null;
        }
        var current = snapshots.state.current;
        var isPlaying = snapshots.state.isPlaying;
        return React.createElement("div", { className: 'msp-state-snapshot-viewport-controls' },
            React.createElement("select", { className: 'msp-form-control', value: current || 'none', onChange: this.change, disabled: this.state.isBusy || isPlaying },
                !current && React.createElement("option", { key: 'none', value: 'none' }),
                snapshots.state.entries.valueSeq().map(function (e, i) { return React.createElement("option", { key: e.snapshot.id, value: e.snapshot.id }, "[" + (i + 1) + "/" + count + "]",
                    " ",
                    e.name || new Date(e.timestamp).toLocaleString()); })),
            React.createElement(common_1.IconButton, { icon: isPlaying ? 'stop' : 'play', title: isPlaying ? 'Pause' : 'Cycle States', onClick: this.togglePlay, disabled: isPlaying ? false : this.state.isBusy }),
            !isPlaying && React.createElement(React.Fragment, null,
                React.createElement(common_1.IconButton, { icon: 'left-open', title: 'Previous State', onClick: this.prev, disabled: this.state.isBusy || isPlaying }),
                React.createElement(common_1.IconButton, { icon: 'right-open', title: 'Next State', onClick: this.next, disabled: this.state.isBusy || isPlaying })));
    };
    return StateSnapshotViewportControls;
}(base_1.PluginUIComponent));
exports.StateSnapshotViewportControls = StateSnapshotViewportControls;
var AnimationViewportControls = /** @class */ (function (_super) {
    __extends(AnimationViewportControls, _super);
    function AnimationViewportControls() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { isEmpty: true, isExpanded: false, isUpdating: false, isAnimating: false, isPlaying: false };
        _this.toggleExpanded = function () { return _this.setState({ isExpanded: !_this.state.isExpanded }); };
        _this.stop = function () {
            _this.plugin.state.animation.stop();
            _this.plugin.state.snapshots.stop();
        };
        return _this;
    }
    AnimationViewportControls.prototype.componentDidMount = function () {
        var _this = this;
        this.subscribe(this.plugin.state.snapshots.events.changed, function () {
            if (_this.plugin.state.snapshots.state.isPlaying)
                _this.setState({ isPlaying: true, isExpanded: false });
            else
                _this.setState({ isPlaying: false });
        });
        this.subscribe(this.plugin.behaviors.state.isUpdating, function (isUpdating) {
            if (isUpdating)
                _this.setState({ isUpdating: true, isExpanded: false, isEmpty: _this.plugin.state.dataState.tree.transforms.size < 2 });
            else
                _this.setState({ isUpdating: false, isEmpty: _this.plugin.state.dataState.tree.transforms.size < 2 });
        });
        this.subscribe(this.plugin.behaviors.state.isAnimating, function (isAnimating) {
            if (isAnimating)
                _this.setState({ isAnimating: true, isExpanded: false });
            else
                _this.setState({ isAnimating: false });
        });
    };
    AnimationViewportControls.prototype.render = function () {
        // if (!this.state.show) return null;
        var isPlaying = this.plugin.state.snapshots.state.isPlaying;
        if (isPlaying)
            return null;
        var isAnimating = this.state.isAnimating;
        return React.createElement("div", { className: 'msp-animation-viewport-controls' },
            React.createElement(common_1.IconButton, { icon: isAnimating || isPlaying ? 'stop' : 'play', title: isAnimating ? 'Stop' : 'Select Animation', onClick: isAnimating || isPlaying ? this.stop : this.toggleExpanded, disabled: isAnimating || isPlaying ? false : this.state.isUpdating || this.state.isPlaying || this.state.isEmpty }),
            (this.state.isExpanded && !this.state.isUpdating) && React.createElement("div", { className: 'msp-animation-viewport-controls-select' },
                React.createElement(animation_1.AnimationControls, { onStart: this.toggleExpanded })));
    };
    return AnimationViewportControls;
}(base_1.PluginUIComponent));
exports.AnimationViewportControls = AnimationViewportControls;
var LociLabelControl = /** @class */ (function (_super) {
    __extends(LociLabelControl, _super);
    function LociLabelControl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { entries: [] };
        return _this;
    }
    LociLabelControl.prototype.componentDidMount = function () {
        var _this = this;
        this.subscribe(this.plugin.behaviors.labels.highlight, function (e) { return _this.setState({ entries: e.entries }); });
    };
    LociLabelControl.prototype.render = function () {
        if (this.state.entries.length === 0)
            return null;
        return React.createElement("div", { className: 'msp-highlight-info' }, this.state.entries.map(function (e, i) { return React.createElement("div", { key: '' + i }, e); }));
    };
    return LociLabelControl;
}(base_1.PluginUIComponent));
exports.LociLabelControl = LociLabelControl;
