/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import * as React from 'react';
import { Color } from '../../../mol-util/color';
export declare class ControlGroup extends React.Component<{
    header: string;
    initialExpanded?: boolean;
}, {
    isExpanded: boolean;
}> {
    state: {
        isExpanded: boolean;
    };
    toggleExpanded: () => void;
    render(): JSX.Element;
}
export declare class NumericInput extends React.PureComponent<{
    value: number;
    onChange: (v: number) => void;
    onEnter?: () => void;
    onBlur?: () => void;
    blurOnEnter?: boolean;
    isDisabled?: boolean;
    placeholder?: string;
}, {
    value: string;
}> {
    state: {
        value: string;
    };
    input: React.RefObject<HTMLInputElement>;
    onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onKeyPress: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    onBlur: () => void;
    static getDerivedStateFromProps(props: {
        value: number;
    }, state: {
        value: string;
    }): {
        value: string;
    } | null;
    render(): JSX.Element;
}
export declare function Icon(props: {
    name: string;
}): JSX.Element;
export declare function IconButton(props: {
    icon: string;
    isSmall?: boolean;
    onClick: (e: React.MouseEvent<HTMLButtonElement>) => void;
    title?: string;
    toggleState?: boolean;
    disabled?: boolean;
    customClass?: string;
    'data-id'?: string;
}): JSX.Element;
export declare class ExpandableGroup extends React.Component<{
    label: string;
    colorStripe?: Color;
    pivot: JSX.Element;
    controls: JSX.Element;
}, {
    isExpanded: boolean;
}> {
    state: {
        isExpanded: boolean;
    };
    toggleExpanded: () => void;
    render(): JSX.Element;
}
