/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { List } from 'immutable';
import { PluginState } from '../../mol-plugin/state';
import { LogEntry } from '../../mol-util/log-entry';
import * as React from 'react';
import { PluginContext } from '../context';
import { PluginUIComponent } from './base';
export declare class Plugin extends React.Component<{
    plugin: PluginContext;
}, {}> {
    region(kind: 'left' | 'right' | 'bottom' | 'main', element: JSX.Element): JSX.Element;
    render(): JSX.Element;
}
export declare class PluginContextContainer extends React.Component<{
    plugin: PluginContext;
}> {
    render(): JSX.Element;
}
export declare class ControlsWrapper extends PluginUIComponent {
    render(): JSX.Element;
}
export declare class ViewportWrapper extends PluginUIComponent {
    render(): JSX.Element;
}
export declare class State extends PluginUIComponent {
    componentDidMount(): void;
    set(kind: PluginState.Kind): void;
    render(): JSX.Element;
}
export declare class Log extends PluginUIComponent<{}, {
    entries: List<LogEntry>;
}> {
    private wrapper;
    componentDidMount(): void;
    componentDidUpdate(): void;
    state: {
        entries: List<LogEntry>;
    };
    private scrollToBottom;
    render(): JSX.Element;
}
export declare class CurrentObject extends PluginUIComponent {
    readonly current: import("../../mol-state/state").State.ObjectEvent;
    componentDidMount(): void;
    render(): JSX.Element | null;
}
