/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import * as React from 'react';
import { PluginUIComponent } from '../base';
import { ButtonsType, ModifiersKeys } from '../../../mol-util/input/input-observer';
import { ValueBox } from '../../../mol-util';
import { StructureSeq } from './util';
declare type BaseSequenceProps = {
    structureSeq: StructureSeq;
    markerArray: Uint8Array;
};
declare type BaseSequenceState = {
    markerData: ValueBox<Uint8Array>;
};
export declare class BaseSequence extends PluginUIComponent<BaseSequenceProps, BaseSequenceState> {
    state: {
        markerData: ValueBox<Uint8Array, never>;
    };
    private lociHighlightProvider;
    private lociSelectionProvider;
    static getDerivedStateFromProps(nextProps: BaseSequenceProps, prevState: BaseSequenceState): BaseSequenceState | null;
    componentDidMount(): void;
    componentWillUnmount(): void;
    getLoci(seqId: number): import("../../../mol-model/structure/structure/element").default.Loci;
    highlight(seqId?: number, modifiers?: ModifiersKeys): void;
    click(seqId: number | undefined, buttons: ButtonsType, modifiers: ModifiersKeys): void;
    contextMenu: (e: React.MouseEvent<Element, MouseEvent>) => void;
    mouseDown: (e: React.MouseEvent<Element, MouseEvent>) => void;
    render(): JSX.Element;
}
export {};
