/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Structure, StructureElement, Unit } from '../../../mol-model/structure';
import { SequenceWrapper } from './util';
import { Interval } from '../../../mol-data/int';
import { Loci } from '../../../mol-model/loci';
export declare type StructureUnit = {
    structure: Structure;
    unit: Unit;
};
export declare class PolymerSequenceWrapper extends SequenceWrapper<StructureUnit> {
    private readonly location;
    private readonly sequence;
    private readonly missing;
    private readonly modelNum;
    private readonly asymId;
    seqId(i: number): number;
    residueLabel(i: number): import("../../../mol-model/sequence/constants").AminoAlphabet;
    residueColor(i: number): import("../../../mol-util/color").Color;
    eachResidue(loci: Loci, apply: (interval: Interval) => boolean): boolean;
    getLoci(seqId: number): StructureElement.Loci;
    constructor(data: StructureUnit);
}
