"use strict";
/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_1 = require("../base");
var input_observer_1 = require("../../../mol-util/input/input-observer");
var color_1 = require("../../../mol-util/color");
var Residue = /** @class */ (function (_super) {
    __extends(Residue, _super);
    function Residue() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mouseEnter = function (e) {
            var modifiers = input_observer_1.getModifiers(e.nativeEvent);
            _this.props.parent.highlight(_this.props.seqId, modifiers);
        };
        _this.mouseLeave = function () {
            _this.props.parent.highlight();
        };
        _this.mouseDown = function (e) {
            var buttons = input_observer_1.getButtons(e.nativeEvent);
            var modifiers = input_observer_1.getModifiers(e.nativeEvent);
            _this.props.parent.click(_this.props.seqId, buttons, modifiers);
            e.stopPropagation(); // so that `parent.mouseDown` is not called
        };
        return _this;
    }
    Residue.prototype.getBackgroundColor = function () {
        // TODO make marker color configurable
        if (this.props.marker === 0)
            return '';
        if (this.props.marker % 2 === 0)
            return 'rgb(51, 255, 25)'; // selected
        if (this.props.marker === undefined)
            console.error('unexpected marker value');
        return 'rgb(255, 102, 153)'; // highlighted
    };
    Residue.prototype.render = function () {
        return React.createElement("span", { onMouseEnter: this.mouseEnter, onMouseLeave: this.mouseLeave, onMouseDown: this.mouseDown, style: {
                color: color_1.Color.toStyle(this.props.color),
                backgroundColor: this.getBackgroundColor()
            } }, this.props.label);
    };
    return Residue;
}(base_1.PurePluginUIComponent));
exports.Residue = Residue;
