/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import * as React from 'react';
import { PluginUIComponent } from '../base';
import { ButtonsType, ModifiersKeys } from '../../../mol-util/input/input-observer';
import { ValueBox } from '../../../mol-util';
import { SequenceWrapper } from './util';
declare type SequenceProps = {
    sequenceWrapper: SequenceWrapper.Any;
};
declare type SequenceState = {
    markerData: ValueBox<Uint8Array>;
};
export declare class Sequence<P extends SequenceProps> extends PluginUIComponent<P, SequenceState> {
    state: {
        markerData: ValueBox<Uint8Array, never>;
    };
    private setMarkerData;
    private lociHighlightProvider;
    private lociSelectionProvider;
    static getDerivedStateFromProps(nextProps: SequenceProps, prevState: SequenceState): SequenceState | null;
    componentDidMount(): void;
    componentWillUnmount(): void;
    highlight(seqId?: number, modifiers?: ModifiersKeys): void;
    click(seqId: number | undefined, buttons: ButtonsType, modifiers: ModifiersKeys): void;
    contextMenu: (e: React.MouseEvent<Element, MouseEvent>) => void;
    mouseDown: (e: React.MouseEvent<Element, MouseEvent>) => void;
    render(): JSX.Element;
}
export {};
