"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var marker_action_1 = require("../../../mol-util/marker-action");
var SequenceWrapper = /** @class */ (function () {
    function SequenceWrapper(data, markerArray, length) {
        this.data = data;
        this.markerArray = markerArray;
        this.length = length;
    }
    SequenceWrapper.prototype.markResidue = function (loci, action) {
        var _this = this;
        return this.eachResidue(loci, function (i) {
            return marker_action_1.applyMarkerAction(_this.markerArray, i, action);
        });
    };
    return SequenceWrapper;
}());
exports.SequenceWrapper = SequenceWrapper;
