"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var command_1 = require("../../mol-plugin/command");
var React = require("react");
var base_1 = require("./base");
var mol_util_1 = require("../../mol-util");
var immutable_1 = require("immutable");
var parameters_1 = require("./controls/parameters");
var param_definition_1 = require("../../mol-util/param-definition");
var state_1 = require("../../mol-plugin/state");
var url_1 = require("../../mol-util/url");
var common_1 = require("./controls/common");
var now_1 = require("../../mol-util/now");
var StateSnapshots = /** @class */ (function (_super) {
    __extends(StateSnapshots, _super);
    function StateSnapshots() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.downloadToFile = function () {
            command_1.PluginCommands.State.Snapshots.DownloadToFile.dispatch(_this.plugin, {});
        };
        _this.open = function (e) {
            if (!e.target.files || !e.target.files[0])
                return;
            command_1.PluginCommands.State.Snapshots.OpenFile.dispatch(_this.plugin, { file: e.target.files[0] });
        };
        return _this;
    }
    StateSnapshots.prototype.render = function () {
        return React.createElement("div", null,
            React.createElement("div", { className: 'msp-section-header' },
                React.createElement(common_1.Icon, { name: 'code' }),
                " State"),
            React.createElement(LocalStateSnapshots, null),
            React.createElement(LocalStateSnapshotList, null),
            React.createElement(RemoteStateSnapshots, null),
            React.createElement("div", { className: 'msp-btn-row-group', style: { marginTop: '10px' } },
                React.createElement("button", { className: 'msp-btn msp-btn-block msp-form-control', onClick: this.downloadToFile }, "Download JSON"),
                React.createElement("div", { className: 'msp-btn msp-btn-block msp-btn-action msp-loader-msp-btn-file' },
                    'Open JSON',
                    " ",
                    React.createElement("input", { onChange: this.open, type: 'file', multiple: false, accept: '.json' }))));
    };
    return StateSnapshots;
}(base_1.PluginUIComponent));
exports.StateSnapshots = StateSnapshots;
var LocalStateSnapshots = /** @class */ (function (_super) {
    __extends(LocalStateSnapshots, _super);
    function LocalStateSnapshots() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { params: param_definition_1.ParamDefinition.getDefaultValues(LocalStateSnapshots.Params) };
        _this.add = function () {
            command_1.PluginCommands.State.Snapshots.Add.dispatch(_this.plugin, {
                name: _this.state.params.name,
                description: _this.state.params.options.description,
                params: _this.state.params.options
            });
            _this.setState({
                params: {
                    name: '',
                    options: __assign({}, _this.state.params.options, { description: '' })
                }
            });
        };
        _this.clear = function () {
            command_1.PluginCommands.State.Snapshots.Clear.dispatch(_this.plugin, {});
        };
        return _this;
    }
    LocalStateSnapshots.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return !mol_util_1.shallowEqual(this.props, nextProps) || !mol_util_1.shallowEqual(this.state, nextState);
    };
    LocalStateSnapshots.prototype.render = function () {
        var _this = this;
        // TODO: proper styling
        return React.createElement("div", null,
            React.createElement(parameters_1.ParameterControls, { params: LocalStateSnapshots.Params, values: this.state.params, onEnter: this.add, onChange: function (p) {
                    var _a;
                    var params = __assign({}, _this.state.params, (_a = {}, _a[p.name] = p.value, _a));
                    _this.setState({ params: params });
                    _this.plugin.state.snapshots.currentGetSnapshotParams = params.options;
                } }),
            React.createElement("div", { className: 'msp-btn-row-group' },
                React.createElement("button", { className: 'msp-btn msp-btn-block msp-form-control', onClick: this.add },
                    React.createElement(common_1.Icon, { name: 'floppy' }),
                    " Save"),
                React.createElement("button", { className: 'msp-btn msp-btn-block msp-form-control', onClick: this.clear }, "Clear")));
    };
    LocalStateSnapshots.Params = {
        name: param_definition_1.ParamDefinition.Text(),
        options: param_definition_1.ParamDefinition.Group(__assign({ description: param_definition_1.ParamDefinition.Text() }, state_1.PluginState.GetSnapshotParams))
    };
    return LocalStateSnapshots;
}(base_1.PluginUIComponent));
var LocalStateSnapshotList = /** @class */ (function (_super) {
    __extends(LocalStateSnapshotList, _super);
    function LocalStateSnapshotList() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.apply = function (e) {
            var id = e.currentTarget.getAttribute('data-id');
            if (!id)
                return;
            command_1.PluginCommands.State.Snapshots.Apply.dispatch(_this.plugin, { id: id });
        };
        _this.remove = function (e) {
            var id = e.currentTarget.getAttribute('data-id');
            if (!id)
                return;
            command_1.PluginCommands.State.Snapshots.Remove.dispatch(_this.plugin, { id: id });
        };
        _this.moveUp = function (e) {
            var id = e.currentTarget.getAttribute('data-id');
            if (!id)
                return;
            command_1.PluginCommands.State.Snapshots.Move.dispatch(_this.plugin, { id: id, dir: -1 });
        };
        _this.moveDown = function (e) {
            var id = e.currentTarget.getAttribute('data-id');
            if (!id)
                return;
            command_1.PluginCommands.State.Snapshots.Move.dispatch(_this.plugin, { id: id, dir: 1 });
        };
        _this.replace = function (e) {
            var id = e.currentTarget.getAttribute('data-id');
            if (!id)
                return;
            command_1.PluginCommands.State.Snapshots.Replace.dispatch(_this.plugin, { id: id, params: _this.plugin.state.snapshots.currentGetSnapshotParams });
        };
        return _this;
    }
    LocalStateSnapshotList.prototype.componentDidMount = function () {
        var _this = this;
        this.subscribe(this.plugin.events.state.snapshots.changed, function () { return _this.forceUpdate(); });
    };
    LocalStateSnapshotList.prototype.render = function () {
        var _this = this;
        var current = this.plugin.state.snapshots.state.current;
        return React.createElement("ul", { style: { listStyle: 'none' }, className: 'msp-state-list' }, this.plugin.state.snapshots.state.entries.map(function (e) { return React.createElement("li", { key: e.snapshot.id },
            React.createElement("button", { "data-id": e.snapshot.id, className: 'msp-btn msp-btn-block msp-form-control', onClick: _this.apply },
                React.createElement("span", { style: { fontWeight: e.snapshot.id === current ? 'bold' : void 0 } }, e.name || new Date(e.timestamp).toLocaleString()),
                " ",
                React.createElement("small", null, "" + (e.snapshot.durationInMs ? now_1.formatTimespan(e.snapshot.durationInMs, false) + ("" + (e.description ? ', ' : '')) : '') + (e.description ? e.description : ''))),
            React.createElement("div", null,
                React.createElement(common_1.IconButton, { "data-id": e.snapshot.id, icon: 'up-thin', title: 'Move Up', onClick: _this.moveUp, isSmall: true }),
                React.createElement(common_1.IconButton, { "data-id": e.snapshot.id, icon: 'down-thin', title: 'Move Down', onClick: _this.moveDown, isSmall: true }),
                React.createElement(common_1.IconButton, { "data-id": e.snapshot.id, icon: 'switch', title: 'Replace', onClick: _this.replace, isSmall: true }),
                React.createElement(common_1.IconButton, { "data-id": e.snapshot.id, icon: 'remove', title: 'Remove', onClick: _this.remove, isSmall: true }))); }));
    };
    return LocalStateSnapshotList;
}(base_1.PluginUIComponent));
var RemoteStateSnapshots = /** @class */ (function (_super) {
    __extends(RemoteStateSnapshots, _super);
    function RemoteStateSnapshots() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { params: param_definition_1.ParamDefinition.getDefaultValues(RemoteStateSnapshots.Params), entries: immutable_1.OrderedMap(), isBusy: false };
        _this.refresh = function () { return __awaiter(_this, void 0, void 0, function () {
            var json, entries, _i, json_1, e, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        this.setState({ isBusy: true });
                        return [4 /*yield*/, this.plugin.runTask(this.plugin.fetch({ url: this.serverUrl('list'), type: 'json' }))];
                    case 1:
                        json = (_a.sent()) || [];
                        json.sort(function (a, b) {
                            if (a.isSticky === b.isSticky)
                                return a.timestamp - b.timestamp;
                            return a.isSticky ? -1 : 1;
                        });
                        entries = immutable_1.OrderedMap().asMutable();
                        for (_i = 0, json_1 = json; _i < json_1.length; _i++) {
                            e = json_1[_i];
                            entries.set(e.id, __assign({}, e, { url: this.serverUrl("get/" + e.id), removeUrl: this.serverUrl("remove/" + e.id) }));
                        }
                        this.setState({ entries: entries.asImmutable(), isBusy: false });
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        this.plugin.log.error('Fetching Remote Snapshots: ' + e_1);
                        this.setState({ entries: immutable_1.OrderedMap(), isBusy: false });
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); };
        _this.upload = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.setState({ isBusy: true });
                        if (!(this.plugin.state.snapshots.state.entries.size === 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, command_1.PluginCommands.State.Snapshots.Add.dispatch(this.plugin, {
                                name: this.state.params.name,
                                description: this.state.params.options.description,
                                params: this.plugin.state.snapshots.currentGetSnapshotParams
                            })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [4 /*yield*/, command_1.PluginCommands.State.Snapshots.Upload.dispatch(this.plugin, {
                            name: this.state.params.name,
                            description: this.state.params.options.description,
                            playOnLoad: this.state.params.options.playOnLoad,
                            serverUrl: this.state.params.options.serverUrl
                        })];
                    case 3:
                        _a.sent();
                        this.setState({ isBusy: false });
                        this.plugin.log.message('Snapshot uploaded.');
                        this.refresh();
                        return [2 /*return*/];
                }
            });
        }); };
        _this.fetch = function (e) { return __awaiter(_this, void 0, void 0, function () {
            var id, entry;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        id = e.currentTarget.getAttribute('data-id');
                        if (!id)
                            return [2 /*return*/];
                        entry = this.state.entries.get(id);
                        if (!entry)
                            return [2 /*return*/];
                        this.setState({ isBusy: true });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, , 3, 4]);
                        return [4 /*yield*/, command_1.PluginCommands.State.Snapshots.Fetch.dispatch(this.plugin, { url: entry.url })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        this.setState({ isBusy: false });
                        return [7 /*endfinally*/];
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        _this.remove = function (e) { return __awaiter(_this, void 0, void 0, function () {
            var id, entry, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        id = e.currentTarget.getAttribute('data-id');
                        if (!id)
                            return [2 /*return*/];
                        entry = this.state.entries.get(id);
                        if (!entry)
                            return [2 /*return*/];
                        this.setState({ entries: this.state.entries.remove(id) });
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, fetch(entry.removeUrl)];
                    case 2:
                        _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        return _this;
    }
    RemoteStateSnapshots.prototype.componentDidMount = function () {
        this.refresh();
        // this.subscribe(UploadedEvent, this.refresh);
    };
    RemoteStateSnapshots.prototype.serverUrl = function (q) {
        if (!q)
            return this.state.params.options.serverUrl;
        return url_1.urlCombine(this.state.params.options.serverUrl, q);
    };
    RemoteStateSnapshots.prototype.render = function () {
        var _this = this;
        return React.createElement("div", null,
            React.createElement("div", { className: 'msp-section-header' },
                React.createElement(common_1.Icon, { name: 'code' }),
                " Remote State"),
            React.createElement(parameters_1.ParameterControls, { params: RemoteStateSnapshots.Params, values: this.state.params, onEnter: this.upload, onChange: function (p) {
                    var _a;
                    _this.setState({ params: __assign({}, _this.state.params, (_a = {}, _a[p.name] = p.value, _a)) });
                }, isDisabled: this.state.isBusy }),
            React.createElement("div", { className: 'msp-btn-row-group' },
                React.createElement("button", { className: 'msp-btn msp-btn-block msp-form-control', onClick: this.upload, disabled: this.state.isBusy },
                    React.createElement(common_1.Icon, { name: 'upload' }),
                    " Upload"),
                React.createElement("button", { className: 'msp-btn msp-btn-block msp-form-control', onClick: this.refresh, disabled: this.state.isBusy }, "Refresh")),
            React.createElement(RemoteStateSnapshotList, { entries: this.state.entries, isBusy: this.state.isBusy, serverUrl: this.state.params.options.serverUrl, fetch: this.fetch, remove: this.remove }));
    };
    RemoteStateSnapshots.Params = {
        name: param_definition_1.ParamDefinition.Text(),
        options: param_definition_1.ParamDefinition.Group({
            description: param_definition_1.ParamDefinition.Text(),
            playOnLoad: param_definition_1.ParamDefinition.Boolean(false),
            serverUrl: param_definition_1.ParamDefinition.Text('https://webchem.ncbr.muni.cz/molstar-state')
        })
    };
    return RemoteStateSnapshots;
}(base_1.PluginUIComponent));
var RemoteStateSnapshotList = /** @class */ (function (_super) {
    __extends(RemoteStateSnapshotList, _super);
    function RemoteStateSnapshotList() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.open = function (e) { return __awaiter(_this, void 0, void 0, function () {
            var id, entry, url, qi;
            return __generator(this, function (_a) {
                id = e.currentTarget.getAttribute('data-id');
                if (!id)
                    return [2 /*return*/];
                entry = this.props.entries.get(id);
                if (!entry)
                    return [2 /*return*/];
                e.preventDefault();
                url = "" + window.location, qi = url.indexOf('?');
                if (qi > 0)
                    url = url.substr(0, qi);
                window.open(url + "?snapshot-url=" + encodeURIComponent(entry.url), '_blank');
                return [2 /*return*/];
            });
        }); };
        return _this;
    }
    RemoteStateSnapshotList.prototype.render = function () {
        var _this = this;
        return React.createElement("ul", { style: { listStyle: 'none' }, className: 'msp-state-list' }, this.props.entries.valueSeq().map(function (e) { return React.createElement("li", { key: e.id },
            React.createElement("button", { "data-id": e.id, className: 'msp-btn msp-btn-block msp-form-control', onClick: _this.props.fetch, disabled: _this.props.isBusy, onContextMenu: _this.open, title: 'Click to download, right-click to open in a new tab.' },
                e.name || new Date(e.timestamp).toLocaleString(),
                " ",
                React.createElement("small", null, e.description)),
            !e.isSticky && React.createElement("div", null,
                React.createElement(common_1.IconButton, { "data-id": e.id, icon: 'remove', title: 'Remove', onClick: _this.props.remove, disabled: _this.props.isBusy }))); }));
    };
    return RemoteStateSnapshotList;
}(base_1.PurePluginUIComponent));
