"use strict";
/**
 * Copyright (c) 2018 - 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_1 = require("../base");
var apply_action_1 = require("./apply-action");
var common_1 = require("../controls/common");
var StateObjectActions = /** @class */ (function (_super) {
    __extends(StateObjectActions, _super);
    function StateObjectActions() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(StateObjectActions.prototype, "current", {
        get: function () {
            return this.plugin.state.behavior.currentObject.value;
        },
        enumerable: true,
        configurable: true
    });
    StateObjectActions.prototype.componentDidMount = function () {
        var _this = this;
        this.subscribe(this.plugin.state.behavior.currentObject, function (o) {
            _this.forceUpdate();
        });
        this.subscribe(this.plugin.events.state.object.updated, function (_a) {
            var ref = _a.ref, state = _a.state;
            var current = _this.current;
            if (current.ref !== ref || current.state !== state)
                return;
            _this.forceUpdate();
        });
    };
    StateObjectActions.prototype.render = function () {
        var _this = this;
        var _a = this.props, state = _a.state, ref = _a.nodeRef;
        var cell = state.cells.get(ref);
        var actions = state.actions.fromCell(cell, this.plugin);
        if (actions.length === 0)
            return null;
        var def = cell.transform.transformer.definition;
        var display = cell.obj ? cell.obj.label : (def.display && def.display.name) || def.name;
        return React.createElement("div", { className: 'msp-state-actions' },
            !this.props.hideHeader && React.createElement("div", { className: 'msp-section-header' },
                React.createElement(common_1.Icon, { name: 'code' }),
                " ", "Actions (" + display + ")"),
            actions.map(function (act, i) { return React.createElement(apply_action_1.ApplyActionControl, { plugin: _this.plugin, key: "" + act.id, state: state, action: act, nodeRef: ref, initiallyCollapsed: _this.props.initiallyColapsed }); }));
    };
    return StateObjectActions;
}(base_1.PluginUIComponent));
exports.StateObjectActions = StateObjectActions;
