"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_1 = require("../base");
var parameters_1 = require("../controls/parameters");
var common_1 = require("../controls/common");
var AnimationControlsWrapper = /** @class */ (function (_super) {
    __extends(AnimationControlsWrapper, _super);
    function AnimationControlsWrapper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AnimationControlsWrapper.prototype.render = function () {
        var anim = this.plugin.state.animation;
        if (anim.isEmpty)
            return null;
        return React.createElement("div", { className: 'msp-controls-section' },
            React.createElement("div", { className: 'msp-section-header' },
                React.createElement(common_1.Icon, { name: 'code' }),
                " Animations"),
            React.createElement(AnimationControls, null));
    };
    return AnimationControlsWrapper;
}(base_1.PluginUIComponent));
exports.AnimationControlsWrapper = AnimationControlsWrapper;
var AnimationControls = /** @class */ (function (_super) {
    __extends(AnimationControls, _super);
    function AnimationControls() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.updateParams = function (p) {
            var _a;
            _this.plugin.state.animation.updateParams((_a = {}, _a[p.name] = p.value, _a));
        };
        _this.updateCurrentParams = function (p) {
            var _a;
            _this.plugin.state.animation.updateCurrentParams((_a = {}, _a[p.name] = p.value, _a));
        };
        _this.startOrStop = function () {
            var anim = _this.plugin.state.animation;
            if (anim.state.animationState === 'playing')
                anim.stop();
            else {
                if (_this.props.onStart)
                    _this.props.onStart();
                anim.start();
            }
        };
        return _this;
    }
    AnimationControls.prototype.componentDidMount = function () {
        var _this = this;
        this.subscribe(this.plugin.state.animation.events.updated, function () { return _this.forceUpdate(); });
    };
    AnimationControls.prototype.render = function () {
        var anim = this.plugin.state.animation;
        if (anim.isEmpty)
            return null;
        var isDisabled = anim.state.animationState === 'playing';
        return React.createElement(React.Fragment, null,
            React.createElement(parameters_1.ParameterControls, { params: anim.getParams(), values: anim.state.params, onChange: this.updateParams, isDisabled: isDisabled }),
            React.createElement(parameters_1.ParameterControls, { params: anim.current.params, values: anim.current.paramValues, onChange: this.updateCurrentParams, isDisabled: isDisabled }),
            React.createElement("div", { className: 'msp-btn-row-group' },
                React.createElement("button", { className: 'msp-btn msp-btn-block msp-form-control', onClick: this.startOrStop },
                    anim.state.animationState !== 'playing' && React.createElement(common_1.Icon, { name: 'play' }),
                    anim.state.animationState === 'playing' ? 'Stop' : 'Start')));
    };
    return AnimationControls;
}(base_1.PluginUIComponent));
exports.AnimationControls = AnimationControls;
