/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
/// <reference types="react" />
import { State, StateTransform, StateTransformer } from '../../../mol-state';
import { TransformControlBase } from './common';
import { Observable } from 'rxjs';
import { PluginUIComponent } from '../base';
export { UpdateTransformControl, TransformUpdaterControl };
declare namespace UpdateTransformControl {
    interface Props {
        transform: StateTransform;
        state: State;
        toggleCollapsed?: Observable<any>;
        initiallyCollapsed?: boolean;
        customHeader?: StateTransformer.Definition['display'];
    }
    interface ComponentState extends TransformControlBase.ComponentState {
        transform: StateTransform;
    }
}
declare class UpdateTransformControl extends TransformControlBase<UpdateTransformControl.Props, UpdateTransformControl.ComponentState> {
    applyAction(): Promise<void>;
    getInfo(): {
        params: import("../../../mol-util/param-definition").ParamDefinition.Params;
        initialValues: any;
        isEmpty: boolean;
    };
    getTransformerId(): StateTransformer.Id;
    getHeader(): {
        readonly name: string;
        readonly description?: string | undefined;
    };
    canApply(): boolean;
    applyText(): "Update" | "Nothing to Update";
    isUpdate(): boolean;
    getSourceAndTarget(): {
        a: import("../../../mol-state/object").StateObject<any, import("../../../mol-state/object").StateObject.Type<any>> | undefined;
        b: import("../../../mol-state/object").StateObject<any, import("../../../mol-state/object").StateObject.Type<any>> | undefined;
    };
    canAutoApply(newParams: any): boolean;
    componentDidMount(): void;
    private _getInfo;
    state: UpdateTransformControl.ComponentState;
    static getDerivedStateFromProps(props: UpdateTransformControl.Props, state: UpdateTransformControl.ComponentState): Partial<UpdateTransformControl.ComponentState> | null;
}
declare class TransformUpdaterControl extends PluginUIComponent<{
    nodeRef: string;
    initiallyCollapsed?: boolean;
    header?: StateTransformer.Definition['display'];
}> {
    componentDidMount(): void;
    render(): JSX.Element | null;
}
