/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import * as React from 'react';
import { PluginUIComponent } from './base';
import { ParamDefinition as PD } from '../../mol-util/param-definition';
interface ViewportState {
    noWebGl: boolean;
}
export declare class ViewportControls extends PluginUIComponent<{}, {
    isSettingsExpanded: boolean;
}> {
    state: {
        isSettingsExpanded: boolean;
    };
    resetCamera: () => void;
    toggleSettingsExpanded: (e: React.MouseEvent<HTMLButtonElement, MouseEvent>) => void;
    toggleControls: () => void;
    toggleExpanded: () => void;
    setSettings: (p: {
        param: PD.Base<any>;
        name: string;
        value: any;
    }) => void;
    setLayout: (p: {
        param: PD.Base<any>;
        name: string;
        value: any;
    }) => void;
    setInteractivityProps: (p: {
        param: PD.Base<any>;
        name: string;
        value: any;
    }) => void;
    componentDidMount(): void;
    icon(name: string, onClick: (e: React.MouseEvent<HTMLButtonElement>) => void, title: string, isOn?: boolean): JSX.Element;
    render(): JSX.Element;
}
export declare class Viewport extends PluginUIComponent<{}, ViewportState> {
    private container;
    private canvas;
    state: ViewportState;
    private handleResize;
    componentDidMount(): void;
    componentWillUnmount(): void;
    renderMissing(): JSX.Element;
    render(): JSX.Element;
}
export {};
