"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var LociLabelManager = /** @class */ (function () {
    function LociLabelManager(ctx) {
        var _this = this;
        this.ctx = ctx;
        this.providers = [];
        this.empty = [];
        ctx.behaviors.interaction.highlight.subscribe(function (ev) { return ctx.behaviors.labels.highlight.next({ entries: _this.getInfo(ev.current) }); });
    }
    LociLabelManager.prototype.addProvider = function (provider) {
        this.providers.push(provider);
    };
    LociLabelManager.prototype.removeProvider = function (provider) {
        this.providers = this.providers.filter(function (p) { return p !== provider; });
        // Event.Interactivity.Highlight.dispatch(this.ctx, []);
    };
    LociLabelManager.prototype.getInfo = function (_a) {
        var loci = _a.loci, repr = _a.repr;
        if (!loci || loci.kind === 'empty-loci')
            return this.empty;
        var info = [];
        for (var _i = 0, _b = this.providers; _i < _b.length; _i++) {
            var p = _b[_i];
            var e = p(loci, repr);
            if (e)
                info.push(e);
        }
        return info;
    };
    return LociLabelManager;
}());
exports.LociLabelManager = LociLabelManager;
