/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { ModifiersKeys, ButtonsType } from '../../mol-util/input/input-observer';
import { Loci } from '../../mol-model/loci';
import { MarkerAction } from '../../mol-geo/geometry/marker-data';
import { PluginContext } from '../context';
export { SequenceView };
declare namespace SequenceView {
    interface HighlightEvent {
        current: Loci;
        modifiers?: ModifiersKeys;
    }
    interface ClickEvent {
        current: Loci;
        buttons: ButtonsType;
        modifiers: ModifiersKeys;
    }
}
declare class SequenceView {
    private plugin;
    private ev;
    private spine;
    readonly interactions: {
        highlight: import("rxjs").Subject<SequenceView.HighlightEvent>;
        click: import("rxjs").Subject<SequenceView.ClickEvent>;
    };
    mark(loci: Loci, action: MarkerAction): void;
    dispose(): void;
    constructor(plugin: PluginContext);
}
