"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var rx_event_helper_1 = require("../../mol-util/rx-event-helper");
var spine_1 = require("../../mol-state/tree/spine");
var SequenceView = /** @class */ (function () {
    function SequenceView(plugin) {
        var _this = this;
        this.plugin = plugin;
        this.ev = rx_event_helper_1.RxEventHelper.create();
        this.interactions = {
            highlight: this.ev(),
            click: this.ev(),
        };
        this.spine = new spine_1.StateTreeSpine.Impl(plugin.state.dataState.cells);
        this.subscribe(this.plugin.state.behavior.currentObject, function (o) {
            var current = _this.plugin.state.dataState.cells.get(o.ref);
            _this.spine.setCurrent(current);
            _this.forceUpdate();
        });
        this.subscribe(this.plugin.events.state.object.updated, function (_a) {
            var ref = _a.ref, state = _a.state;
            console.log('object updated');
            // const current = this.current;
            // if (current.ref !== ref || current.state !== state) return;
            // this.forceUpdate();
        });
    }
    SequenceView.prototype.mark = function (loci, action) {
    };
    SequenceView.prototype.dispose = function () {
        this.ev.dispose();
    };
    return SequenceView;
}());
exports.SequenceView = SequenceView;
