/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Loci } from '../../mol-model/loci';
import { Structure, StructureElement } from '../../mol-model/structure';
import { PluginContext } from '../context';
export { StructureElementSelectionManager };
declare class StructureElementSelectionManager {
    private plugin;
    private entries;
    private getEntry;
    add(loci: Loci): Loci;
    remove(loci: Loci): Loci;
    set(loci: Loci): Loci;
    clear(): StructureElement.Loci[];
    get(structure: Structure): StructureElement.Loci | {
        kind: "empty-loci";
    };
    has(loci: Loci): boolean;
    tryGetRange(loci: Loci): StructureElement.Loci | undefined;
    private prevHighlight;
    accumulateInteractiveHighlight(loci: Loci): StructureElement.Loci | undefined;
    clearInteractiveHighlight(): StructureElement.Loci | {
        kind: "empty-loci";
    };
    private onRemove;
    private onUpdate;
    constructor(plugin: PluginContext);
}
