/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { Task, Progress } from '../../mol-task';
export { TaskManager };
declare class TaskManager {
    private ev;
    private id;
    private abortRequests;
    readonly events: {
        progress: import("rxjs").Subject<TaskManager.ProgressEvent>;
        finished: import("rxjs").Subject<{
            id: number;
        }>;
    };
    private track;
    run<T>(task: Task<T>): Promise<T>;
    requestAbort(task: Task<any> | number, reason?: string): void;
    dispose(): void;
}
declare namespace TaskManager {
    type ReportLevel = 'none' | 'background' | 'overlay';
    interface ProgressEvent {
        id: number;
        level: ReportLevel;
        progress: Progress;
    }
    function testTask(N: number): Task<void>;
}
