"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var representation_1 = require("../representation");
var base_1 = require("../../mol-geo/geometry/base");
var mesh_1 = require("../../mol-geo/geometry/mesh/mesh");
var spheres_1 = require("../../mol-geo/geometry/spheres/spheres");
var points_1 = require("../../mol-geo/geometry/points/points");
var lines_1 = require("../../mol-geo/geometry/lines/lines");
var direct_volume_1 = require("../../mol-geo/geometry/direct-volume/direct-volume");
var texture_mesh_1 = require("../../mol-geo/geometry/texture-mesh/texture-mesh");
exports.StructureRepresentationStateBuilder = {
    create: function () {
        return __assign({}, representation_1.Representation.createState(), { unitTransforms: null });
    },
    update: function (state, update) {
        representation_1.Representation.updateState(state, update);
        if (update.unitTransforms !== undefined)
            state.unitTransforms = update.unitTransforms;
    }
};
//
exports.StructureParams = __assign({}, base_1.BaseGeometry.Params);
exports.StructureMeshParams = __assign({}, mesh_1.Mesh.Params, exports.StructureParams);
exports.StructureSpheresParams = __assign({}, spheres_1.Spheres.Params, exports.StructureParams);
exports.StructurePointsParams = __assign({}, points_1.Points.Params, exports.StructureParams);
exports.StructureLinesParams = __assign({}, lines_1.Lines.Params, exports.StructureParams);
exports.StructureDirectVolumeParams = __assign({}, direct_volume_1.DirectVolume.Params, exports.StructureParams);
exports.StructureTextureMeshParams = __assign({}, texture_mesh_1.TextureMesh.Params, exports.StructureParams);
var complex_representation_1 = require("./complex-representation");
exports.ComplexRepresentation = complex_representation_1.ComplexRepresentation;
var units_representation_1 = require("./units-representation");
exports.UnitsRepresentation = units_representation_1.UnitsRepresentation;
var complex_visual_1 = require("./complex-visual");
exports.ComplexVisual = complex_visual_1.ComplexVisual;
var units_visual_1 = require("./units-visual");
exports.UnitsVisual = units_visual_1.UnitsVisual;
