/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { ParamDefinition as PD } from '../../../mol-util/param-definition';
import { StructureRepresentation, StructureRepresentationProvider } from '../representation';
import { RepresentationParamsGetter, RepresentationContext } from '../../../mol-repr/representation';
import { ThemeRegistryContext } from '../../../mol-theme/theme';
import { Structure } from '../../../mol-model/structure';
export declare const BallAndStickParams: {
    unitKinds: PD.MultiSelect<"spheres" | "gaussians" | "atomic", ("spheres" | "gaussians" | "atomic")[]>;
    sizeFactor: PD.Numeric;
    sizeAspectRatio: PD.Numeric;
    visuals: PD.MultiSelect<"element-sphere" | "intra-link" | "inter-link", ("element-sphere" | "intra-link" | "inter-link")[]>;
    linkScale: PD.Numeric;
    linkSpacing: PD.Numeric;
    radialSegments: PD.Numeric;
    alpha: PD.Numeric;
    useFog: PD.BooleanParam;
    highlightColor: PD.Color;
    selectColor: PD.Color;
    quality: PD.Select<"auto" | "custom" | "low" | "medium" | "high" | "highest" | "higher" | "lower" | "lowest">;
    doubleSided: PD.BooleanParam;
    flipSided: PD.BooleanParam;
    flatShaded: PD.BooleanParam;
    detail: PD.Numeric;
};
export declare type BallAndStickParams = typeof BallAndStickParams;
export declare function getBallAndStickParams(ctx: ThemeRegistryContext, structure: Structure): {
    unitKinds: PD.MultiSelect<"spheres" | "gaussians" | "atomic", ("spheres" | "gaussians" | "atomic")[]>;
    sizeFactor: PD.Numeric;
    sizeAspectRatio: PD.Numeric;
    visuals: PD.MultiSelect<"element-sphere" | "intra-link" | "inter-link", ("element-sphere" | "intra-link" | "inter-link")[]>;
    linkScale: PD.Numeric;
    linkSpacing: PD.Numeric;
    radialSegments: PD.Numeric;
    alpha: PD.Numeric;
    useFog: PD.BooleanParam;
    highlightColor: PD.Color;
    selectColor: PD.Color;
    quality: PD.Select<"auto" | "custom" | "low" | "medium" | "high" | "highest" | "higher" | "lower" | "lowest">;
    doubleSided: PD.BooleanParam;
    flipSided: PD.BooleanParam;
    flatShaded: PD.BooleanParam;
    detail: PD.Numeric;
};
export declare type BallAndStickRepresentation = StructureRepresentation<BallAndStickParams>;
export declare function BallAndStickRepresentation(ctx: RepresentationContext, getParams: RepresentationParamsGetter<Structure, BallAndStickParams>): BallAndStickRepresentation;
export declare const BallAndStickRepresentationProvider: StructureRepresentationProvider<BallAndStickParams>;
