"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var cross_link_restraint_cylinder_1 = require("../visual/cross-link-restraint-cylinder");
var param_definition_1 = require("../../../mol-util/param-definition");
var complex_representation_1 = require("../complex-representation");
var representation_1 = require("../representation");
var representation_2 = require("../../../mol-repr/representation");
var common_1 = require("../visual/util/common");
var DistanceRestraintVisuals = {
    'distance-restraint': function (ctx, getParams) { return complex_representation_1.ComplexRepresentation('Cross-link restraint', ctx, getParams, cross_link_restraint_cylinder_1.CrossLinkRestraintVisual); },
};
exports.DistanceRestraintParams = __assign({}, cross_link_restraint_cylinder_1.CrossLinkRestraintParams, { unitKinds: param_definition_1.ParamDefinition.MultiSelect(['atomic', 'spheres'], common_1.UnitKindOptions) });
function getDistanceRestraintParams(ctx, structure) {
    return param_definition_1.ParamDefinition.clone(exports.DistanceRestraintParams);
}
exports.getDistanceRestraintParams = getDistanceRestraintParams;
function DistanceRestraintRepresentation(ctx, getParams) {
    return representation_2.Representation.createMulti('DistanceRestraint', ctx, getParams, representation_1.StructureRepresentationStateBuilder, DistanceRestraintVisuals);
}
exports.DistanceRestraintRepresentation = DistanceRestraintRepresentation;
exports.DistanceRestraintRepresentationProvider = {
    label: 'Distance Restraint',
    description: 'Displays cross-link distance restraints.',
    factory: DistanceRestraintRepresentation,
    getParams: getDistanceRestraintParams,
    defaultValues: param_definition_1.ParamDefinition.getDefaultValues(exports.DistanceRestraintParams),
    defaultColorTheme: 'cross-link',
    defaultSizeTheme: 'uniform'
};
