"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var param_definition_1 = require("../../../mol-util/param-definition");
var gaussian_density_volume_1 = require("../visual/gaussian-density-volume");
var representation_1 = require("../representation");
var representation_2 = require("../../../mol-repr/representation");
var GaussianVolumeVisuals = {
    'gaussian-volume': function (ctx, getParams) { return representation_1.ComplexRepresentation('Gaussian volume', ctx, getParams, gaussian_density_volume_1.GaussianDensityVolumeVisual); }
};
exports.GaussianVolumeParams = __assign({}, gaussian_density_volume_1.GaussianDensityVolumeParams);
function getGaussianVolumeParams(ctx, structure) {
    return param_definition_1.ParamDefinition.clone(exports.GaussianVolumeParams);
}
exports.getGaussianVolumeParams = getGaussianVolumeParams;
function GaussianVolumeRepresentation(ctx, getParams) {
    return representation_2.Representation.createMulti('Gaussian Volume', ctx, getParams, representation_1.StructureRepresentationStateBuilder, GaussianVolumeVisuals);
}
exports.GaussianVolumeRepresentation = GaussianVolumeRepresentation;
exports.GaussianVolumeRepresentationProvider = {
    label: 'Gaussian Volume',
    description: 'Displays a gaussian molecular density using direct volume rendering.',
    factory: GaussianVolumeRepresentation,
    getParams: getGaussianVolumeParams,
    defaultValues: param_definition_1.ParamDefinition.getDefaultValues(exports.GaussianVolumeParams),
    defaultColorTheme: 'polymer-id',
    defaultSizeTheme: 'uniform'
};
