"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var element_point_1 = require("../visual/element-point");
var units_representation_1 = require("../units-representation");
var param_definition_1 = require("../../../mol-util/param-definition");
var representation_1 = require("../representation");
var representation_2 = require("../../../mol-repr/representation");
var common_1 = require("../visual/util/common");
var PointVisuals = {
    'element-point': function (ctx, getParams) { return units_representation_1.UnitsRepresentation('Points', ctx, getParams, element_point_1.ElementPointVisual); },
};
exports.PointParams = __assign({}, element_point_1.ElementPointParams, { unitKinds: param_definition_1.ParamDefinition.MultiSelect(['atomic', 'spheres'], common_1.UnitKindOptions) });
function getPointParams(ctx, structure) {
    return param_definition_1.ParamDefinition.clone(exports.PointParams);
}
exports.getPointParams = getPointParams;
function PointRepresentation(ctx, getParams) {
    return representation_2.Representation.createMulti('Point', ctx, getParams, representation_1.StructureRepresentationStateBuilder, PointVisuals);
}
exports.PointRepresentation = PointRepresentation;
exports.PointRepresentationProvider = {
    label: 'Point',
    description: 'Displays elements (atoms, coarse spheres) as spheres.',
    factory: PointRepresentation,
    getParams: getPointParams,
    defaultValues: param_definition_1.ParamDefinition.getDefaultValues(exports.PointParams),
    defaultColorTheme: 'element-symbol',
    defaultSizeTheme: 'physical'
};
