"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var element_sphere_1 = require("../visual/element-sphere");
var units_representation_1 = require("../units-representation");
var param_definition_1 = require("../../../mol-util/param-definition");
var representation_1 = require("../representation");
var representation_2 = require("../../../mol-repr/representation");
var common_1 = require("../visual/util/common");
var SpacefillVisuals = {
    'element-sphere': function (ctx, getParams) { return units_representation_1.UnitsRepresentation('Sphere mesh', ctx, getParams, element_sphere_1.getElementSphereVisual(ctx.webgl)); },
};
exports.SpacefillParams = __assign({}, element_sphere_1.ElementSphereParams, { unitKinds: param_definition_1.ParamDefinition.MultiSelect(['atomic', 'spheres'], common_1.UnitKindOptions) });
function getSpacefillParams(ctx, structure) {
    return param_definition_1.ParamDefinition.clone(exports.SpacefillParams);
}
exports.getSpacefillParams = getSpacefillParams;
function SpacefillRepresentation(ctx, getParams) {
    return representation_2.Representation.createMulti('Spacefill', ctx, getParams, representation_1.StructureRepresentationStateBuilder, SpacefillVisuals);
}
exports.SpacefillRepresentation = SpacefillRepresentation;
exports.SpacefillRepresentationProvider = {
    label: 'Spacefill',
    description: 'Displays atomic/coarse elements as spheres.',
    factory: SpacefillRepresentation,
    getParams: getSpacefillParams,
    defaultValues: param_definition_1.ParamDefinition.getDefaultValues(exports.SpacefillParams),
    defaultColorTheme: 'element-symbol',
    defaultSizeTheme: 'physical'
};
