"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author David Sehnal <david.sehnal@gmail.com>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var param_definition_1 = require("../../mol-util/param-definition");
var representation_1 = require("./representation");
var common_1 = require("./visual/util/common");
var structure_1 = require("../../mol-model/structure");
var rxjs_1 = require("rxjs");
var render_object_1 = require("../../mol-gl/render-object");
var theme_1 = require("../../mol-theme/theme");
var mol_task_1 = require("../../mol-task");
var loci_1 = require("../../mol-model/loci");
exports.UnitsParams = __assign({}, representation_1.StructureParams, { unitKinds: param_definition_1.ParamDefinition.MultiSelect(['atomic', 'spheres'], common_1.UnitKindOptions) });
function UnitsRepresentation(label, ctx, getParams, visualCtor) {
    var version = 0;
    var updated = new rxjs_1.Subject();
    var materialId = render_object_1.getNextMaterialId();
    var renderObjects = [];
    var _state = representation_1.StructureRepresentationStateBuilder.create();
    var visuals = new Map();
    var _structure;
    var _groups;
    var _params;
    var _props;
    var _theme = theme_1.createEmptyTheme();
    function createOrUpdate(props, structure) {
        var _this = this;
        if (props === void 0) { props = {}; }
        if (structure && structure !== _structure) {
            _params = getParams(ctx, structure);
            if (!_props)
                _props = param_definition_1.ParamDefinition.getDefaultValues(_params);
        }
        _props = Object.assign({}, _props, props);
        return mol_task_1.Task.create('Creating or updating UnitsRepresentation', function (runtime) { return __awaiter(_this, void 0, void 0, function () {
            var i, group, visual, promise, oldVisuals, i, group, visualGroup, visual, promise, visual, promise, i, group, visualGroup, promise, visualsList_1, i, il, visual, promise;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(!_structure && !structure)) return [3 /*break*/, 1];
                        throw new Error('missing structure');
                    case 1:
                        if (!(structure && !_structure)) return [3 /*break*/, 8];
                        // console.log(label, 'initial structure')
                        // First call with a structure, create visuals for each group.
                        _groups = structure.unitSymmetryGroups;
                        i = 0;
                        _a.label = 2;
                    case 2:
                        if (!(i < _groups.length)) return [3 /*break*/, 7];
                        group = _groups[i];
                        visual = visualCtor(materialId);
                        promise = visual.createOrUpdate({ webgl: ctx.webgl, runtime: runtime }, _theme, _props, { group: group, structure: structure });
                        if (!promise) return [3 /*break*/, 4];
                        return [4 /*yield*/, promise];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        visuals.set(group.hashCode, { visual: visual, group: group });
                        if (!runtime.shouldUpdate) return [3 /*break*/, 6];
                        return [4 /*yield*/, runtime.update({ message: 'Creating or updating UnitsVisual', current: i, max: _groups.length })];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        i++;
                        return [3 /*break*/, 2];
                    case 7: return [3 /*break*/, 34];
                    case 8:
                        if (!(structure && !structure_1.Structure.areEquivalent(structure, _structure))) return [3 /*break*/, 19];
                        // Tries to re-use existing visuals for the groups of the new structure.
                        // Creates additional visuals if needed, destroys left-over visuals.
                        _groups = structure.unitSymmetryGroups;
                        oldVisuals = visuals;
                        visuals = new Map();
                        i = 0;
                        _a.label = 9;
                    case 9:
                        if (!(i < _groups.length)) return [3 /*break*/, 18];
                        group = _groups[i];
                        visualGroup = oldVisuals.get(group.hashCode);
                        if (!visualGroup) return [3 /*break*/, 12];
                        visual = visualGroup.visual;
                        promise = visual.createOrUpdate({ webgl: ctx.webgl, runtime: runtime }, _theme, _props, { group: group, structure: structure });
                        if (!promise) return [3 /*break*/, 11];
                        return [4 /*yield*/, promise];
                    case 10:
                        _a.sent();
                        _a.label = 11;
                    case 11:
                        visuals.set(group.hashCode, { visual: visual, group: group });
                        oldVisuals.delete(group.hashCode);
                        return [3 /*break*/, 15];
                    case 12:
                        visual = visualCtor(materialId);
                        promise = visual.createOrUpdate({ webgl: ctx.webgl, runtime: runtime }, _theme, _props, { group: group, structure: structure });
                        if (!promise) return [3 /*break*/, 14];
                        return [4 /*yield*/, promise];
                    case 13:
                        _a.sent();
                        _a.label = 14;
                    case 14:
                        visuals.set(group.hashCode, { visual: visual, group: group });
                        _a.label = 15;
                    case 15:
                        if (!runtime.shouldUpdate) return [3 /*break*/, 17];
                        return [4 /*yield*/, runtime.update({ message: 'Creating or updating UnitsVisual', current: i, max: _groups.length })];
                    case 16:
                        _a.sent();
                        _a.label = 17;
                    case 17:
                        i++;
                        return [3 /*break*/, 9];
                    case 18:
                        oldVisuals.forEach(function (_a) {
                            var visual = _a.visual;
                            // console.log(label, 'removed unused visual')
                            visual.destroy();
                        });
                        return [3 /*break*/, 34];
                    case 19:
                        if (!(structure && structure !== _structure && structure_1.Structure.areEquivalent(structure, _structure))) return [3 /*break*/, 28];
                        // console.log(label, 'structures equivalent but not identical')
                        // Expects that for structures with the same hashCode,
                        // the unitSymmetryGroups are the same as well.
                        // Re-uses existing visuals for the groups of the new structure.
                        _groups = structure.unitSymmetryGroups;
                        i = 0;
                        _a.label = 20;
                    case 20:
                        if (!(i < _groups.length)) return [3 /*break*/, 27];
                        group = _groups[i];
                        visualGroup = visuals.get(group.hashCode);
                        if (!visualGroup) return [3 /*break*/, 23];
                        promise = visualGroup.visual.createOrUpdate({ webgl: ctx.webgl, runtime: runtime }, _theme, _props, { group: group, structure: structure });
                        if (!promise) return [3 /*break*/, 22];
                        return [4 /*yield*/, promise];
                    case 21:
                        _a.sent();
                        _a.label = 22;
                    case 22:
                        visualGroup.group = group;
                        return [3 /*break*/, 24];
                    case 23: throw new Error("expected to find visual for hashCode " + group.hashCode);
                    case 24:
                        if (!runtime.shouldUpdate) return [3 /*break*/, 26];
                        return [4 /*yield*/, runtime.update({ message: 'Creating or updating UnitsVisual', current: i, max: _groups.length })];
                    case 25:
                        _a.sent();
                        _a.label = 26;
                    case 26:
                        i++;
                        return [3 /*break*/, 20];
                    case 27: return [3 /*break*/, 34];
                    case 28:
                        visualsList_1 = [] // TODO avoid allocation
                        ;
                        visuals.forEach(function (_a) {
                            var visual = _a.visual, group = _a.group;
                            return visualsList_1.push([visual, group]);
                        });
                        i = 0, il = visualsList_1.length;
                        _a.label = 29;
                    case 29:
                        if (!(i < il)) return [3 /*break*/, 34];
                        visual = visualsList_1[i][0];
                        promise = visual.createOrUpdate({ webgl: ctx.webgl, runtime: runtime }, _theme, _props);
                        if (!promise) return [3 /*break*/, 31];
                        return [4 /*yield*/, promise];
                    case 30:
                        _a.sent();
                        _a.label = 31;
                    case 31:
                        if (!runtime.shouldUpdate) return [3 /*break*/, 33];
                        return [4 /*yield*/, runtime.update({ message: 'Creating or updating UnitsVisual', current: i, max: il })];
                    case 32:
                        _a.sent();
                        _a.label = 33;
                    case 33:
                        ++i;
                        return [3 /*break*/, 29];
                    case 34:
                        // update list of renderObjects
                        renderObjects.length = 0;
                        visuals.forEach(function (_a) {
                            var visual = _a.visual;
                            if (visual.renderObject)
                                renderObjects.push(visual.renderObject);
                        });
                        // set new structure
                        if (structure)
                            _structure = structure;
                        // increment version
                        updated.next(version++);
                        return [2 /*return*/];
                }
            });
        }); });
    }
    function getLoci(pickingId) {
        var loci = loci_1.EmptyLoci;
        visuals.forEach(function (_a) {
            var visual = _a.visual;
            var _loci = visual.getLoci(pickingId);
            if (!loci_1.isEmptyLoci(_loci))
                loci = _loci;
        });
        return loci;
    }
    function mark(loci, action) {
        var changed = false;
        visuals.forEach(function (_a) {
            var visual = _a.visual;
            changed = visual.mark(loci, action) || changed;
        });
        return changed;
    }
    function setState(state) {
        var visible = state.visible, alphaFactor = state.alphaFactor, pickable = state.pickable, overpaint = state.overpaint, transparency = state.transparency, transform = state.transform, unitTransforms = state.unitTransforms;
        if (visible !== undefined)
            visuals.forEach(function (_a) {
                var visual = _a.visual;
                return visual.setVisibility(visible);
            });
        if (alphaFactor !== undefined)
            visuals.forEach(function (_a) {
                var visual = _a.visual;
                return visual.setAlphaFactor(alphaFactor);
            });
        if (pickable !== undefined)
            visuals.forEach(function (_a) {
                var visual = _a.visual;
                return visual.setPickable(pickable);
            });
        if (overpaint !== undefined)
            visuals.forEach(function (_a) {
                var visual = _a.visual;
                return visual.setOverpaint(overpaint);
            });
        if (transparency !== undefined)
            visuals.forEach(function (_a) {
                var visual = _a.visual;
                return visual.setTransparency(transparency);
            });
        if (transform !== undefined)
            visuals.forEach(function (_a) {
                var visual = _a.visual;
                return visual.setTransform(transform);
            });
        if (unitTransforms !== undefined) {
            visuals.forEach(function (_a) {
                var visual = _a.visual, group = _a.group;
                if (unitTransforms) {
                    // console.log(group.hashCode, unitTransforms.getSymmetryGroupTransforms(group))
                    visual.setTransform(undefined, unitTransforms.getSymmetryGroupTransforms(group));
                }
                else {
                    visual.setTransform(undefined, null);
                }
            });
        }
        representation_1.StructureRepresentationStateBuilder.update(_state, state);
    }
    function setTheme(theme) {
        _theme = theme;
    }
    function destroy() {
        visuals.forEach(function (_a) {
            var visual = _a.visual;
            return visual.destroy();
        });
        visuals.clear();
    }
    return {
        label: label,
        get groupCount() {
            var groupCount = 0;
            visuals.forEach(function (_a) {
                var visual = _a.visual;
                if (visual.renderObject)
                    groupCount += visual.groupCount;
            });
            return groupCount;
        },
        get props() { return _props; },
        get params() { return _params; },
        get state() { return _state; },
        get theme() { return _theme; },
        renderObjects: renderObjects,
        updated: updated,
        createOrUpdate: createOrUpdate,
        setState: setState,
        setTheme: setTheme,
        getLoci: getLoci,
        mark: mark,
        destroy: destroy
    };
}
exports.UnitsRepresentation = UnitsRepresentation;
