"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var param_definition_1 = require("../../../mol-util/param-definition");
var units_visual_1 = require("../units-visual");
var points_builder_1 = require("../../../mol-geo/geometry/points/points-builder");
var linear_algebra_1 = require("../../../mol-math/linear-algebra");
var element_1 = require("./util/element");
exports.ElementPointParams = __assign({}, units_visual_1.UnitsPointsParams, { 
    // sizeFactor: PD.Numeric(1.0, { min: 0, max: 10, step: 0.01 }),
    pointSizeAttenuation: param_definition_1.ParamDefinition.Boolean(false) });
// TODO size
function createElementPoint(ctx, unit, structure, theme, props, points) {
    // const { sizeFactor } = props
    var elements = unit.elements;
    var n = elements.length;
    var builder = points_builder_1.PointsBuilder.create(n, n / 10, points);
    var pos = unit.conformation.invariantPosition;
    var p = linear_algebra_1.Vec3.zero();
    for (var i = 0; i < n; ++i) {
        pos(elements[i], p);
        builder.add(p[0], p[1], p[2], i);
    }
    return builder.getPoints();
}
exports.createElementPoint = createElementPoint;
function ElementPointVisual(materialId) {
    return units_visual_1.UnitsPointsVisual({
        defaultProps: param_definition_1.ParamDefinition.getDefaultValues(exports.ElementPointParams),
        createGeometry: createElementPoint,
        createLocationIterator: element_1.StructureElementIterator.fromGroup,
        getLoci: element_1.getElementLoci,
        eachLocation: element_1.eachElement,
        setUpdateState: function (state, newProps, currentProps) {
        }
    }, materialId);
}
exports.ElementPointVisual = ElementPointVisual;
