/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { ParamDefinition as PD } from '../../../mol-util/param-definition';
import { UnitsVisual } from '../units-visual';
export declare const NucleotideBlockMeshParams: {
    sizeFactor: PD.Numeric;
    radialSegments: PD.Numeric;
};
export declare const DefaultNucleotideBlockMeshProps: PD.Values<{
    sizeFactor: PD.Numeric;
    radialSegments: PD.Numeric;
}>;
export declare type NucleotideBlockMeshProps = typeof DefaultNucleotideBlockMeshProps;
export declare const NucleotideBlockParams: {
    sizeFactor: PD.Numeric;
    radialSegments: PD.Numeric;
    unitKinds: PD.MultiSelect<"spheres" | "gaussians" | "atomic", ("spheres" | "gaussians" | "atomic")[]>;
    alpha: PD.Numeric;
    useFog: PD.BooleanParam;
    highlightColor: PD.Color;
    selectColor: PD.Color;
    quality: PD.Select<"auto" | "custom" | "low" | "medium" | "high" | "highest" | "higher" | "lower" | "lowest">;
    doubleSided: PD.BooleanParam;
    flipSided: PD.BooleanParam;
    flatShaded: PD.BooleanParam;
};
export declare type NucleotideBlockParams = typeof NucleotideBlockParams;
export declare function NucleotideBlockVisual(materialId: number): UnitsVisual<NucleotideBlockParams>;
