/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { ParamDefinition as PD } from '../../../mol-util/param-definition';
import { UnitsVisual } from '../units-visual';
export declare const NucleotideRingMeshParams: {
    sizeFactor: PD.Numeric;
    radialSegments: PD.Numeric;
    detail: PD.Numeric;
};
export declare const DefaultNucleotideRingMeshProps: PD.Values<{
    sizeFactor: PD.Numeric;
    radialSegments: PD.Numeric;
    detail: PD.Numeric;
}>;
export declare type NucleotideRingProps = typeof DefaultNucleotideRingMeshProps;
export declare const NucleotideRingParams: {
    sizeFactor: PD.Numeric;
    radialSegments: PD.Numeric;
    detail: PD.Numeric;
    unitKinds: PD.MultiSelect<"spheres" | "gaussians" | "atomic", ("spheres" | "gaussians" | "atomic")[]>;
    alpha: PD.Numeric;
    useFog: PD.BooleanParam;
    highlightColor: PD.Color;
    selectColor: PD.Color;
    quality: PD.Select<"auto" | "custom" | "low" | "medium" | "high" | "highest" | "higher" | "lower" | "lowest">;
    doubleSided: PD.BooleanParam;
    flipSided: PD.BooleanParam;
    flatShaded: PD.BooleanParam;
};
export declare type NucleotideRingParams = typeof NucleotideRingParams;
export declare function NucleotideRingVisual(materialId: number): UnitsVisual<NucleotideRingParams>;
