/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { ParamDefinition as PD } from '../../../mol-util/param-definition';
import { UnitsVisual } from '../units-visual';
export declare const PolymerTraceMeshParams: {
    sizeFactor: PD.Numeric;
    linearSegments: PD.Numeric;
    radialSegments: PD.Numeric;
    aspectRatio: PD.Numeric;
    arrowFactor: PD.Numeric;
};
export declare const DefaultPolymerTraceMeshProps: PD.Values<{
    sizeFactor: PD.Numeric;
    linearSegments: PD.Numeric;
    radialSegments: PD.Numeric;
    aspectRatio: PD.Numeric;
    arrowFactor: PD.Numeric;
}>;
export declare type PolymerTraceMeshProps = typeof DefaultPolymerTraceMeshProps;
export declare const PolymerTraceParams: {
    sizeFactor: PD.Numeric;
    linearSegments: PD.Numeric;
    radialSegments: PD.Numeric;
    aspectRatio: PD.Numeric;
    arrowFactor: PD.Numeric;
    unitKinds: PD.MultiSelect<"spheres" | "gaussians" | "atomic", ("spheres" | "gaussians" | "atomic")[]>;
    alpha: PD.Numeric;
    useFog: PD.BooleanParam;
    highlightColor: PD.Color;
    selectColor: PD.Color;
    quality: PD.Select<"auto" | "custom" | "low" | "medium" | "high" | "highest" | "higher" | "lower" | "lowest">;
    doubleSided: PD.BooleanParam;
    flipSided: PD.BooleanParam;
    flatShaded: PD.BooleanParam;
};
export declare type PolymerTraceParams = typeof PolymerTraceParams;
export declare function PolymerTraceVisual(materialId: number): UnitsVisual<PolymerTraceParams>;
