/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Unit, Structure } from '../../../../mol-model/structure';
import { Task } from '../../../../mol-task';
import { ParamDefinition as PD } from '../../../../mol-util/param-definition';
import { Texture } from '../../../../mol-gl/webgl/texture';
import { WebGLContext } from '../../../../mol-gl/webgl/context';
export declare const GaussianDensityParams: {
    resolution: PD.Numeric;
    radiusOffset: PD.Numeric;
    smoothness: PD.Numeric;
    useGpu: PD.BooleanParam;
};
export declare const DefaultGaussianDensityProps: PD.Values<{
    resolution: PD.Numeric;
    radiusOffset: PD.Numeric;
    smoothness: PD.Numeric;
    useGpu: PD.BooleanParam;
}>;
export declare type GaussianDensityProps = typeof DefaultGaussianDensityProps;
export declare const GaussianDensityTextureParams: {
    resolution: PD.Numeric;
    radiusOffset: PD.Numeric;
    smoothness: PD.Numeric;
};
export declare const DefaultGaussianDensityTextureProps: PD.Values<{
    resolution: PD.Numeric;
    radiusOffset: PD.Numeric;
    smoothness: PD.Numeric;
}>;
export declare type GaussianDensityTextureProps = typeof DefaultGaussianDensityTextureProps;
export declare function computeUnitGaussianDensity(unit: Unit, props: GaussianDensityProps, webgl?: WebGLContext): Task<import("../../../../mol-math/geometry").DensityData>;
export declare function computeUnitGaussianDensityTexture(unit: Unit, props: GaussianDensityTextureProps, webgl: WebGLContext, texture?: Texture): Task<import("../../../../mol-math/geometry").DensityTextureData>;
export declare function computeUnitGaussianDensityTexture2d(unit: Unit, props: GaussianDensityTextureProps, webgl: WebGLContext, texture?: Texture): Task<import("../../../../mol-math/geometry").DensityTextureData>;
export declare function computeStructureGaussianDensity(structure: Structure, props: GaussianDensityProps, webgl?: WebGLContext): Task<import("../../../../mol-math/geometry").DensityData>;
export declare function computeStructureGaussianDensityTexture(structure: Structure, props: GaussianDensityTextureProps, webgl: WebGLContext, texture?: Texture): Task<import("../../../../mol-math/geometry").DensityTextureData>;
