/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Unit, StructureElement } from '../../../../../mol-model/structure';
import Iterator from '../../../../../mol-data/iterator';
/** Iterates over consecutive pairs of residues/coarse elements in polymers */
export declare function PolymerBackboneIterator(unit: Unit): Iterator<PolymerBackbonePair>;
interface PolymerBackbonePair {
    centerA: StructureElement;
    centerB: StructureElement;
}
export declare class AtomicPolymerBackboneIterator implements Iterator<PolymerBackbonePair> {
    private unit;
    private traceElementIndex;
    private value;
    private polymerIt;
    private residueIt;
    private state;
    private residueSegment;
    hasNext: boolean;
    move(): PolymerBackbonePair;
    constructor(unit: Unit.Atomic);
}
export declare class CoarsePolymerBackboneIterator implements Iterator<PolymerBackbonePair> {
    private unit;
    private value;
    private polymerIt;
    private polymerSegment;
    private state;
    private elementIndex;
    hasNext: boolean;
    move(): PolymerBackbonePair;
    constructor(unit: Unit.Spheres | Unit.Gaussians);
}
export {};
