/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { VisualQuality } from '../mol-geo/geometry/base';
export interface VisualUpdateState {
    updateTransform: boolean;
    updateMatrix: boolean;
    updateColor: boolean;
    updateSize: boolean;
    createGeometry: boolean;
    createNew: boolean;
    /** holds contextual info, is not reset  */
    info: {
        [k: string]: unknown;
    };
}
export declare namespace VisualUpdateState {
    function create(): VisualUpdateState;
    function reset(state: VisualUpdateState): void;
}
export interface QualityProps {
    quality: VisualQuality;
    detail: number;
    radialSegments: number;
    linearSegments: number;
    resolution: number;
}
export declare function getQualityProps(props: Partial<QualityProps>, data?: any): {
    detail: number;
    radialSegments: number;
    linearSegments: number;
    resolution: number;
};
