/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { RepresentationProvider, RepresentationRegistry, Representation } from '../representation';
import { VolumeData } from '../../mol-model/volume';
export declare class VolumeRepresentationRegistry extends RepresentationRegistry<VolumeData, Representation.State> {
    constructor();
}
export declare const BuiltInVolumeRepresentations: {
    'isosurface': RepresentationProvider<VolumeData, {
        visuals: import("../../mol-util/param-definition").ParamDefinition.MultiSelect<"solid" | "wireframe", ("solid" | "wireframe")[]>;
        isoValue: import("../../mol-util/param-definition").ParamDefinition.Conditioned<import("../../mol-model/volume/data").VolumeIsoValue, import("../../mol-util/param-definition").ParamDefinition.Base<import("../../mol-model/volume/data").VolumeIsoValue>, {
            'absolute': import("../../mol-util/param-definition").ParamDefinition.Converted<Readonly<{
                kind: "absolute";
                absoluteValue: number;
            }>, number>;
            'relative': import("../../mol-util/param-definition").ParamDefinition.Converted<Readonly<{
                kind: "relative";
                relativeValue: number;
            }>, number>;
        }>;
        sizeFactor: import("../../mol-util/param-definition").ParamDefinition.Numeric;
        lineSizeAttenuation: import("../../mol-util/param-definition").ParamDefinition.BooleanParam;
        alpha: import("../../mol-util/param-definition").ParamDefinition.Numeric;
        useFog: import("../../mol-util/param-definition").ParamDefinition.BooleanParam;
        highlightColor: import("../../mol-util/param-definition").ParamDefinition.Color;
        selectColor: import("../../mol-util/param-definition").ParamDefinition.Color;
        quality: import("../../mol-util/param-definition").ParamDefinition.Select<"auto" | "custom" | "low" | "medium" | "high" | "highest" | "higher" | "lower" | "lowest">;
        doubleSided: import("../../mol-util/param-definition").ParamDefinition.BooleanParam;
        flipSided: import("../../mol-util/param-definition").ParamDefinition.BooleanParam;
        flatShaded: import("../../mol-util/param-definition").ParamDefinition.BooleanParam;
    }, Representation.State>;
};
export declare type BuiltInVolumeRepresentationsName = keyof typeof BuiltInVolumeRepresentations;
export declare const BuiltInVolumeRepresentationsNames: string[];
export declare const BuiltInVolumeRepresentationsOptions: ["isosurface", string][];
