"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var representation_1 = require("../representation");
var isosurface_1 = require("./isosurface");
var VolumeRepresentationRegistry = /** @class */ (function (_super) {
    __extends(VolumeRepresentationRegistry, _super);
    function VolumeRepresentationRegistry() {
        var _this = _super.call(this) || this;
        Object.keys(exports.BuiltInVolumeRepresentations).forEach(function (name) {
            var p = exports.BuiltInVolumeRepresentations[name];
            _this.add(name, p);
        });
        return _this;
    }
    return VolumeRepresentationRegistry;
}(representation_1.RepresentationRegistry));
exports.VolumeRepresentationRegistry = VolumeRepresentationRegistry;
exports.BuiltInVolumeRepresentations = {
    'isosurface': isosurface_1.IsosurfaceRepresentationProvider,
};
exports.BuiltInVolumeRepresentationsNames = Object.keys(exports.BuiltInVolumeRepresentations);
exports.BuiltInVolumeRepresentationsOptions = exports.BuiltInVolumeRepresentationsNames.map(function (n) { return [n, n]; });
