/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { State } from '../state';
import { StateObject, StateObjectCell } from '../object';
export { StateTreeSpine };
/** The tree spine allows access to ancestor of a node during reconciliation. */
interface StateTreeSpine {
    getAncestorOfType<T extends StateObject.Ctor>(type: T): StateObject.From<T> | undefined;
    getRootOfType<T extends StateObject.Ctor>(type: T): StateObject.From<T> | undefined;
}
declare namespace StateTreeSpine {
    class Impl implements StateTreeSpine {
        private cells;
        private _current;
        current: StateObjectCell | undefined;
        getAncestorOfType<T extends StateObject.Ctor>(t: T): StateObject.From<T> | undefined;
        getRootOfType<T extends StateObject.Ctor>(t: T): StateObject.From<T> | undefined;
        constructor(cells: State.Cells);
    }
}
