"use strict";
/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var color_1 = require("../../mol-util/color");
var param_definition_1 = require("../../mol-util/param-definition");
var tables_1 = require("../../mol-util/color/tables");
var mol_util_1 = require("../../mol-util");
var DefaultColor = color_1.Color(0xCCCCCC);
var Description = 'Gives everything the same, uniform color.';
exports.UniformColorThemeParams = {
    value: param_definition_1.ParamDefinition.Color(DefaultColor),
};
function getUniformColorThemeParams(ctx) {
    return exports.UniformColorThemeParams; // TODO return copy
}
exports.getUniformColorThemeParams = getUniformColorThemeParams;
function UniformColorTheme(ctx, props) {
    var color = mol_util_1.defaults(props.value, DefaultColor);
    return {
        factory: UniformColorTheme,
        granularity: 'uniform',
        color: function () { return color; },
        props: props,
        description: Description,
        legend: tables_1.TableLegend([['uniform', color]])
    };
}
exports.UniformColorTheme = UniformColorTheme;
exports.UniformColorThemeProvider = {
    label: 'Uniform',
    factory: UniformColorTheme,
    getParams: getUniformColorThemeParams,
    defaultValues: param_definition_1.ParamDefinition.getDefaultValues(exports.UniformColorThemeParams),
    isApplicable: function (ctx) { return true; }
};
