"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var loci_1 = require("../mol-model/loci");
var Overpaint;
(function (Overpaint) {
    Overpaint.Empty = { layers: [], alpha: 1 };
    function areEqual(oA, oB) {
        if (oA.layers.length === 0 && oB.layers.length === 0)
            return true;
        if (oA.layers.length !== oB.layers.length)
            return false;
        if (oA.alpha !== oB.alpha)
            return false;
        for (var i = 0, il = oA.layers.length; i < il; ++i) {
            if (oA.layers[i].color !== oB.layers[i].color)
                return false;
            if (!loci_1.Loci.areEqual(oA.layers[i].loci, oB.layers[i].loci))
                return false;
        }
        return true;
    }
    Overpaint.areEqual = areEqual;
})(Overpaint || (Overpaint = {}));
exports.Overpaint = Overpaint;
