"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var loci_1 = require("../mol-model/loci");
var Transparency;
(function (Transparency) {
    Transparency.Empty = { loci: loci_1.EmptyLoci, value: 0, variant: 'single' };
    function areEqual(tA, tB) {
        if (tA.value !== tB.value)
            return false;
        if (tA.variant !== tB.variant)
            return false;
        if (!loci_1.Loci.areEqual(tA.loci, tB.loci))
            return false;
        return true;
    }
    Transparency.areEqual = areEqual;
})(Transparency || (Transparency = {}));
exports.Transparency = Transparency;
