/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { NumberArray } from './type-helpers';
/** Get the maximum value in an array */
export declare function arrayMax(array: ArrayLike<number>): number;
/** Get the minimum value in an array */
export declare function arrayMin(array: ArrayLike<number>): number;
/** Get the sum of values in an array */
export declare function arraySum(array: ArrayLike<number>, stride?: number, offset?: number): number;
/** Get the mean of values in an array */
export declare function arrayMean(array: ArrayLike<number>, stride?: number, offset?: number): number;
/** Get the root mean square of values in an array */
export declare function arrayRms(array: ArrayLike<number>): number;
/** Fill an array with serial numbers starting from 0 until n - 1 (defaults to array.length) */
export declare function fillSerial<T extends NumberArray>(array: T, n?: number): T;
/** Fill an array with value starting from index 0 until n - 1 (defaults to array.length) */
export declare function fillUniform<T extends NumberArray>(array: T, v: number, n?: number): T;
export declare function arrayRemoveInPlace<T>(xs: T[], x: T): boolean;
