"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 *
 * Adapted from LiteMol
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var mol_task_1 = require("../mol-task");
var utf8_1 = require("../mol-io/common/utf8");
// polyfill XMLHttpRequest in node.js
var XHR = typeof document === 'undefined' ? require('xhr2') : XMLHttpRequest;
function readStringFromFile(file) {
    return readFromFileInternal(file, false);
}
exports.readStringFromFile = readStringFromFile;
function readUint8ArrayFromFile(file) {
    return readFromFileInternal(file, true);
}
exports.readUint8ArrayFromFile = readUint8ArrayFromFile;
function readFromFile(file, type) {
    return readFromFileInternal(file, type === 'binary');
}
exports.readFromFile = readFromFile;
function ajaxGet(params) {
    if (typeof params === 'string')
        return ajaxGetInternal(params, params, 'string', false);
    return ajaxGetInternal(params.title, params.url, params.type || 'string', false /* params.compression === DataCompressionMethod.Gzip */, params.body);
}
exports.ajaxGet = ajaxGet;
function decompress(buffer) {
    // TODO
    throw 'nyi';
    // const gzip = new LiteMolZlib.Gunzip(new Uint8Array(buffer));
    // return gzip.decompress();
}
function processFile(ctx, asUint8Array, compressed, e) {
    return __awaiter(this, void 0, void 0, function () {
        var data, decompressed;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    data = e.target.result;
                    if (!compressed) return [3 /*break*/, 2];
                    return [4 /*yield*/, ctx.update('Decompressing...')];
                case 1:
                    _a.sent();
                    decompressed = decompress(new Uint8Array(data));
                    if (asUint8Array) {
                        return [2 /*return*/, decompressed];
                    }
                    else {
                        return [2 /*return*/, utf8_1.utf8Read(decompressed, 0, decompressed.length)];
                    }
                    return [3 /*break*/, 3];
                case 2: return [2 /*return*/, asUint8Array ? new Uint8Array(data) : data];
                case 3: return [2 /*return*/];
            }
        });
    });
}
function readData(ctx, action, data, asUint8Array) {
    return new Promise(function (resolve, reject) {
        data.onerror = function (e) {
            var error = e.target.error;
            reject(error ? error : 'Failed.');
        };
        data.onabort = function () { return reject(mol_task_1.Task.Aborted('')); };
        data.onprogress = function (e) {
            if (e.lengthComputable) {
                ctx.update({ message: action, isIndeterminate: false, current: e.loaded, max: e.total });
            }
            else {
                ctx.update({ message: action + " " + (e.loaded / 1024 / 1024).toFixed(2) + " MB", isIndeterminate: true });
            }
        };
        data.onload = function (e) { return resolve(e); };
    });
}
function readFromFileInternal(file, asUint8Array) {
    var _this = this;
    var reader = void 0;
    return mol_task_1.Task.create('Read File', function (ctx) { return __awaiter(_this, void 0, void 0, function () {
        var isCompressed, e, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, , 2, 3]);
                    reader = new FileReader();
                    isCompressed = /\.gz$/i.test(file.name);
                    if (isCompressed || asUint8Array)
                        reader.readAsArrayBuffer(file);
                    else
                        reader.readAsBinaryString(file);
                    ctx.update({ message: 'Opening file...', canAbort: true });
                    return [4 /*yield*/, readData(ctx, 'Reading...', reader, asUint8Array)];
                case 1:
                    e = _a.sent();
                    result = processFile(ctx, asUint8Array, isCompressed, e);
                    return [2 /*return*/, result];
                case 2:
                    reader = void 0;
                    return [7 /*endfinally*/];
                case 3: return [2 /*return*/];
            }
        });
    }); }, function () {
        if (reader)
            reader.abort();
    });
}
var RequestPool = /** @class */ (function () {
    function RequestPool() {
    }
    RequestPool.get = function () {
        if (this.pool.length) {
            return this.pool.pop();
        }
        return new XHR();
    };
    RequestPool.emptyFunc = function () { };
    RequestPool.deposit = function (req) {
        if (this.pool.length < this.poolSize) {
            req.onabort = RequestPool.emptyFunc;
            req.onerror = RequestPool.emptyFunc;
            req.onload = RequestPool.emptyFunc;
            req.onprogress = RequestPool.emptyFunc;
            this.pool.push(req);
        }
    };
    RequestPool.pool = [];
    RequestPool.poolSize = 15;
    return RequestPool;
}());
function processAjax(ctx, asUint8Array, decompressGzip, e) {
    return __awaiter(this, void 0, void 0, function () {
        var req, buff, text, status_1;
        return __generator(this, function (_a) {
            req = e.target;
            if (req.status >= 200 && req.status < 400) {
                if (asUint8Array) {
                    buff = new Uint8Array(e.target.response);
                    RequestPool.deposit(e.target);
                    if (decompressGzip) {
                        return [2 /*return*/, decompress(buff)];
                    }
                    else {
                        return [2 /*return*/, buff];
                    }
                }
                else {
                    text = e.target.responseText;
                    RequestPool.deposit(e.target);
                    return [2 /*return*/, text];
                }
            }
            else {
                status_1 = req.statusText;
                RequestPool.deposit(e.target);
                throw status_1;
            }
            return [2 /*return*/];
        });
    });
}
function ajaxGetInternal(title, url, type, decompressGzip, body) {
    var _this = this;
    var xhttp = void 0;
    return mol_task_1.Task.create(title ? title : 'Download', function (ctx) { return __awaiter(_this, void 0, void 0, function () {
        var asUint8Array, e, result, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, , 3, 4]);
                    asUint8Array = type === 'binary';
                    if (!asUint8Array && decompressGzip) {
                        throw 'Decompress is only available when downloading binary data.';
                    }
                    xhttp = RequestPool.get();
                    xhttp.open(body ? 'post' : 'get', url, true);
                    xhttp.responseType = asUint8Array ? 'arraybuffer' : 'text';
                    xhttp.send(body);
                    ctx.update({ message: 'Waiting for server...', canAbort: true });
                    return [4 /*yield*/, readData(ctx, 'Downloading...', xhttp, asUint8Array)];
                case 1:
                    e = _a.sent();
                    return [4 /*yield*/, processAjax(ctx, asUint8Array, decompressGzip, e)];
                case 2:
                    result = _a.sent();
                    if (type === 'json') {
                        ctx.update({ message: 'Parsing JSON...', canAbort: false });
                        data = JSON.parse(result);
                        return [2 /*return*/, data];
                    }
                    return [2 /*return*/, result];
                case 3:
                    xhttp = void 0;
                    return [7 /*endfinally*/];
                case 4: return [2 /*return*/];
            }
        });
    }); }, function () {
        if (xhttp)
            xhttp.abort();
    });
}
function ajaxGetMany(ctx, sources, maxConcurrency) {
    return __awaiter(this, void 0, void 0, function () {
        var len, slots, promises, promiseKeys, currentSrc, _i, current, done, r, src, idx, current;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    len = sources.length;
                    slots = new Array(sources.length);
                    return [4 /*yield*/, ctx.update({ message: 'Downloading...', current: 0, max: len })];
                case 1:
                    _a.sent();
                    promises = [], promiseKeys = [];
                    currentSrc = 0;
                    for (_i = Math.min(len, maxConcurrency); currentSrc < _i; currentSrc++) {
                        current = sources[currentSrc];
                        promises.push(wrapPromise(currentSrc, current.id, ajaxGet({ url: current.url, type: current.isBinary ? 'binary' : 'string' }).runAsChild(ctx)));
                        promiseKeys.push(currentSrc);
                    }
                    done = 0;
                    _a.label = 2;
                case 2:
                    if (!(promises.length > 0)) return [3 /*break*/, 6];
                    return [4 /*yield*/, Promise.race(promises)];
                case 3:
                    r = _a.sent();
                    src = sources[r.index];
                    idx = promiseKeys.indexOf(r.index);
                    done++;
                    if (r.kind === 'error' && !src.canFail) {
                        // TODO: cancel other downloads
                        throw new Error(src.url + ": " + r.error);
                    }
                    if (!ctx.shouldUpdate) return [3 /*break*/, 5];
                    return [4 /*yield*/, ctx.update({ message: 'Downloading...', current: done, max: len })];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    slots[r.index] = r;
                    promises = promises.filter(_filterRemoveIndex, idx);
                    promiseKeys = promiseKeys.filter(_filterRemoveIndex, idx);
                    if (currentSrc < len) {
                        current = sources[currentSrc];
                        promises.push(wrapPromise(currentSrc, current.id, ajaxGet({ url: current.url, type: current.isBinary ? 'binary' : 'string' }).runAsChild(ctx)));
                        promiseKeys.push(currentSrc);
                        currentSrc++;
                    }
                    return [3 /*break*/, 2];
                case 6: return [2 /*return*/, slots];
            }
        });
    });
}
exports.ajaxGetMany = ajaxGetMany;
function _filterRemoveIndex(_, i) {
    return this !== i;
}
function wrapPromise(index, id, p) {
    return __awaiter(this, void 0, void 0, function () {
        var result, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, p];
                case 1:
                    result = _a.sent();
                    return [2 /*return*/, { kind: 'ok', result: result, index: index, id: id }];
                case 2:
                    error_1 = _a.sent();
                    return [2 /*return*/, { kind: 'error', error: error_1, index: index, id: id }];
                case 3: return [2 /*return*/];
            }
        });
    });
}
