/**
 * Copyright (c) 2017 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
/** Create new object if any property in "update" changes in "source". */
export declare function shallowMerge2<T>(source: T, update: Partial<T>): T;
export declare function shallowEqual<T>(a: T, b: T): boolean;
export declare function shallowMerge<T>(source: T, ...rest: (Partial<T> | undefined)[]): T;
export declare function shallowMergeArray<T>(source: T, rest: (Partial<T> | undefined)[]): T;
/** Simple deep clone for number, boolean, string, null, undefined, object, array */
export declare function deepClone<T>(source: T): T;
export declare function mapObjectMap<O extends {
    [k: string]: T;
}, T, S>(o: O, f: (v: T) => S): {
    [k: string]: S;
};
