/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
export declare namespace SetUtils {
    /** Test if set a contains all elements of set b. */
    function isSuperset<T>(setA: Set<T>, setB: Set<T>): boolean;
    /** Create set containing elements of both set a and set b. */
    function union<T>(setA: Set<T>, setB: Set<T>): Set<T>;
    function unionMany<T>(...sets: Set<T>[]): Set<T>;
    function unionManyArrays<T>(arrays: T[][]): Set<T>;
    /** Create set containing elements of set a that are also in set b. */
    function intersection<T>(setA: Set<T>, setB: Set<T>): Set<T>;
    /** Create set containing elements of set a that are not in set b. */
    function difference<T>(setA: Set<T>, setB: Set<T>): Set<T>;
    /** Test if set a and b contain the same elements. */
    function areEqual<T>(setA: Set<T>, setB: Set<T>): boolean;
}
