"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var builder_1 = require("../mol-script/language/builder");
var compiler_1 = require("../mol-script/runtime/query/compiler");
var structure_1 = require("../mol-model/structure");
var model_1 = require("../apps/structure-info/model");
var symbol_1 = require("../mol-script/language/symbol");
var type_1 = require("../mol-script/language/type");
var parser_1 = require("../mol-script/language/parser");
var util = require("util");
var symbols_1 = require("../mol-script/script/mol-script/symbols");
var expression_formatter_1 = require("../mol-script/language/expression-formatter");
var structure_quality_report_1 = require("../mol-model-props/pdbe/structure-quality-report");
var node_fetch_1 = require("node-fetch");
// import Examples from 'mol-script/script/mol-script/examples'
// import { parseMolScript } from 'mol-script/script/mol-script/parser'
// //import { compileAST } from 'mol-script/script/mol-script/compile';
// for (const e of Examples) {
//     const expr = parseMolScript(e.value)[0];
//     console.log(e.name, util.inspect(expr, true, 10, true));
// }
// const exprs = parseMolScript(`(sel.atom.atom-groups
//     :residue-test (= atom.auth_comp_id ALA)
//     ;; ho ho ho
//     :atom-test (set.has { _C _N } atom.el)) ; comm
//     ;; this is a comment
//     ((hi) (ho))`);
// ;; :residue-test (= atom.label_comp_id REA)
var exprs = parser_1.parseMolScript("(sel.atom.atom-groups\n    :residue-test (> pdbe.structure-quality.issue-count 0)\n    :atom-test (= atom.el _C))");
var tsp = symbols_1.transpileMolScript(exprs[0]);
// console.log(util.inspect(exprs, true, 10, true));
console.log(util.inspect(tsp, true, 10, true));
console.log(expression_formatter_1.formatMolScript);
console.log(expression_formatter_1.formatMolScript(tsp));
// //console.log(expr);
var expr = builder_1.MolScriptBuilder.core.math.add([1, 2, 3]);
var compiled = compiler_1.compile(expr);
var result = compiled(new structure_1.QueryContext(structure_1.Structure.Empty));
console.log(result);
var CustomProp = structure_1.CustomPropertyDescriptor({
    name: 'test_prop',
    isStatic: true,
    cifExport: { prefix: '', categories: [] },
    symbols: {
        residueIndex: compiler_1.QuerySymbolRuntime.Dynamic(symbol_1.CustomPropSymbol('custom.test-prop', 'residue-index', type_1.default.Num), function (ctx) {
            var e = ctx.element;
            // console.log(e.element, e.unit.model.atomicHierarchy.residueAtomSegments.index[e.element])
            return e.unit.model.atomicHierarchy.residueAtomSegments.index[e.element];
        })
    }
});
compiler_1.DefaultQueryRuntimeTable.addCustomProp(CustomProp);
compiler_1.DefaultQueryRuntimeTable.addCustomProp(structure_quality_report_1.StructureQualityReport.Descriptor);
function testQ() {
    return __awaiter(this, void 0, void 0, function () {
        var frame, structure, expr, compiled, result;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, model_1.readCifFile('e:/test/quick/1cbs_updated.cif')];
                case 1:
                    frame = _a.sent();
                    return [4 /*yield*/, model_1.getModelsAndStructure(frame)];
                case 2:
                    structure = (_a.sent()).structure;
                    return [4 /*yield*/, structure_quality_report_1.StructureQualityReport.attachFromCifOrApi(structure.models[0], {
                            PDBe_apiSourceJson: function (model) { return __awaiter(_this, void 0, void 0, function () {
                                var rawData;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, node_fetch_1.default("https://www.ebi.ac.uk/pdbe/api/validation/residuewise_outlier_summary/entry/" + model.label.toLowerCase(), { timeout: 1500 })];
                                        case 1:
                                            rawData = _a.sent();
                                            return [4 /*yield*/, rawData.json()];
                                        case 2: return [2 /*return*/, _a.sent()];
                                    }
                                });
                            }); }
                        })];
                case 3:
                    _a.sent();
                    expr = builder_1.MolScriptBuilder.struct.generator.atomGroups({
                        'atom-test': builder_1.MolScriptBuilder.core.rel.eq([
                            builder_1.MolScriptBuilder.struct.atomProperty.core.elementSymbol(),
                            builder_1.MolScriptBuilder.es('C')
                        ]),
                        // 'residue-test': MolScriptBuilder.core.rel.eq([
                        //     MolScriptBuilder.struct.atomProperty.macromolecular.label_comp_id(),
                        //     'REA'
                        // ])
                        'residue-test': builder_1.MolScriptBuilder.core.rel.inRange([CustomProp.symbols.residueIndex.symbol(), 1, 5])
                    });
                    expr = tsp;
                    compiled = compiler_1.compile(expr);
                    result = compiled(new structure_1.QueryContext(structure));
                    console.log(result);
                    return [2 /*return*/];
            }
        });
    });
}
exports.testQ = testQ;
testQ();
