/**
 * Copyright (c) 2017 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { Structure, Model } from '../mol-model/structure';
export declare function readCIF(path: string): Promise<{
    mmcif: import("../mol-io/reader/cif/schema/mmcif").mmCIF_Database;
    models: readonly Model[];
    structures: Structure[];
}>;
export declare function getBcif(pdbId: string): Promise<{
    mmcif: import("../mol-io/reader/cif/schema/mmcif").mmCIF_Database;
    models: readonly Model[];
    structures: Structure[];
}>;
export declare namespace PropertyAccess {
    function write(s: Structure): void;
    function testAssembly(id: string, s: Structure): Promise<void>;
    function testSymmetry(id: string, s: Structure): Promise<void>;
    function testIncludeSurroundings(id: string, s: Structure): Promise<void>;
    function runLinks(): Promise<void>;
    function run(): Promise<void>;
}
