"use strict";
/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var express = require("express");
var fs = require("fs");
var swagger_ui_dist_1 = require("swagger-ui-dist");
var string_1 = require("../../../mol-util/string");
function swaggerUiAssetsHandler(options) {
    var opts = options || {};
    opts.index = false;
    return express.static(swagger_ui_dist_1.getAbsoluteFSPath(), opts);
}
exports.swaggerUiAssetsHandler = swaggerUiAssetsHandler;
function createHTML(options) {
    var htmlTemplate = fs.readFileSync(__dirname + "/indexTemplate.html").toString();
    return string_1.interpolate(htmlTemplate, options);
}
function swaggerUiIndexHandler(options) {
    var html = createHTML(options);
    return function (req, res) {
        res.writeHead(200, { 'Content-Type': 'text/html; charset=utf-8' });
        res.end(html);
    };
}
exports.swaggerUiIndexHandler = swaggerUiIndexHandler;
