"use strict";
/**
 * Copyright (c) 2018-2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var assembly_symmetry_1 = require("../../../../mol-model-props/rcsb/assembly-symmetry");
var data_source_1 = require("../../../../mol-util/data-source");
var graphql_client_1 = require("../../../../mol-util/graphql-client");
var util_1 = require("../../../common/util");
exports.RCSB_assemblySymmetry = function (_a) {
    var model = _a.model, params = _a.params;
    var url = getApiUrl(params, 'assembly_symmetry', "https:" + assembly_symmetry_1.AssemblySymmetry.GraphQLEndpointURL);
    var client = new graphql_client_1.GraphQLClient(url, data_source_1.ajaxGet);
    return assembly_symmetry_1.AssemblySymmetry.attachFromCifOrAPI(model, client);
};
function getApiUrl(params, name, fallback) {
    var path = util_1.getParam(params, 'RCSB', 'API', name);
    if (!path)
        return fallback;
    return path;
}
