/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
import { UUID } from '../../../mol-util';
import { QueryDefinition, QueryName, QueryParams } from './api';
export interface ResponseFormat {
    isBinary: boolean;
}
export interface Job {
    id: UUID;
    datetime_utc: string;
    sourceId: '_local_' | string;
    entryId: string;
    key: string;
    queryDefinition: QueryDefinition;
    normalizedParams: any;
    responseFormat: ResponseFormat;
    modelNums?: number[];
    outputFilename?: string;
}
export interface JobDefinition<Name extends QueryName> {
    sourceId?: string;
    entryId: string;
    queryName: Name;
    queryParams: QueryParams<Name>;
    options?: {
        modelNums?: number[];
        outputFilename?: string;
        binary?: boolean;
    };
}
export declare function createJob<Name extends QueryName>(definition: JobDefinition<Name>): Job;
declare class _JobQueue {
    private list;
    readonly size: number;
    add<Name extends QueryName>(definition: JobDefinition<Name>): UUID;
    hasNext(): boolean;
    getNext(): Job;
    /** Sort the job list by key = sourceId/entryId */
    sort(): void;
}
export declare const JobManager: _JobQueue;
export {};
