"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
Object.defineProperty(exports, "__esModule", { value: true });
var version_1 = require("../version");
var examples = [{
        name: 'Atoms',
        params: {
            id: '1cbs',
            name: 'atoms',
            params: { atom_site: { label_comp_id: 'ALA' } }
        }
    }, {
        name: 'Residue Interaction',
        params: {
            id: '1cbs',
            name: 'residueInteraction',
            params: {
                radius: 5,
                atom_site: { 'label_comp_id': 'REA' }
            }
        }
    }, {
        name: 'Full',
        params: {
            id: '1tqn',
            name: 'full'
        }
    }, {
        name: 'Full (binary)',
        params: {
            id: '1tqn',
            name: 'full',
            binary: true
        }
    }, {
        name: 'Full (specific models)',
        params: {
            id: '1grm',
            name: 'full',
            modelNums: [2, 3]
        }
    }];
function create() {
    return "<!DOCTYPE html>\n<html lang=\"en\">\n    <head>\n        <meta charset=\"utf-8\" />\n        <meta name=\"viewport\" content=\"width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0\">\n        <title>Mol* ModelServer " + version_1.default + "</title>\n        <link rel=\"stylesheet\" href=\"https://cdnjs.cloudflare.com/ajax/libs/skeleton/2.0.4/skeleton.min.css\" />\n    </head>\n    <body>\n        <h1>Mol* Model Server " + version_1.default + "</h1>\n        <select id='example'>\n            <option value='-1'>Select example...</option>\n            " + examples.map(function (e, i) { return "<option value=" + i + ">" + e.name + "</option>"; }) + "\n        </select>\n        <br/>\n        <textarea style=\"height: 280px; width: 600px; font-family: monospace\" id=\"query-text\"></textarea><br>\n        <button class=\"button button-primary\" style=\"width: 600px\" id=\"query\">Query</button>\n        <div id='error' style='color: red; font-weight: blue'></div>\n        <div>Static input files available as CIF and BinaryCIF at <a href='/ModelServer/static/cif/1cbs' target='_blank'>static/cif/id</a> and <a href='/ModelServer/static/bcif/1cbs' target='_blank'>static/bcif/id</a> respectively.</div>\n        <script>\n            var Examples = " + JSON.stringify(examples) + ";\n            var err = document.getElementById('error');\n            var exampleEl = document.getElementById('example'), queryTextEl = document.getElementById('query-text');\n            exampleEl.onchange = function () {\n                var i = +exampleEl.value;\n                if (i < 0) return;\n                queryTextEl.value = JSON.stringify(Examples[i].params, null, 2);\n            };\n            document.getElementById('query').onclick = function () {\n                err.innerText = '';\n                try {\n                    var q = JSON.parse(queryTextEl.value);\n                    var path = '/ModelServer/api/v1?' + encodeURIComponent(JSON.stringify(q));\n                    console.log(path);\n                    window.open(path, '_blank');\n                } catch (e) {\n                    err.innerText = '' + e;\n                }\n            };\n        </script>\n    </body>\n</html>";
}
exports.LandingPage = create();
