/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import * as argparse from 'argparse';
export declare function addLimitsArgs(parser: argparse.ArgumentParser): void;
export declare function addServerArgs(parser: argparse.ArgumentParser): void;
declare const DefaultServerConfig: {
    apiPrefix: string;
    defaultPort: number;
    shutdownTimeoutMinutes: number;
    shutdownTimeoutVarianceMinutes: number;
    idMap: [string, string][];
};
export declare type ServerConfig = typeof DefaultServerConfig;
export declare const ServerConfig: {
    apiPrefix: string;
    defaultPort: number;
    shutdownTimeoutMinutes: number;
    shutdownTimeoutVarianceMinutes: number;
    idMap: [string, string][];
};
export declare function setServerConfig(config: ServerConfig): void;
declare const DefaultLimitsConfig: {
    maxRequestBlockCount: number;
    maxFractionalBoxVolume: number;
    maxOutputSizeInVoxelCountByPrecisionLevel: number[];
};
export declare type LimitsConfig = typeof DefaultLimitsConfig;
export declare const LimitsConfig: {
    maxRequestBlockCount: number;
    maxFractionalBoxVolume: number;
    maxOutputSizeInVoxelCountByPrecisionLevel: number[];
};
export declare function setLimitsConfig(config: LimitsConfig): void;
export declare function setConfig(config: ServerConfig & LimitsConfig): void;
export {};
