"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = "\n#if defined(dColorType_uniform)\n    vec4 material = vec4(uColor, uAlpha);\n#elif defined(dColorType_attribute) || defined(dColorType_instance) || defined(dColorType_group) || defined(dColorType_groupInstance)\n    vec4 material = vec4(vColor.rgb, uAlpha);\n#elif defined(dColorType_objectPicking) || defined(dColorType_instancePicking) || defined(dColorType_groupPicking)\n    vec4 material = uPickable == 1 ? vColor : vec4(0.0, 0.0, 0.0, 1.0); // set to empty picking id\n#elif defined(dColorType_depth)\n    #ifdef enabledFragDepth\n        vec4 material = packDepthToRGBA(gl_FragDepthEXT);\n    #else\n        vec4 material = packDepthToRGBA(gl_FragCoord.z);\n    #endif\n#endif\n\n// mix material with overpaint\n#if defined(dOverpaint) && (defined(dColorType_uniform) || defined(dColorType_attribute) || defined(dColorType_instance) || defined(dColorType_group) || defined(dColorType_groupInstance))\n    material.rgb = mix(material.rgb, vOverpaint.rgb, vOverpaint.a);\n#endif\n\n// apply screendoor transparency\n#if defined(dTransparency) && (defined(dColorType_uniform) || defined(dColorType_attribute) || defined(dColorType_instance) || defined(dColorType_group) || defined(dColorType_groupInstance))\n    float ta = 1.0 - vTransparency;\n    float at = 0.0;\n\n    #if defined(dTransparencyVariant_single)\n        const mat4 thresholdMatrix = mat4(\n            1.0 / 17.0,  9.0 / 17.0,  3.0 / 17.0, 11.0 / 17.0,\n            13.0 / 17.0,  5.0 / 17.0, 15.0 / 17.0,  7.0 / 17.0,\n            4.0 / 17.0, 12.0 / 17.0,  2.0 / 17.0, 10.0 / 17.0,\n            16.0 / 17.0,  8.0 / 17.0, 14.0 / 17.0,  6.0 / 17.0\n        );\n        at = thresholdMatrix[int(intMod(gl_FragCoord.x, 4.0))][int(intMod(gl_FragCoord.y, 4.0))];\n    #elif defined(dTransparencyVariant_multi)\n        at = fract(dot(vec3(gl_FragCoord.xy, vGroup + 0.5), vec3(2.0, 7.0, 23.0) / 17.0f));\n    #endif\n\n    if (ta < 0.99 && (ta < 0.01 || ta < at)) discard;\n#endif\n";
